/*
    $Id: SCAliasNameTable.java,v 1.6 2003/10/27 13:16:21 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCAliasNameTable {
    Hashtable root; // ̒ɂGgHashtableA̒ɂVectorA̒Integer܂B
    
    public SCAliasNameTable() {
	root = new Hashtable();
    }
    
    public void load(File f) {
	// f : alias.txt
	// usakura.surface.aliasv̋LqǂŁAe[u쐬܂B
	if (!f.exists() || !f.isFile()) return;
	
	BufferedReader br = null;
        try {
            br = new BufferedReader(new InputStreamReader(new FileInputStream(f),"SJIS"));
        }
	catch (Exception e) {
	    return;
	}
        
        String line = null;
        while(true) {
            try{  line = br.readLine();  }catch(Exception e){}
            
            if (line == null) break;
	    line = line.trim();
	    if (line.length() == 0) continue; // ̍s̓XLbvB
	    if (line.startsWith("//")) continue; // Rgs
	    if (line.indexOf(',') != -1) continue; // J}܂񂾍s̓ubNwłȂ̂ŃXLbvB
	    
	    // āAlinerootɓׂGgɂȂĂB
	    // ̍s͊ʂ̎n܂łׂBłȂ΃e[u쐬͂ŋIB
	    // Gǵu.surface.aliasvŏIĂȂ΂ȂȂB
	    String entryname = line;
	    try{  line = br.readLine();  }catch(Exception e){}
	    if (line == null || !line.equals("{")) break;
	    // ̎̍s犇ʂ܂ŃubNf[^B
	    Hashtable current_table = null;
	    if (entryname.endsWith(".surface.alias")) {
		current_table = new Hashtable();
	    }
	    while(true) {
		try{  line = br.readLine();  }catch(Exception e){}

		if (line == null) break;
		line = line.trim();
		if (line.equals("}")) break; // ubNI
		if (current_table == null) continue;
		if (line.startsWith("//")) continue;
		if (line.indexOf(',') == -1) continue;
		
		int comma_pos = line.indexOf(',');
		String label = line.substring(0,comma_pos);
		String data = line.substring(comma_pos+1);
		// data[id,id,id,...]`Ȃ̂łoB
		
		data = data.substring(1,data.length() - 1); // O̊ʂB
		
		Vector array = new Vector();
		StringTokenizer st = new StringTokenizer(data,",");
		int n_tokens = st.countTokens();
		for (int i = 0;i < n_tokens;i++) {
		    array.add(new Integer(st.nextToken()));
		}
		
		// e[uɃZbg
		current_table.put(label,array);
	    }
	    
	    // [ge[uɃZbg
	    if (current_table != null) {
		root.put(entryname,current_table);
	    }
	}
	
	try{ br.close(); }catch(IOException e){}
    }
    
    public int lookup(String entry,String label) {
	// entry : sakura.surface.alias
	// label : angry
	// Yf[^-1Ԃ܂B
	Hashtable table = (Hashtable)root.get(entry);
	if (table == null) return -1;
	
	Vector array = (Vector)table.get(label);
	if (array == null) return -1;
	
	if (array.size() == 0) return -1;
	if (array.size() == 1) return ((Integer)array.elementAt(0)).intValue();
	
	int item_to_select = (int)Math.round(Math.random() * array.size());
	if (item_to_select == array.size()) item_to_select--;
	return ((Integer)array.elementAt(item_to_select)).intValue();
    }
}
