/*  $Id: SCBalloonTextView.java,v 1.11 2004/04/13 10:31:50 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

/*
    ̃NXɂāAȉ͂̕ꂼȈӖ܂B
    
    U+0001 : S
    U+0002 : halfs
    U+0003 : L[ɓo^ꂽTur[ǉ
    U+000a : ʏs
*/

public class SCBalloonTextView extends NSView {
    private static final NSRange FIRSTCHAR_RANGE = new NSRange(0,1);
    private static final int SHADOW_INTERVAL = 2;
    private static final int LINE_INTERVAL = 0;
    
    NSFont font;
    float fontHeight;
    NSColor mainColor,mainShadowColor;
    
    float x,y;
    NSImage offscreen;
    
    StringBuffer buffer;
    Vector subview_queue;

    SCBalloonScrollArrow arrow_up, arrow_down;
    
    public SCBalloonTextView(NSRect r) {
	super(r);
	
	buffer = new StringBuffer();
	subview_queue = new Vector();
	
	setFont(NSFont.systemFontOfSize(10.0f));
	setMainColor(NSColor.blackColor());
	setMainShadowColor(null);
	
	offscreen = new NSImage(new NSSize(10,10)); // łTCYݒ肵ĂȂlockFocus()oȂB
	//offscreen.setFlipped(true);
	beEmpty(); // ŐTCYɂB
    }
	
    public void initialize(SCBalloonScrollArrow arrow_up,SCBalloonScrollArrow arrow_down) {
	this.arrow_up = arrow_up;
	this.arrow_down = arrow_down;
    }

    public void close() {
	subview_queue.clear();
	arrow_up = null;
	arrow_down = null;
    }
    
    public void updateArrowsVisibilities() {
	// initialize()Ă΂Oɂ̃\bhĂ΂\B
	if (arrow_up != null) arrow_up.updateVisibility();
	if (arrow_down != null) arrow_down.updateVisibility();
    }
    
    public void addSubviewAtCurrentLoc(NSView view) {
	subview_queue.add(view);
	buffer.append('\u0003');
	display();
    }
    protected void addSubviewAtCurrentLoc() {
	NSView view = (NSView)subview_queue.elementAt(0);
	subview_queue.removeElementAt(0);
	
	NSRect view_frame = view.frame();
	float viewwidth = view_frame.width();
	float viewheight = view_frame.height();
	
	view.setFrame(new NSRect(x,y,viewwidth,viewheight));
	addSubview(view);
	x += viewwidth;
    }
    
    /*public boolean isFlipped() {
      return true;
      }*/
    
    public void changedSize() {
	// r[̂̂̃TCYύXKĂłB
	NSRect frame = superview().frame();
	setFrame(frame);
	offscreen.setSize(frame.size());
    }
    
    public void setFont(NSFont f) {
	font = f;
	fontHeight = Math.round(font.boundingRectForFont().height());
	//fontHeight = Math.round(font.ascender() - font.descender());
    }
    
    public NSFont getFont() {
	return font;
    }
    
    public void setMainColor(NSColor c) {
	mainColor = c;
    }
    
    public NSColor getMainColor() {
	return mainColor;
    }
    
    public void setMainShadowColor(NSColor c) {
	// nullȂe𗎂Ƃ܂B
	mainShadowColor = c;
    }

    public void waitUntilFlushed() {
	while (buffer.length() > 0) {
	    try {
		Thread.sleep(50);
	    } catch (Exception e) {}
	}
    }
    
    public void flushBuffer() {
	if (buffer.length() > 0) {
	    offscreen.lockFocus();
	    while (buffer.length() > 0) {
		char c = buffer.charAt(0);
		buffer.deleteCharAt(0);
		if (c == '\u0001') { // clear
		    // ̒display()flushBuffer()ɍē\鎖ɒ!
		    cleanUp();
		}
		else if (c == '\u0003') { // add subview
		    addSubviewAtCurrentLoc();
		}
		else {
		    drawChar(c);
		}
	    }
	    offscreen.unlockFocus();
	}
    }
    public void drawRect(NSRect r) {
	flushBuffer();
	offscreen.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);
    }
    public void drawImage(NSImage image, NSPoint point){
	// FIXME: 摜subviewɂǂƎvBłʓ|Ȃ̂Ō񂵁B
        image.compositeToPoint(point,NSImage.CompositeCopy);
        NSRect r = new NSRect(0,0,image.size().width(),image.size().height());
        offscreen.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);
        flushBuffer();
    }
    private void drawChar(char c) {
	NSMutableAttributedString astr = new NSMutableAttributedString(c+"");
	astr.addAttributeInRange(NSAttributedString.FontAttributeName,font,FIRSTCHAR_RANGE);
	NSMutableAttributedString shadowstr = new NSMutableAttributedString(astr); // copy
	
	astr.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,mainColor,FIRSTCHAR_RANGE);
        if (mainShadowColor != null) {
            shadowstr.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,mainShadowColor,FIRSTCHAR_RANGE);
        }
	
	float widthOfCurrentChar = NSGraphics.sizeOfAttributedString(astr).width();
	// słȂĂA̕`悵ƂŔ͈͂𒴂悤ȂsB
	if (c == '\n' || c == '\u0002' || x + widthOfCurrentChar > frame().width()) {
	    x = 0;
	    //y += (c == '\u0002' ? (float)Math.round(fontHeight / 2.0) : fontHeight) + LINE_INTERVAL + SHADOW_INTERVAL;
	    y -= (c == '\u0002' ? (float)Math.round(fontHeight / 2.0) : fontHeight) + LINE_INTERVAL + SHADOW_INTERVAL;
	    
	    float screen_height = offscreen.size().height();
	    //if (y > screen_height) // y˂jt[găXN[B
	    if (y < 0) {
		float deltaY = -1 * y;
		
		offscreen.unlockFocus();
		NSRect oldframe = frame();
		NSRect newframe = new NSRect(0,0,oldframe.width(),oldframe.height()+deltaY); // sg
		setFrame(newframe);
		offscreen.setSize(newframe.size());
		offscreen.lockFocus();
		
		updateArrowsVisibilities();
		
		// XN[͏Ɍĉт̂ŁÃ݂XN[̓eɉグB
		offscreen.compositeToPoint(new NSPoint(0,deltaY),NSImage.CompositeCopy);
		/*NSGraphics.copyBits(
		  0,
		  oldframe,
		  new NSPoint(0,deltaY)
		  );*/
		
		NSArray subviews = subviews();
		final int n_subviews = subviews.count();
		for (int i = 0;i < n_subviews;i++) {
		    NSView subview = (NSView)subviews.objectAtIndex(i);
		    NSRect subview_oldframe = subview.frame();
		    subview.setFrame(
			new NSRect(subview_oldframe.x(),subview_oldframe.y()+deltaY,subview_oldframe.width(),subview_oldframe.height()));
		}
		
		NSColor.clearColor().set();
		NSGraphics.fillRectList(new NSRect[] {new NSRect(0,0,newframe.width(),deltaY)});

		/*if (mainShadowColor == null) {
		    y = 0;
		}
		else {
		    y = SHADOW_INTERVAL;
		    }*/
		y = SHADOW_INTERVAL;
	    }
	}
	if (c != '\n' && c != '\u0002') {
	    if (mainShadowColor != null) { // nullȂe𗎂ƂȂB
		NSGraphics.drawAttributedString(shadowstr,new NSPoint(x+SHADOW_INTERVAL,y-SHADOW_INTERVAL));
	    }
	    NSGraphics.drawAttributedString(astr,new NSPoint(x,y));
	    x += widthOfCurrentChar;
	}
    }
    private void cleanUp()
    {
		// r[ƃItXN[̃TCYlɖ߂B
		offscreen.unlockFocus();
		NSRect frame = superview().frame();
		setFrame(frame);
		offscreen.setSize(frame.size());
		offscreen.lockFocus();
		
		updateArrowsVisibilities();
		
		NSColor.clearColor().set();
		NSGraphics.fillRectList(new NSRect[] {frame()});
		
		resetLocation();
    }
    
    public synchronized void addChar(char c)
    {
		buffer.append(c);
		//flushBuffer();
		//offscreen.lockFocus();
		//drawChar(c);
		//offscreen.unlockFocus();
		
		display();
    }
    
    public void beEmpty()
    {
		buffer.append('\u0001'); // ł̓oCgl1̓N[AbvӖB
		//flushBuffer();
		/*NSRect frame = superview().frame();
		setFrame(frame);
		offscreen.setSize(frame.size());
		
		offscreen.lockFocus();
		NSColor.clearColor().set();
		NSGraphics.fillRectList(new NSRect[] {frame()});
		offscreen.unlockFocus();
		
		updateArrowsVisibilities();
		
		resetLocation();*/
		
		display();
    }
    
    private void resetLocation()
    {
		x = 0;
		y = frame().height() - fontHeight;
		//y = 0;
    }
}
