/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
import java.lang.reflect.*;

public class SCESEvaluator
{
    SCEseShiori eseshiori;
    
    SCESVariableCommands varCommands;
    SCESSystemCommands sysCommands;
    SCESStringCommands strCommands;
    SCESCalculationCommands calcCommands;
    Hashtable dispatchTable;
    
    Vector pool; // Ēu^Op
    
    public SCESEvaluator(SCEseShiori eseshiori)
    {
	this.eseshiori = eseshiori;
	
	pool = new Vector();
	
	varCommands = new SCESVariableCommands(eseshiori);
	sysCommands = new SCESSystemCommands(eseshiori);
	strCommands = new SCESStringCommands(eseshiori);
	calcCommands = new SCESCalculationCommands(eseshiori);
	
	dispatchTable = new Hashtable();
	dispatchTable.put("PUSH",varCommands);
	dispatchTable.put("POP",varCommands);
	dispatchTable.put("MODE",sysCommands);
	dispatchTable.put("REMODE",sysCommands);
	dispatchTable.put("GETSENTRES",strCommands);
	dispatchTable.put("GETPOP",strCommands);
	dispatchTable.put("REFLECT",sysCommands);
	dispatchTable.put("GETGHOST",sysCommands);
	dispatchTable.put("RAND",calcCommands);
	dispatchTable.put("CALC",calcCommands);
	dispatchTable.put("TALK_INTERVAL",sysCommands);
	dispatchTable.put("TAGSEL_STYLE",sysCommands);
    }
    
    public String evaluate(String src)
    {
	try
	{
	    StringBuffer buf = new StringBuffer(src);
	    
	    /***** Ggu *****/
	    while (true)
	    {
		int pos = buf.toString().indexOf('%');
		if (pos == -1) break; // I
		
		// %̌ܕoB
		String per_arg = buf.substring(pos+1,pos+6);
		
		if (per_arg.startsWith("00")) // Ēu^O
		{
		    int index = Integer.parseInt(per_arg.substring(2));
		    if (index >= 900) // ʏ
		    {
			String from_replacement_area = eseshiori.getFromReplaceDataArea(index);
			if (from_replacement_area == null)
			{
			    buf.delete(pos,pos+6);
			}
			else
			{
			    buf.replace(pos,pos+6,evaluate(from_replacement_area));
			}
		    }
		    else
		    {
			String from_pool = (String)pool.elementAt(index);
			if (from_pool == null)
			{
			    buf.delete(pos,pos+6);
			}
			else
			{
			    buf.replace(pos,pos+6,evaluate(from_pool)); // Ēu
			}
		    }
		}
		else
		{
		    String from_dic = eseshiori.getDictionary().getAnyItem(per_arg);
		    
		    if (per_arg.charAt(0) == 's')
		    {
			// ̓GgȂ̂ōĒuv[NA
			pool.clear();
		    }
		    else
		    {
			pool.add(from_dic); // 炸ɋL^
		    }
		    
		    buf.replace(pos,pos+6,evaluate(from_dic)); // Ēu
		}
	    }
	    
	    /* ֐u */
	    while (true)
	    {
		int pos = buf.toString().indexOf('$');
		if (pos == -1) break; // I
		
		if (buf.charAt(pos+1) >= 'a' && buf.charAt(pos+1) <= 'z')
		{
		    // Ŏn܂֐͎SHIORIƂ͖֌WB
		    // Fuckin'ʏB
		    buf.replace(pos,pos+1,"&_dollar_");
		    continue;
		}
		
		int blockstart = buf.toString().indexOf('(',pos);
		int blockend = blockstart; // blockendT[`
		boolean in_quote = false;
		int nest_depth = 0;
		while (true)
		{
		    if (blockend >= buf.length())
		    {
			// \G[
			System.err.println("The EseShiori Clone : syntax error in script , missing \")\"");
			return "";
		    }
		    
		    char c = buf.charAt(blockend);
		    if (c == '(' && !in_quote)
		    {
			nest_depth++;
		    }
		    else if (c == ')' && !in_quote)
		    {
			nest_depth--;
			if (nest_depth == 0) break; // T[`I
		    }
		    else if (c == '\"')
		    {
			in_quote = !in_quote;
		    }
		    blockend++;
		}
		// blockstartblockendɂ͂ꂼ֐̊JʂƕʂĂB
		String func_name = buf.substring(pos+1,blockstart); // ֐̖O
		
		if (func_name.equals("IF"))
		{
		    if (judgement(buf.toString(),pos)) // F^
		    {
			// Ήŏ$ELSE,$ELSEIF,$ENDIFT
			int pos_delstartfunc = findelseendif(buf.toString(),blockend+1);
			int pos_delendfunc = -1;
			
			if (buf.toString().startsWith("$ELSE",pos_delstartfunc))
			{
			    // $ELSE,$ELSEIF̏ꍇ$ENDIFT
			    pos_delendfunc = findendif(buf.toString(),blockend+1);
			}
			
			if (pos_delstartfunc == -1)
			{
			    // $IF݂̂Ȃ̂ŏ͈͖B
			}
			else if (buf.toString().startsWith("$ENDIF",pos_delstartfunc))
			{
			    // $IF`$ENDIF^Cv$ENDIF
			    remove_function(buf,pos_delstartfunc);
			}
			else if (pos_delendfunc == -1)
			{
			    // $IF`$ELSE(IF)^Cv$ELSEŐ؂
			    buf.delete(pos_delstartfunc,buf.length());
			}
			else
			{
			    //$IF`$ELSE(IF)`$ENDIF^Cv$ELSE$ENDIF܂łBi$ENDIFȍ~͂̂܂܁j
			    remove_function(buf,pos_delendfunc); // $ENDIF
			    buf.delete(pos_delstartfunc,pos_delendfunc);
			}
		    }
		    else // FU
		    {
			// $ELSE,$ELSEIF,$ENDIFT
			boolean judge_true = false; // $ELSE$ELSEIFŏłctrueB
			int pos_nextelse;
			while ((pos_nextelse = findelseendif(buf.toString(),blockend+1)) != -1)
			{
			    if (buf.toString().startsWith("$ELSEIF",pos_nextelse))
			    {
				// $ELSEIF͈sB
				
				if (judgement(buf.toString(),pos_nextelse)) // F^
				{
				    judge_true = true;
				    
				    // Ήŏ$ELSE,$ELSEIF,$ENDIFT
				    int pos_delstartfunc = findelseendif(buf.toString(),pos_nextelse+1);
				    int pos_delendfunc = -1;
				    
				    if (buf.toString().startsWith("$ELSE",pos_delstartfunc))
				    {
					// $ELSE,$ELSEIF̏ꍇ$ENDIFT
					pos_delendfunc = findendif(buf.toString(),blockend+1);
				    }
				    
				    if (pos_delstartfunc == -1)
				    {
					// $ELSEIF݂̂Ȃ̂ŏ͈͖B
				    }
				    else if (buf.toString().startsWith("$ENDIF",pos_delstartfunc))
				    {
					// $ELSEIF`$ENDIF^Cv$ENDIF
					remove_function(buf,pos_delstartfunc);
				    }
				    else if (pos_delendfunc == -1)
				    {
					// $ELSEIF`$ELSE(IF)^Cv$ELSEŐ؂
					buf.delete(pos_delstartfunc,buf.length());
				    }
				    else
				    {
					// $ELSEIF`$ELSE(IF)`$ENDIF^Cv$ELSE`$ENDIF
					remove_function(buf,pos_delendfunc); // $ENDIF
					buf.delete(pos_delstartfunc,pos_delendfunc);
				    }
				}
				// $ELSEIF
				remove_function(buf,pos_nextelse);
				
				// $IF`Y$ELSEIF܂ł
				buf.delete(blockend+1,pos_nextelse);
			    }
			    else if (buf.toString().startsWith("$ELSE",pos_nextelse))
			    {
				judge_true = true;
				
				// $ELSȄꍇ$IF`$ELSEԂ$ENDIFB
				int pos_delendfunc = findendif(buf.toString(),pos_nextelse); // $ENDIF
				if (pos_delendfunc != -1) // $ENDIFΏ
				{
				    remove_function(buf,pos_delendfunc);
				}
				remove_function(buf,pos_nextelse); // $ELSE
				buf.delete(blockend+1,pos_nextelse); // $IF`$ELSE
			    }
			    else if (buf.toString().startsWith("$ENDIF",pos_nextelse))
			    {
				judge_true = true;
				
				// $ENDIF̏ꍇ$IF`$ENDIF͈̔͂
				remove_function(buf,pos_nextelse);
				buf.delete(blockend+1,pos_nextelse);
			    }
			}
			if (!judge_true)
			{
			    // SFALSEɂȂ$ELSEnȂ̂$IFȍ~Sď
			    buf.delete(blockend+1,buf.length());
			}
		    }
		    
		    // $IF
		    buf.delete(pos,blockend+1);
		}
		else // ʏ̊֐
		{
		    String arg = buf.substring(blockstart+1,blockend);
		    SCESArgumentsTokenizer at = new SCESArgumentsTokenizer(arg,",");
		    Vector args = new Vector();
		    while (at.hasMoreTokens())
		    {
			args.add(at.nextToken().trim());
		    }
		    
		    String result_of_func;
		    SCESCommands executer = (SCESCommands)dispatchTable.get(func_name);
		    if (executer != null) // ĂB
		    {
			try
			{
			    Method method = executer.getClass().getMethod(func_name,new Class[] {Vector.class});
			    result_of_func = (String)method.invoke(executer,new Object[] {args});
			}
			catch (Exception e)
			{
			    result_of_func = null;
			}
		    }
		    else
		    {
			result_of_func = null;
		    }
		    
		    buf.replace(pos,blockend+1,result_of_func == null ? "" : result_of_func);
		}
	    }
	    
	    /* I */
	    inline_selection(buf);
	    
	    return buf.toString();
	}
	catch (Exception e)
	{
	    System.err.println("The EseShiori Clone : exception occured in evaluating script");
	    e.printStackTrace();
	    return "";
	}
    }
    
    protected void inline_selection(StringBuffer buf)
    {
	while (true)
	{
	    int blockstart = buf.toString().indexOf('(');
	    if (blockstart == -1) break; // end
	    int blockend = buf.toString().indexOf(')',blockstart);
	    if (blockend == -1) break; // end (error)
	    
	    String world = buf.substring(blockstart+1,blockend);
	    StringTokenizer st_parts = new StringTokenizer(world,"|");
	    final int n_parts = st_parts.countTokens();
	    String[] parts = new String[n_parts];
	    int[] probs = new int[n_parts];
	    for (int i = 0;i < n_parts;i++)
	    {
		String part = (String)st_parts.nextToken();
		int colon_pos = part.indexOf(':');
		if (colon_pos != -1)
		{
		    try
		    {
			parts[i] = part.substring(0,colon_pos);
		   	probs[i] = Integer.parseInt(part.substring(colon_pos+1));
		    }
		    catch (NumberFormatException e)
		    {
			parts[i] = part;
			probs[i] = 1;
		    }
		}
		else
		{
		    parts[i] = part;
		    probs[i] = 1;
		}
	    }
	    // partsprobsɂꂼꐳƊmB
	    
	    int sum = 0;
	    for (int i = 0;i < n_parts;i++)
	    {
		sum += probs[i];
	    }
	    
	    final int randnum = (int)((Math.random() * Integer.MAX_VALUE) % sum);
	    int floor = 0;
	    String result = null;
	    for (int i = 0;i < n_parts;i++)
	    {
		if (floor <= randnum && floor + probs[i] > randnum)
		{
		    // Ɍ
		    result = parts[i];
		    break;
		}
		else
		{
		    floor += probs[i];
		}
	    }
	    
	    buf.replace(blockstart,blockend+1,result);
	}
    }
    
    protected boolean judgement(String str,int startpoint)
    {
	// strstartpoint猩ŏ()ň͂܂ꂽ͈͂ƂĔ肷B
	int blockstart = str.indexOf('(',startpoint);
	int blockend = blockstart; // blockendT[`
	boolean in_quote = false;
	int nest_depth = 0;
	while (true)
	{
	    if (blockend >= str.length())
	    {
		// \G[
		System.err.println("The EseShiori Clone : syntax error in script , missing \")\"");
		return false;
	    }
	    
	    char c = str.charAt(blockend);
	    if (c == '(' && !in_quote)
	    {
		nest_depth++;
	    }
	    else if (c == ')' && !in_quote)
	    {
		nest_depth--;
		if (nest_depth == 0) break; // T[`I
	    }
	    else if (c == '\"')
	    {
		in_quote = !in_quote;
	    }
	    blockend++;
	}
	// blockstartblockendɂ͂ꂼ֐̊JʂƕʂĂB
	
	return judgement(str.substring(blockstart+1,blockend));
    }
    
    protected boolean judgement(String condition)
    {
	// conditiońu"A" = "B"v̂悤ȕB
	// ^ȂtrueԂB
	try
	{
	    StringTokenizer st = new StringTokenizer(condition," ");
	    
	    StringBuffer leftbuf = new StringBuffer();
	    String ope = null;
	    while (true)
	    {
		if (!st.hasMoreTokens())
		{
		    System.err.println("The EseShiori Clone : operator not found in condition "+condition);
		    return false;
		}
		
		String token = st.nextToken();
		
		if (token.equals("=") || token.equals("==") ||
		    token.equals("<>") || token.equals("><") ||
		    token.equals("<") || token.equals(">") ||
		    token.equals("<=") || token.equals(">=") ||
		    token.equals("=<") || token.equals("=>"))
		{
		    ope = token;
		    break;
		}
		else
		{
		    leftbuf.append(token);
		}
	    }
	    
	    StringBuffer rightbuf = new StringBuffer();
	    while (st.hasMoreTokens())
	    {
		rightbuf.append(st.nextToken());
	    }
	    
	    String left = validateStringArgument(leftbuf.toString());
	    String right = validateStringArgument(rightbuf.toString());
	    
	    if (ope.equals("=") || ope.equals("=="))
	    {
		return left.equals(right);
	    }
	    else if (ope.equals("<>") || ope.equals("><"))
	    {
		return !left.equals(right);
	    }
	    else if (ope.equals("<"))
	    {
		try
		{
		    return Integer.parseInt(left) < Integer.parseInt(right);
		}
		catch (NumberFormatException e)
		{
		    return left.compareTo(right) < 0;
		}
	    }
	    else if (ope.equals("<=") || ope.equals("=<"))
	    {
		try
		{
		    return Integer.parseInt(left) <= Integer.parseInt(right);
		}
		catch (NumberFormatException e)
		{
		    return left.compareTo(right) <= 0;
		}
	    }
	    else if (ope.equals(">"))
	    {
		try
		{
		    return Integer.parseInt(left) > Integer.parseInt(right);
		}
		catch (NumberFormatException e)
		{
		    return left.compareTo(right) > 0;
		}
	    }
	    else if (ope.equals(">=") || ope.equals("=>"))
	    {
		try
		{
		    return Integer.parseInt(left) >= Integer.parseInt(right);
		}
		catch (NumberFormatException e)
		{
		    return left.compareTo(right) >= 0;
		}
	    }
	    else
	    {
		System.err.println("The EseShiori Clone : unsupported operator "+ope+" in condition");
		return false;
	    }
	}
	catch (Exception e)
	{
	    System.err.println("The EseShiori Clone : exception occured in evaluating condition "+condition);
	    e.printStackTrace();
	    return false;
	}
    }
    
    protected int findelseendif(String str,int startpoint)
    {
	int nest_depth = 0;
	final int len = str.length();
	for (int pos = startpoint;pos < len;pos++)
	{
	    if (str.charAt(pos) != '$') continue;
	    if (str.charAt(pos+1) != 'E' && str.charAt(pos+1) != 'I') continue;
	    
	    if (str.startsWith("$IF",pos))
	    {
		nest_depth++;
	    }
	    else if (str.startsWith("$ELSE",pos))
	    {
		if (nest_depth == 0) return pos;
	    }
	    else if (str.startsWith("$ENDIF",pos))
	    {
		if (nest_depth == 0)
		{
		    return pos;
		}
		else
		{
		    nest_depth--;
		}
	    }
	}
	return -1; // Ȃ
    }
    
    protected int findendif(String str,int startpoint)
    {
	int nest_depth = 0;
	final int len = str.length();
	for (int pos = startpoint;pos < len;pos++)
	{
	    if (str.charAt(pos) != '$') continue;
	    if (str.charAt(pos+1) != 'E' && str.charAt(pos+1) != 'I') continue;
	    
	    if (str.startsWith("$IF",pos))
	    {
		nest_depth++;
	    }
	    else if (str.startsWith("$ENDIF",pos))
	    {
		if (nest_depth == 0)
		{
		    return pos;
		}
		else
		{
		    nest_depth--;
		}
	    }
	}
	return -1; // Ȃ
    }
    
    protected void remove_function(StringBuffer buf,int startpoint)
    {
	int blockstart = buf.toString().indexOf('(',startpoint);
	int blockend = blockstart; // blockendT[`
	boolean in_quote = false;
	int nest_depth = 0;
	while (true)
	{
	    if (blockend >= buf.length())
	    {
		// \G[
		System.err.println("The EseShiori Clone : syntax error in script , missing \")\"");
		buf.setLength(0);
		return;
	    }
	    
	    char c = buf.charAt(blockend);
	    if (c == '(' && !in_quote)
	    {
		nest_depth++;
	    }
	    else if (c == ')' && !in_quote)
	    {
		nest_depth--;
		if (nest_depth == 0) break; // T[`I
	    }
	    else if (c == '\"')
	    {
		in_quote = !in_quote;
	    }
	    blockend++;
	}
	// blockstartblockendɂ͂ꂼ֐̊JʂƕʂĂ
	
	buf.delete(startpoint,blockend+1);
    }
    
    public String validateStringArgument(String s)
    {
	// _uNI[gň͂܂Ă΂OA
	// POPMODEgĂ炻]B
	StringBuffer result = new StringBuffer();
	StringTokenizer st = new StringTokenizer(s,"~");
	while (st.hasMoreTokens())
	{
	    String token = st.nextToken().trim();
	    if (token.charAt(0) == '\"' && token.charAt(token.length()-1) == '\"')
	    {
		result.append(token.substring(1,token.length()-1));
	    }
	    else if (token.startsWith("POP"))
	    {
		int blockstart = token.indexOf('(');
		int blockend = token.indexOf(')');
		if (blockstart == -1 || blockend == -1)
		{
		    System.err.println("The EseShiori Clone : illegal POP instruction , missing \"(\" or \")\".");
		    continue;
		}
		
		String arg = token.substring(blockstart+1,blockend);
		try
		{
		    String data = eseshiori.getFromUnivDataArea(Integer.parseInt(arg));
		    if (data != null) result.append(data);
		}
		catch (NumberFormatException e)
		{
		    System.err.println("The EseShiori Clone : illegal POP instruction , numeric argument is required but found "+arg);
		}
	    }
	    else if (token.startsWith("MODE"))
	    {
		result.append(eseshiori.getCurrentRandomSentenceMode());
	    }
	    else
	    {
		System.err.println("The EseShiori Clone : illegal string format -> "+token);
	    }
	}
	
	return result.toString();
    }
}
