/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCESIni
{
    File inifile;
    Hashtable root; // key : (String)section , content : (Hashtable)elements
    // elements - key : (String)key , content : (String)value
    
    public SCESIni(File inifile)
    {
	// inifile : eseai.ini
	// t@C݂ȂΏȗꂽ̂ƌ􂷁B
	this.inifile = inifile;
	root = new Hashtable();
	
	if (inifile.exists())
	{
	    try
	    {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(inifile),"SJIS"));
		Hashtable current_section = null;
		while (true)
		{
		    String line = br.readLine();
		    if (line == null) break; // eof
		    if (line.length() == 0) continue;
		    if (line.charAt(0) == ';') continue;
		    
		    if (line.charAt(0) == '[' && line.charAt(line.length()-1) == ']') // ZNVJn
		    {
			String section_name = line.substring(1,line.length()-1);
			current_section = new Hashtable();
			root.put(section_name,current_section);
		    }
		    
		    int equal_pos = line.indexOf('=');
		    if (equal_pos == -1) continue;
		    
		    String key = line.substring(0,equal_pos);
		    String value = (line.length() > equal_pos+1 ? line.substring(equal_pos+1) : ""); // lłꍇ
		    current_section.put(key,value);
		}
		br.close();
	    }
	    catch (Exception e)
	    {
		System.err.println("The EseShiori Clone : exception occured in loading eseai.ini.");
		e.printStackTrace();
	    }
	}
    }
    
    public int getRandomTalkInterval()
    {
	// ̒lȂ烉_g[N𔭐ȂB
	Hashtable eseai = (Hashtable)root.get("ESEAI");
	String str = (String)eseai.get("RANDOM_TALK_INTERVAL");
	if (str == null) return 70;
	
	try
	{
	    return Integer.parseInt(str);
	}
	catch (NumberFormatException e)
	{
	    return 70;
	}
    }
    
    public void setRandomTalkInterval(int n)
    {
	// ̒lȂ烉_g[N𔭐ȂB
	// ݒƓɃt@CɕۑB
	Hashtable eseai = (Hashtable)root.get("ESEAI");
	eseai.put("RANDOM_TALK_INTERVAL",Integer.toString(n));
	
	synchronize();
    }
    
    public void synchronize()
    {
	try
	{
	    if (inifile.exists()) inifile.delete();
	    OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(inifile),"SJIS");
	    
	    for (Enumeration section_names = root.keys();section_names.hasMoreElements();)
	    {
		String section_name = (String)section_names.nextElement();
		String secname_line = "["+section_name+"]\r\n";
		osw.write(secname_line,0,secname_line.length());
		
		Hashtable elements = (Hashtable)root.get(section_name);
		for (Enumeration element_keys = elements.keys();element_keys.hasMoreElements();)
		{
		    String elem_name = (String)element_keys.nextElement();
		    String elem_line = elem_name+'='+(String)elements.get(elem_name)+"\r\n";
		    osw.write(elem_line,0,elem_line.length());
		}
	    }
	    
	    osw.flush();
	    osw.close();
	}
	catch (Exception e)
	{
	    System.err.println("The EseShiori Clone : couldn\'t save to eseai.ini.");
	    e.printStackTrace();
	}
    }
}
