/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCESNormalEntry
{
    public static final int RANDOM_MODE = 1;
    public static final int SEQUENTIAL_MODE = 2;
    
    Vector items; // content : (SCESItem)
    int pos = 0; // [h[h̎Aɓǂݍލ
    int mode = RANDOM_MODE;
    
    public SCESNormalEntry()
    {
	items = new Vector();
    }
    
    public void add(SCESItem item)
    {
	items.add(item);
    }
    
    public void add(int prob,String data)
    {
	items.add(new SCESItem(prob,data));
    }
    
    public String getNextItem()
    {
	// _o[hł͊ml_ɁA
	// V[PVo[hł͎̍ڂԂ܂B
	
	if (mode == RANDOM_MODE)
	{
	    // eڂ̊mIB
	    // ܂͍vl߂
	    final int n_items = items.size();
	    if (n_items == 0) return null;
	    
	    int sum = 0;
	    for (int i = 0;i < n_items;i++)
	    {
		sum += ((SCESItem)items.elementAt(i)).getProb();
	    }
	    
	    final int randnum = (int)((Math.random() * Integer.MAX_VALUE) % sum);
	    int floor = 0;
	    for (int i = 0;i < n_items;i++)
	    {
		SCESItem item = (SCESItem)items.elementAt(i);
		if (floor <= randnum && floor + item.getProb() > randnum)
		{
		    // Ɍ
		    return item.getData();
		}
		else
		{
		    floor += item.getProb();
		}
	    }
	    return null; // ɗ邱Ƃ͂肦ȂB
	}
	else // SEQUENTIAL_MODE
	{
	    if (pos >= items.size()) pos = 0; // ߂
	    SCESItem item = (SCESItem)items.elementAt(pos);
	    pos++;
	    return item.getData();
	}
    }
    
    public void setMode(int n)
    {
	mode = n;
    }
    
    public void setPos(int n)
    {
	pos = n;
    }
}
