/*
	$Id: SCGhostPreviewView.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;

public class SCGhostPreviewView extends NSView
{
    NSImage background;
    NSImage sakura,kero;
    boolean is_empty; // ʏAsakurakeronull̏ꍇ͂̎|uvƂĕ񍐂邪Aꂪtrue̎́uIvƉ߂B
    NSFont messageFont;
    NSColor messageColor;
    NSColor messageBGColor;
    
    public SCGhostPreviewView(NSRect r)
    {
		super(r);
		
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		String bgimage_path = (String)defaults.objectForKey("display.ghostmanager.preview.filepath");
		if (bgimage_path == null) bgimage_path = "/Library/Desktop Pictures/Aqua Blue.jpg";
		background = new NSImage(bgimage_path,true);
		background.setScalesWhenResized(false);
		sakura = kero = null;
		is_empty = true;
		messageFont = NSFont.systemFontOfSize(10.0f);
		messageColor = NSColor.blackColor();
		messageBGColor = NSColor.colorWithCalibratedWhite(1.0f,0.5f);
    }
    
    public void setImage(File shell_dir)
    {
		// shell_dir : VFfBNgB
		// \s[0]\s[10]ǂŕ\B
		// Ăꍇ͂̎|\B
		is_empty = false;
		
		if (!shell_dir.exists())
		{
			sakura = kero = null;
			display();
			return;
		}
	
		// surface${id}ŃGCAXf[^x[X猟A΂AȂsurface${id}.pngt@C[hB
		SCAliasManager aliasFileNameTable = new SCAliasManager(new File(shell_dir,"alias.txt"));
		String surfaceName;
		File pngFile;
		surfaceName = aliasFileNameTable.resolveAlias("surface0");
		pngFile = new File(shell_dir,surfaceName+".png");
		if (pngFile.exists())
		{
			setImage(pngFile,SCFoundation.SAKURA);
		}
		else
		{
			pngFile = SCSurfaceServer.findSurfacePngFile(shell_dir,0);
			if (pngFile != null)
			{
				setImage(pngFile,SCFoundation.SAKURA);
			}
			else
			{
				sakura = null;
			}
		}
		surfaceName = aliasFileNameTable.resolveAlias("surface10");
		pngFile = new File(shell_dir,surfaceName+".png");
		if (pngFile.exists())
		{
			setImage(pngFile,SCFoundation.KERO);
		}
		else
		{
			pngFile = SCSurfaceServer.findSurfacePngFile(shell_dir,10);
			if (pngFile != null)
			{
				setImage(pngFile,SCFoundation.KERO);
			}
			else
			{
				kero = null;
			}
		}
		
		display();
    }
    
    public void setEmpty()
    {
		sakura = kero = null; // GC! JČꋋ!
		is_empty = true;
		
		display();
    }
    
    public void setImage(File pngFile,int type)
    {
		// type : SCFoundation.SAKURA/KERO
		
		// png[hč̍WŐFBɃAt@`lB
		NSImage image = SCAlphaConverter.convertImage(new NSImage(pngFile.getPath(),true));
		
		// pna݂邩H
		File pnaFile = new File(SCFileUtils.stringByDeletingExtension(pngFile.getPath()) + ".pna");
		if (pnaFile.exists())
		{
			// pna[hăAt@`lɃRs[
			NSImage pna = new NSImage(pnaFile.getPath(),true);
			SCAlphaConverter.attachAlphaToImage(pna,image);
		}
		
		image.setScalesWhenResized(false);
		
		if (type == SCFoundation.SAKURA)
		{
			sakura = image;
		}
		else
		{
			kero = image;
		}
    }
    
    public void drawRect(NSRect r)
    {
		final float widthOfView = (int)frame().size().width();
		final float heightOfView = (int)frame().size().height();
		
		// cۂ܂ܔwi摜g/kB
		// ĉǂ炩View̏c܂͉ƍĂΗǂB
		// wi摜͏ViewŜ𕢂B
		float ratio;
		float widthOfBG,heightOfBG;
		final float orig_widthOfBG = background.size().width();
		final float orig_heightOfBG = background.size().height();
		// ܂͉킹B
		ratio = widthOfView / orig_widthOfBG;
		widthOfBG = (int)(orig_widthOfBG * ratio);
		heightOfBG = (int)(orig_heightOfBG * ratio);
		if (heightOfBG < heightOfView) // cȂ
		{
			ratio = heightOfView / orig_heightOfBG;
			widthOfBG = (int)(orig_widthOfBG * ratio);
			heightOfBG = (int)(orig_heightOfBG * ratio);
		}
		NSSize newSize = new NSSize(widthOfBG,heightOfBG);
		if (ratio > 1.0) background.setSize(newSize);
		NSImageRep rep = (NSImageRep)background.representations().objectAtIndex(0);
		rep.setSize(newSize);
	
		// Eɍ킹ĕ`悷B
		NSRect rectToComposite = new NSRect(widthOfBG - widthOfView,0,widthOfView,heightOfView);
		background.compositeToPointFromRect(NSPoint.ZeroPoint,rectToComposite,NSImage.CompositeCopy);
		
		if (!is_empty)
		{
			/*
			\s[0]\s[10]ꍇFuMissing surface id 0.vƕ\
			\s[0]\s[10]ꍇFuMissing surface id 10.vƕ\
			ꍇuMissing surface both of id 0 and id 10.vƕ\
			*/
			String message = null;
			if (sakura == null && kero != null)
			{
				message = "Missing surface id 0.";
			}
			else if (sakura != null && kero == null)
			{
				message = "Missing surface id 10.";
			}
			else if (sakura == null && kero == null)
			{
				message = "Missing surface both of id 0 and id 10.";
			}
			if (message != null)
			{
				NSRange wholeRange = new NSRange(0,message.length());
				NSMutableAttributedString astr = new NSMutableAttributedString(message);
				astr.addAttributeInRange(NSAttributedString.FontAttributeName,messageFont,wholeRange);
				astr.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,messageColor,wholeRange);
				NSSize sizeOfMessage = NSGraphics.sizeOfAttributedString(astr);
				
				NSSize messageAreaSize = new NSSize(sizeOfMessage.width() + 6,sizeOfMessage.height() + 4);
				NSRect messageAreaRect = new NSRect(3,heightOfView - 3 - messageAreaSize.height(),messageAreaSize.width(),messageAreaSize.height());
				messageBGColor.set();
				NSBezierPath.fillRect(messageAreaRect);
				
				NSGraphics.drawAttributedString(astr,new NSPoint(messageAreaRect.x() + 3,messageAreaRect.y() + 2));
				return; // ȍ~̏͂ǂ炩łĂƔɖʓ|B̂āB
			}
			
			/*
			sakura.width + kero.widthʓɎ܂܂ŏcŒŏk邪A
			̎_sakura.heightkero.heightʓɎ܂ĂȂ
			̑傫ɉʓɎ܂悤ɏkB
			*/
			double shell_ratio;
			float widthOfSakura,heightOfSakura,widthOfKero,heightOfKero;
			final float orig_widthOfSakura = sakura.size().width();
			final float orig_heightOfSakura = sakura.size().height();
			final float orig_widthOfKero = kero.size().width();
			final float orig_heightOfKero = kero.size().height();
			// ܂͉ɍ킹
			shell_ratio = widthOfView / (orig_widthOfSakura + orig_widthOfKero);
			widthOfSakura = (int)(orig_widthOfSakura * shell_ratio);
			heightOfSakura = (int)(orig_heightOfSakura * shell_ratio);
			widthOfKero = (int)(orig_widthOfKero * shell_ratio);
			heightOfKero = (int)(orig_heightOfKero * shell_ratio);
			if (heightOfSakura > heightOfView || heightOfKero > heightOfView) // c͂ݏoĂ
			{
				float base_height = (orig_heightOfSakura > orig_heightOfKero ? orig_heightOfSakura : orig_heightOfKero); // ƂȂ鍂
				shell_ratio = heightOfView / base_height;
				widthOfSakura = (int)(orig_widthOfSakura * shell_ratio);
				heightOfSakura = (int)(orig_heightOfSakura * shell_ratio);
				widthOfKero = (int)(orig_widthOfKero * shell_ratio);
				heightOfKero = (int)(orig_heightOfKero * shell_ratio);
			}
			NSSize newShellSize;
			// sakura
			newShellSize = new NSSize(widthOfSakura,heightOfSakura);
			if (shell_ratio > 1.0) sakura.setSize(newShellSize);
			((NSImageRep)sakura.representations().objectAtIndex(0)).setSize(newShellSize);
			// kero
			newShellSize = new NSSize(widthOfKero,heightOfKero);
			if (shell_ratio > 1.0) kero.setSize(newShellSize);
			((NSImageRep)kero.representations().objectAtIndex(0)).setSize(newShellSize);
			
			sakura.compositeToPoint(NSPoint.ZeroPoint,NSImage.CompositeSourceOver);
			kero.compositeToPoint(new NSPoint(widthOfSakura,0),NSImage.CompositeSourceOver);
		}
    }
}
