/*
	$Id: SCHLSensorPlugin.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.lang.reflect.*;
import java.io.*;
import java.util.*;

public class SCHLSensorPlugin extends SCPlugin
{
    Method methodRequest;
    Object instance;
    
    public SCHLSensorPlugin(Class plugin,String type,String name,File plugin_root)
    {
		super(plugin,type,name,plugin_root);
		
		try
		{
			methodRequest = plugin.getMethod("request",new Class[] {InputStream.class});
			
			Constructor con = plugin.getConstructor(new Class[] {File.class});
			instance = con.newInstance(new Object[] {plugin_root});
		}
		catch (NoSuchMethodException e)
		{
			System.err.println("SCHLSensorPlugin : Class "+plugin.getName()+" doesn\'t have required method request().");
			e.printStackTrace();
		}
		catch (Exception e)
		{
			System.err.println("SCHLSensorPlugin : An exception has occured in accesing class "+plugin.getName()+".");
			e.printStackTrace();
		}
    }
    
    public SCHLSensorResponse request(String req)
    {
		try
		{
			return request(new ByteArrayInputStream(req.getBytes("UTF-8")));
		}
		catch (Exception e)
		{
			return null;
		}
    }
    
    public SCHLSensorResponse request(InputStream req)
    {
		try
		{
			InputStream resp = (InputStream)methodRequest.invoke(instance,new Object[] {req});
			
			BufferedReader br = new BufferedReader(new InputStreamReader(resp,"UTF-8"));
			
			String header = br.readLine();
			
			Hashtable hash = new Hashtable();
			String line = null;
			while (true)
			{
				line = br.readLine();
				if (line == null || line.length() == 0) break;
				if (line.indexOf(':') == -1) continue;
				
				String label = line.substring(0,line.indexOf(':'));
				String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
				
				hash.put(label,data);
			}
			
			StringBuffer content = new StringBuffer();
			char[] buf = new char[256];
			while (true)
			{
				int count = br.read(buf,0,256);
				if (count == -1) break;
				
				content.append(buf,0,count);
			}
	    
			br.close();
			
			return new SCHLSensorResponse(header,hash,content.toString());
		}
		catch (Exception e)
		{
			return null;
		}
    }
}
