/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.net.*;
import java.util.*;

public class SCHTTPSession
{
    URL url;
    Socket s;
    InputStream is;
    String statusString;
    Hashtable headers;
    int statusCode;
    int timeout = 0;
    
    public SCHTTPSession(URL url)
    {
	this.url = url;
	headers = new Hashtable();
    }
    
    public void connect() throws UnknownHostException,IOException,InterruptedIOException,SocketException
    {
	// ڑ
	s = new Socket(url.getHost(),url.getPort() == -1 ? 80 : url.getPort());
	s.setSoTimeout(timeout);
	
	// Xg[M̏
	is = s.getInputStream();
	OutputStream os = s.getOutputStream();
	OutputStreamWriter osw = new OutputStreamWriter(os);
	
	// GETM
	String path = (url.getQuery() == null || url.getQuery().length() == 0 ? url.getPath() : url.getPath()+'?'+url.getQuery());
	StringBuffer req = new StringBuffer("GET "+path+" HTTP/1.1\r\n");
	req.append("Host: "+url.getHost()+"\r\n");
	req.append("User-Agent: "+SCFoundation.getVersion()+"\r\n");
	req.append("Connection: close\r\n");
	req.append("\r\n");
	osw.write(req.toString(),0,req.length());
	osw.flush();
	
	// Xe[^XR[hǂ
	statusString = readLine();
	StringTokenizer statusCodeTokens = new StringTokenizer(statusString," ");
	statusCodeTokens.nextToken(); // ̂āBHTTP/*.*
	try
	{
	    statusCode = Integer.parseInt(statusCodeTokens.nextToken());
	}
	catch (NumberFormatException e)
	{
	    throw new IOException();
	}
	
	// wb_ǂ
	while (true)
	{
	    String line = readLine();
	    if (line == null || line.length() == 0) break; // I
	    
	    int colon_pos = line.indexOf(':');
	    String key = line.substring(0,colon_pos).trim();
	    String value = line.substring(colon_pos+1).trim();
	    headers.put(key,value);
	}
	
	// wb_ǂݍލۂɊɃwb_̎̋s܂œǂł܂Ă̂ŁA
	// ̌Xg[ǂݏof[^͕ԂꂽRegƂȂ܂B
    }
    
    private String readLine() throws IOException
    {
	StringBuffer buf = new StringBuffer();
	while (true)
	{
	    int b = is.read();
	    if (b == -1) // end
	    {
		break;
	    }
	    else if (b == 0x0d) // CR
	    {
		is.read(); // LFB
		break;
	    }
	    else
	    {
		buf.append((char)b);
	    }
	}
	return buf.toString();
    }
    
    public void disconnect() throws IOException
    {
	s.close();
    }
    
    public void setSoTimeout(int timeout) throws SocketException
    {
	this.timeout = timeout;
	if (s != null)
	{
	    s.setSoTimeout(timeout);
	}
    }
    
    public InputStream getInputStream()
    {
	return is;
    }
    
    public String getStatusString()
    {
	return statusString;
    }
    
    public int getStatusCode()
    {
	return statusCode;
    }
    
    public String getHeader(String key)
    {
	return (String)headers.get(key);
    }
}
