/*  $Id: SCInstaller.java,v 1.9 2005/04/24 08:03:02 phonohawk Exp $

    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.zip.*;
import java.util.*;
import java.io.*;

/*
    %lastghostname%lastobjectnameAt@Cj󂷂鋰̂ŁA
    ̃Xbh͌ēȏ㓯ɑ点ȂłB
*/

public class SCInstaller extends Thread {
    private static String LAST_GHOST_NAME;
    private static String LAST_OBJECT_NAME;
    
    String fpath;
    SCSession target;
    boolean deleteAfterSuccess;

    SCStatusWindowController stat;
    ZipFile zf;
    ZipEntry manifest_ent;
    int garbageCharsOfPath = -1; // install.txtւǂ蒅܂ł̃pX̒
    SCDescription install_txt;
    Hashtable chmod_table;
    
    String destdir_path_from_home;
    File destdir;
    String destdir_balloon_path_from_home;
    File destdir_balloon;
    
    public SCInstaller(String fpath) {
	this.fpath = fpath;
	this.target = null;
	this.deleteAfterSuccess = false;
    }
    
    public SCInstaller(String fpath,SCSession target) {
	// targetnull̏ꍇA
	// [1] supplementłȂ΋ÑZbV̂ǂꂩ^[Qbgɐݒ肵āA
	//     NĂȂCXg[Cxg𔭍sɖقăCXg[s܂B
	// [2] supplement炻̃A[JCuw肷ZbV^[Qbgɐݒ肵āA
	//     NĂȂ΃G[oďI܂B
	this.fpath = fpath;
	this.target = target;
	this.deleteAfterSuccess = false;
    }
    
    public SCInstaller(String fpath,SCSession target,boolean deleteAfterSuccess) {
	this.fpath = fpath;
	this.target = target;
	this.deleteAfterSuccess = deleteAfterSuccess;
    }

    private ZipEntry find_manifest() throws Exception {
	// install.txtGgTB
	// A[JCũ[g猩čł󂢈ʒuɂt@CgpB
	Enumeration entries = zf.entries();
	while (entries.hasMoreElements()) {
	    ZipEntry ent = (ZipEntry)entries.nextElement();
	    if (ent.getName().endsWith("/install.txt") || ent.getName().equals("install.txt")) {
		int temp_garbage = ent.getName().indexOf("install.txt");
		
		if (garbageCharsOfPath == -1 || temp_garbage < garbageCharsOfPath) {
		    manifest_ent = ent;
		    garbageCharsOfPath = temp_garbage;
		}
	    }
	}
	
        if (manifest_ent == null) {
	    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.descriptionNotFound");
	    stat.texttype_print("install.txt : %[color,yellow]*** NONE ***%[color,default]\n");
	    
	    throw new Exception(errorString);
        }
	else {
	    stat.texttype_println("install.txt : %[color,orange]"+manifest_ent.getName()+"%[color,default]");

	    return manifest_ent;
	}
    }

    private boolean safe_path_p(String path) {
	// ...A../foołfalse
	return !(
	    path.equals(".") || path.equals("..") || path.startsWith("./") ||
	    path.indexOf("../") != -1 || path.indexOf("/..") != -1);
    }

    private void sanity_check() throws Exception {
	// typesaoripluginłȂ̂safe_path_p(directory)falseȂG[
	String type = install_txt.getStrValue("type");
	String directory = install_txt.getStrValue("directory");
	
	if (!type.equals("saori") && !type.equals("plugin") && !safe_path_p(directory)) {
	    throw new Exception(
		"Security Error: bad directory for this type");
	}

	// typemF
	stat.texttype_println("type : %[color,orange]"+type+"%[color,default]");
        if (!type.equals("shell") && !type.equals("ghost") && !type.equals("balloon") &&
	    !type.equals("plugin") && !type.equals("supplement") && !type.equals("saori")) {

	    throw new Exception(
		SCErrorStringServer.getErrorMessage(
		    "foundation.installer.undefinedType",new String[] {type}));
        }

	// safe_path_p(balloon.directory)falseȂG[
	String balloon_dir = install_txt.getStrValue("balloon.directory");
	if (balloon_dir != null && !safe_path_p(balloon_dir)) {
	    throw new Exception(
		"Security Error: balloon.directory is illegal");
	}
    }

    private void make_chmod_table() throws Exception {
	// foo=755:bar=400:baz=666:saitama/taiyou=700
	String permission = install_txt.getStrValue("permission");
	
	chmod_table = new Hashtable();
	if (permission != null) {
	    try {
		StringTokenizer st = new StringTokenizer(permission,":");
		while (st.hasMoreTokens()) {
		    String file = st.nextToken();
		    
		    int equalpos = file.indexOf('=');
		    if (equalpos == -1) {
			throw new Exception("Illegal permission; '=' not found: "+file);
		    }
		    
		    try {
			String fpath = file.substring(0,equalpos).trim();
			int mode = Integer.parseInt(file.substring(equalpos+1).trim(),8);
			
			chmod_table.put(fpath,new Integer(mode));
		    }
		    catch (Exception ex) {
			throw new Exception("Illegal permission; "+ex.toString()+"; "+file);
		    }
		}
	    }
	    catch (Exception e) {
		stat.texttype_println("%[color,red]"+e.getMessage()+"%[color,default]");
		
		throw new Exception("");
	    }
	}
    }

    public void check_target() throws Exception {
	String type = install_txt.getStrValue("type");
	String name = install_txt.getStrValue("name");
	String directory = install_txt.getStrValue("directory");
	String accept = install_txt.getStrValue("accept");
	
	if (target == null) {
	    if (!type.equals("supplement") && !type.equals("shell")) {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("directory : %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = name;
		
		target = SCFoundation.sharedFoundation().getSession();
	    }
	    else {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("accept : %[color,yellow]"+accept+"%[color,default]");
		if (type.equals("shell")) stat.texttype_println("directory: %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = accept;
		LAST_OBJECT_NAME = name;
		
		target = SCFoundation.sharedFoundation().getSession(accept,false);
		if (target == null) { // acceptwZbVNĂȂ
		    String errorString = SCErrorStringServer.getErrorMessage(
			"foundation.installer.supplementTargetNotBooted", new String[] {accept});
		    stat.texttype_println("%[color,red]"+errorString+"%[color,default]");
		    
		    throw new Exception("");
		}
	    }
	}
	else {
	    if (!type.equals("supplement")) {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("directory : %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = name;
	    }
	    else {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("accept : %[color,yellow]"+accept+"%[color,default]");
		if (type.equals("shell")) stat.texttype_println("directory: %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = accept;
		LAST_OBJECT_NAME = name;
	    }
	    
	    if ((type.equals("supplement") || type.equals("shell")) && !target.getMasterSpirit().getSelfName().equals(accept)) {
		String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.supplementRefused",new String[] {accept});
		stat.texttype_println("%[color,red]"+errorString+"%[color,default]");
		
		throw new Exception("");
	    }
	}
    }

    private void make_dest_dir() {
	String type = install_txt.getStrValue("type");
	String directory = install_txt.getStrValue("directory");
	String balloon_directory = install_txt.getStrValue("balloon.directory");
	String balloon_source_directory = install_txt.getStrValue("balloon.source.directory");
	
	if (type.equals("supplement")) {
	    destdir_path_from_home = target.getGhostPath();
	    destdir = new File(SCFoundation.getParentDirOfBundle(),destdir_path_from_home);
	    stat.texttype_println("destination : %[color,orange]"+destdir_path_from_home+"%[color,default]");
	}
	else if (type.equals("shell")) {
	    // w肳ꂽOŃfBNgB
	    destdir_path_from_home = target.getGhostPath()+"/shell/"+directory; // homen܂fBNgւ̃pXB
	    destdir = new File(SCFoundation.getParentDirOfBundle(),destdir_path_from_home);
	    
	    stat.texttype_println("directory %[color,orange]"+destdir_path_from_home+"%[color,default] exists : %[color,white]"+(destdir.exists() ? "YES" : "NO")+"%[color,default]");
	    destdir.mkdir();
	    stat.texttype_println("%[color,white]created "+destdir_path_from_home+"%[color,default]");
	}
	else {
	    // w肳ꂽOŃfBNgB
	    destdir_path_from_home = "home/"+type+"/"+directory; // homen܂fBNgւ̃pXB
	    destdir = new File(SCFoundation.getParentDirOfBundle(),destdir_path_from_home);
	    
	    stat.texttype_println("directory %[color,orange]"+destdir_path_from_home+"%[color,default] exists : %[color,white]"+(destdir.exists() ? "YES" : "NO")+"%[color,default]");
	    destdir.mkdir();
	    stat.texttype_println("%[color,white]created "+destdir_path_from_home+"%[color,default]");
	}

	// with balloon
	File balloon_root = new File(SCFoundation.getParentDirOfBundle(),"home/balloon");
	if (balloon_directory != null) {
	    destdir_balloon_path_from_home = "home/balloon/"+balloon_directory;
	    destdir_balloon = new File(SCFoundation.getParentDirOfBundle(),"home/balloon/"+balloon_directory);
	    
	    stat.texttype_println("%[color,white]\"with balloon\" directory : "+balloon_directory);
	    stat.texttype_println(
		"\"with balloon\" directory "+destdir_balloon_path_from_home+
		" exists : "+(
		    destdir_balloon.exists() ? "%[color,orange]YES%[color,white]" : "NO"
		    )+"%[color,default]");
	    if (!destdir_balloon.exists()) {
		destdir_balloon.mkdir();
		stat.texttype_println("%[color,white]created "+destdir_balloon_path_from_home+"%[color,default]");
	    }
	    if (balloon_source_directory != null) {
		stat.texttype_println(
		    "%[color,white]\"with balloon\" source directory : "+
		    balloon_source_directory+"%[color,default]");
	    }
	}
	else {
	    destdir_balloon_path_from_home = null;
	}
    }

    private void refresh_if_needed() {
	refresh_if_needed("", destdir_path_from_home, destdir);
	refresh_if_needed("balloon.", destdir_balloon_path_from_home, destdir_balloon);
    }
    private void refresh_if_needed(String prefix, String dirpath_from_home, File dir) {
	String refresh_str = install_txt.getStrValue(prefix + "refresh");
	String mask_str = install_txt.getStrValue(prefix + "refreshundeletemask");

	boolean refresh = refresh_str != null &&
	    (refresh_str.equals("1") || refresh_str.equals("true"));
	
	stat.texttype_println(prefix+"refresh : "+(refresh ? "%[color,yellow]YES%[color,default]" : "NO"));
	if (refresh) {
	    if (mask_str == null) {
		SCFileUtils.deleteRecursively(dir); // S
	    }
	    else {
		// RŃZp[gĂ̂łVector<String>ɂB
		StringTokenizer st = new StringTokenizer(mask_str, ":");
		Vector mask = new Vector();
		while (st.hasMoreTokens()) {
		    mask.add(st.nextToken());
		}
		SCFileUtils.deleteRecursively(dir, mask);
	    }
	    dir.mkdir();
	    stat.texttype_println("%[color,yellow]refreshed : "+dirpath_from_home+"%[color,default]");
	}
    }

    private void do_install() throws Exception {
	String balloon_directory = install_txt.getStrValue("balloon.directory");
	String balloon_source_directory = install_txt.getStrValue("balloon.source.directory");
	if (balloon_source_directory == null) {
	    // sourcew肳ĂȂ̂destƓOɁB
	    balloon_source_directory = balloon_directory;
	}
	
	final int n_entries = zf.size();
	SCStatusWindowController prog = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	prog.setTypeToProgressBar();
	prog.show();
	prog.pbartype_setText1("Extracting archive...");
	
	int installedItemsCount = 0;
	int current_entry_index = -1;
        for ( Enumeration e = zf.entries() ; e.hasMoreElements() ; ) {
	    current_entry_index++;
	    prog.pbartype_setVal((double)current_entry_index / (double)n_entries);
	    
            ZipEntry curEnt = (ZipEntry)e.nextElement();
            
            // Ggɍ쐬t@C/fBNg̃pX߂B
            File pathToDest = null;
	    String valid_name = null;
            try {
		// R[hSJISƂB~ނ𓾂ȂB
		// łɃfR[ho҂Ȃꍇ₤Łc
		valid_name = new String(curEnt.getName().getBytes(), "SJIS").substring(garbageCharsOfPath);
		if (balloon_directory != null &&
		    (valid_name.equals(balloon_source_directory) ||
		     valid_name.startsWith(balloon_source_directory + "/"))) {

		    if (valid_name.equals(balloon_source_directory)) {
			pathToDest = destdir_balloon;
		    }
		    else {
			String name = valid_name.substring(
			    balloon_source_directory.length() + 1);
			pathToDest = new File(destdir_balloon, name);
		    }
		}
		else {
		    pathToDest = new File(
			destdir,
			valid_name
			);
		}
            } catch (Exception ex) {
		ex.printStackTrace();
	    }
	    if (pathToDest.getName().equals("install.txt") || pathToDest.getName().equals("delete.txt")) {
		// install.txtOB
		// ȂsupplementCXg[ۂɍŌɓꂽsupplementinstall.txt݂̂cB
		
		// delete.txtOB
		continue;
	    }
	    if (pathToDest.exists()) {
		if (pathToDest.isFile()) {
		    // t@C폜B
		    pathToDest.delete();
		}
	    }
	    prog.pbartype_setText2(valid_name);
	    
	    installedItemsCount++;
	    
            if (curEnt.isDirectory()) { // fBNg
		if (!pathToDest.exists()) { // ݂Ȃ΍쐬B
		    try {
			pathToDest.mkdir();
		    }
		    catch (Exception ex) {
			ex.printStackTrace();
		    }
		}
            }
            else { // t@C璆gRs[B
                try {
                    // zipWJRs[
		    pathToDest.getParentFile().mkdirs(); // fBNgGg݂ȂꍇɔBThanx > MacX2.0113
                    InputStream inStream = zf.getInputStream(curEnt);
		    if (inStream == null) {
			stat.texttype_println("Unzip error: "+valid_name);
			installedItemsCount--;
			continue;
		    }
                    FileOutputStream outStream = new FileOutputStream(pathToDest);
                    byte[] data = new byte[2048];
                    int bytesRead;
                    do {
                        bytesRead = inStream.read(data);
                        if (bytesRead != -1) {
                            outStream.write(data,0,bytesRead);
                        }
                    } while (bytesRead > 0);
		    outStream.close();
		    
		    // chmod tableɊY鍀ڂ΁AchmodsB
		    Integer mode = (Integer)chmod_table.get(valid_name);
		    if (mode != null) {
			SCUnixSystemCalls.chmod(pathToDest.getAbsolutePath(),mode.intValue());
		    }
                }
                catch (IOException ex) {
		    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.ioException");
		    prog.pbartype_setText1("Error!");
		    prog.closeWindow();
		    
		    throw new Exception(errorString);
                }
		catch (Exception ex) {
		    ex.printStackTrace();
		    
		    stat.texttype_println("Install error ("+ex.toString()+"): "+valid_name);
		    installedItemsCount--;
		}
            }
        }
	prog.pbartype_setVal(1.0);
	prog.pbartype_setText1("Done.");
	prog.pbartype_setText2(null);
	prog.closeWindow();
	stat.texttype_println("installed "+installedItemsCount+" items");
    }

    private void fix_balloon_if_needed() {
	String balloon_directory = install_txt.getStrValue("balloon.directory");
	if (balloon_directory != null) {
	    try {
		SCGhostManager.sharedGhostManager().getInstalledList().
		    changeBalloonOfGhost(destdir_path_from_home,destdir_balloon_path_from_home);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
	}
    }

    private void do_delete_if_needed() {
	ZipEntry delete_txt_entry = null;
        for ( Enumeration e = zf.entries() ; e.hasMoreElements() ; ) {
            ZipEntry curEnt = (ZipEntry)e.nextElement();
	    
	    if (curEnt.getName().endsWith("/delete.txt") || curEnt.getName().equals("delete.txt")) {
		delete_txt_entry = curEnt;
	    }
	}
	if (delete_txt_entry == null) {
	    stat.texttype_println("delete.txt : %[color,yellow]*** NONE ***%[color,default]");
	}
	else {
	    try {
		stat.texttype_println("delete.txt : %[color,orange]"+delete_txt_entry.getName()+"%[color,default]");
		SCDeletesList dlist = new SCDeletesList(zf.getInputStream(delete_txt_entry));
		final int n_dfiles = dlist.size();
		
		SCStatusWindowController prog_del = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
		prog_del.setTypeToProgressBar();
		prog_del.show();
		prog_del.pbartype_setText1("Deleting...");
		
		for (int i = 0;i < n_dfiles;i++) {
		    prog_del.pbartype_setVal((double)i / (double)n_dfiles);
		    prog_del.pbartype_setText2(dlist.getFile(i));
					
		    File fileToDel = new File(destdir,dlist.getFile(i));
		    if (fileToDel.exists()) {
			SCFileUtils.deleteRecursively(fileToDel);
						
			prog_del.pbartype_setText2(dlist.getFile(i));
			stat.texttype_println("%[color,yellow]deleted : "+dlist.getFile(i)+"%[color,default]");
		    }
		}
		prog_del.pbartype_setVal(1.0);
		prog_del.closeWindow();
	    }
	    catch (Exception e) {
		e.printStackTrace();
	    }
	}
    }

    private void exec_shell_if_needed() {
	String type = install_txt.getStrValue("type");
	String sh = install_txt.getStrValue("sh"); // install.sh
	
	if (sh != null && (type.equals("saori") || type.equals("plugin"))) {
	    stat.texttype_println("%[color,red]shell script exists : "+sh+"%[color,default]");
	    try {
		Process p = Runtime.getRuntime().exec(
		    new String[] {"/bin/sh", sh},
		    null,
		    destdir);
		
		// I҂
		while (true) {
		    try {
			p.waitFor();
			break;
		    }
		    catch (InterruptedException e) {}
		}

		stat.texttype_println("%[color,green]"+sh+" exitted with status "+p.exitValue()+"%[color,default]");
	    }
	    catch (Exception e) {
		e.printStackTrace();
	    }
	    // sht@CB
	    new File(destdir, sh).delete();
	}
    }

    private void postprocess() {
	String type = install_txt.getStrValue("type");
	String name = install_txt.getStrValue("name");
	String script = install_txt.getStrValue("script");
	String balloon_directory = install_txt.getStrValue("balloon.directory");
	
	if (deleteAfterSuccess) {
	    File archive = new File(fpath);
	    archive.delete();
	    stat.texttype_println(
		"%[color,white]deleted local archive "+archive.getName()+"%[color,default]");
	}

	stat.texttype_println("%[color,orange]INSTALL completed.%[color,default]");
	stat.closeWindow();
	if (type.equals("supplement")) {
	    if (script != null) {
		target.runScript(replaceInstallerEnvs(script),false);
	    }
	}
	else {
	    if (balloon_directory != null) { // with balloon
		sendInstallEvent(
		    "OnInstallComplete", new String[] {type,name,balloon_directory});
	    }
	    else { // ʏpbP[W
		sendInstallEvent(
		    "OnInstallComplete", new String[] {type,name});
	    }
	}

	// FIXME: Ȃ̂͗vȂcBਂɂH
	/*
	try {
	    SCGhostManager.sharedGhostManager().reloadLists();
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
	*/

	try {
	    zf.close();
	} catch (IOException ex) {}

	// typeghostballoonłreadme.txt݂΂JB
	if (type.equals("ghost") || type.equals("balloon")) {
	    File readme_txt = new File(destdir,"readme.txt");
	    if (readme_txt.exists()) {
		//new SCDocumentWindowController(readme_txt,destdir_path_from_home+"/readme.txt").showWindow(null);
		NSWorkspace.sharedWorkspace().openFile(readme_txt.getPath(),null,true);
	    }
	}

	// typepluginȂvOC}l[W[hB
	if (type.equals("plugin")) {
	    SCFoundation.sharedFoundation().getPluginManager().rescan();
	    
	    // ݒpl̃vOCXgr[[hB
	    SCPrefWindowController.sharedPrefWindowController().reloadPluginList();
	}

	// meBtBP[Vuinstaller.endv𔭍sB
	// ɂăS[Xg}l[W[hB
	NSNotificationCenter.defaultCenter().postNotification("installer.end",null,null);
    }
    
    public void run() {
	if (target != null && target.isInPassiveMode()) return; // pbVu[hł΋IB
	int pool = NSAutoreleasePool.push();

	try {
	    sendInstallEvent("OnInstallBegin");

	    // Xe[^XEChEJ
	    stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	    stat.setTypeToText();
	    stat.show();
	    stat.texttype_print("Installer started...\n");

	    // zipJ
	    zf = new ZipFile(fpath);

	    // install.txtGgT
	    find_manifest();

	    // ǂݍ
	    install_txt = new SCDescription(zf.getInputStream(manifest_ent));

	    // ̊mF
	    sanity_check();

	    // chmod\쐬
	    make_chmod_table();

	    // ^[Qbgw蓙
	    check_target();

	    // K{̃fBNg𑵂
	    SCFoundation.sharedFoundation().checkAndMakeSystemDirs();

	    // CXg[fBNg쐬
	    make_dest_dir();

	    // refresh
	    refresh_if_needed();

	    // ۂɃCXg[Binstall.txt͏OB
	    do_install();

	    // with balloon̏ꍇ̓CXg[ꂽS[Xg̃o[ύX
	    fix_balloon_if_needed();

	    // delete.txtΎs
	    do_delete_if_needed();

	    // shΎsBAtypesaori܂plugin̏ꍇ̂݁B
	    exec_shell_if_needed();

	    // ㏈
	    postprocess();
	}
	catch (ZipException e) {
	    String err = SCErrorStringServer.getErrorMessage("foundation.installer.zipException");
	    stat.texttype_println(e.getMessage());
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure", new String[] {e.getMessage()});
	}
	catch (IOException e) {
	    String err = SCErrorStringServer.getErrorMessage("foundation.installer.ioException");
	    stat.texttype_println(e.getMessage());
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure", new String[] {e.getMessage()});
	}
	catch (Exception e) {
	    String err = e.getMessage();
	    if (err.length() > 0) {
		stat.texttype_println(err);
	    }
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure", new String[] {err});
        }
    
	NSAutoreleasePool.pop(pool);
	return;
    }
    
    public void waitUntilEnd() {
	while (isAlive()) {}
    }
    
    private void sendInstallEvent(String eventName,String[] references) {
	if (target != null) target.doShioriEvent(eventName,references);
    }
    
    private void sendInstallEvent(String eventName) {
	if (target != null) target.doShioriEvent(eventName);
    }
    
    public static String replaceInstallerEnvs(String script) {
	// CXg[[ϐ%lastobjectname,%lastghostnameuĕԂ܂B
	StringBuffer buf = new StringBuffer(script);
	while (true) {
	    int pos = buf.toString().indexOf("%lastobjectname");
	    if (pos == -1) break;
	    
	    buf.replace(pos,pos+("%lastobjectname".length()),LAST_OBJECT_NAME);
	}
	while (true) {
	    int pos = buf.toString().indexOf("%lastghostname");
	    if (pos == -1) break;
	    
	    buf.replace(pos,pos+("%lastghostname".length()),LAST_GHOST_NAME);
	}
	return buf.toString();
    }
}
