/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import java.util.jar.*;
import java.util.zip.*;

/*
    jart@CNXǂݍރNX[_[łB
    pbP[WɂΉĂ܂B
*/

public class SCJarClassLoader extends ClassLoader
{
    JarFile jar;
	File nativelib_dir;
	String nativelib_prefix,nativelib_postfix;
    
    public SCJarClassLoader(JarFile jar)
    {
		this.jar = jar;
		this.nativelib_dir = null;
		this.nativelib_prefix = null;
		this.nativelib_postfix = null;
    }
	
	public SCJarClassLoader(JarFile jar,File nativelib_dir,String nativelib_prefix,String nativelib_postfix)
	{
		this.jar = jar;
		this.nativelib_dir = nativelib_dir;
		this.nativelib_prefix = nativelib_prefix;
		this.nativelib_postfix = nativelib_postfix;
	}
    
    protected Class findClass(String name) throws ClassNotFoundException
    {
		// NX̃sIh̓XbVɕϊ
		String path = name;
		if (name.indexOf('.') != -1)
		{
			StringBuffer buf = new StringBuffer(name);
			while (true)
			{
				int pos = buf.toString().indexOf('.');
				if (pos == -1) break;
				
				buf.setCharAt(pos,'/');
			}
			path = buf.toString();
		}
		path = path + ".class";
		
		// JarT
		ZipEntry ze = jar.getEntry(path);
		if (ze == null) throw new ClassNotFoundException(name);
	
		// [h
		try
		{
			InputStream is = jar.getInputStream(ze);
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			
			byte[] buffer = new byte[512];
			while (true)
			{
				int count = is.read(buffer);
				if (count == -1) break; // eof
				
				baos.write(buffer,0,count);
			}
			
			byte[] classData = baos.toByteArray();
			return defineClass(name,classData,0,classData.length);
		}
		catch (Exception e)
		{
			throw new ClassNotFoundException(name);
		}
    }
	
	protected String findLibrary(String libname)
	{
		return new File(nativelib_dir,nativelib_prefix+libname+nativelib_postfix).getAbsolutePath();
	}
}
