/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.util.*;
import java.lang.reflect.*;

public class SCKis
{
    SCKawari kawari;
    Hashtable dispatchTable;
    
    SCKisDictionaryCommands dicKis;
    SCKisCalculationCommands calcKis;
    SCKisSyntaxCommands syntKis;
    SCKisFileCommands fileKis;
    SCKisDataCommands dataKis;
    
    public SCKis(SCKawari kawari)
    {
	this.kawari = kawari;
	
	dicKis = new SCKisDictionaryCommands(kawari);
	calcKis = new SCKisCalculationCommands(kawari);
	syntKis = new SCKisSyntaxCommands(kawari);
	fileKis = new SCKisFileCommands(kawari);
	dataKis = new SCKisDataCommands(kawari);
	
	dispatchTable = new Hashtable();
	// ĂR}hQBl͂NX̃CX^XB
	
	dispatchTable.put("array",dicKis);
	dispatchTable.put("get",dicKis);
	dispatchTable.put("set",dicKis);
	dispatchTable.put("adddict",dicKis);
	dispatchTable.put("clear",dicKis);
	dispatchTable.put("enumerate",dicKis);
	dispatchTable.put("size",dicKis);
	
	dispatchTable.put("inc",calcKis);
	dispatchTable.put("dec",calcKis);
	// []͓ʈB
	dispatchTable.put("test",calcKis);
	dispatchTable.put("expr",calcKis);
	dispatchTable.put("rand",calcKis);
	
	// if,while,?͓ʈB
	dispatchTable.put("until",syntKis);
	dispatchTable.put("foreach",syntKis);
	dispatchTable.put("NULL",syntKis);
	dispatchTable.put("loop",syntKis);
	
	dispatchTable.put("load",fileKis);
	dispatchTable.put("save",fileKis);
	dispatchTable.put("savecrypt",fileKis);
	dispatchTable.put("textload",fileKis);
	dispatchTable.put("readdir",fileKis);
	
	dispatchTable.put("date",dataKis);
	dispatchTable.put("escape",dataKis);
	dispatchTable.put("echo",dataKis);
	dispatchTable.put("eval",dataKis);
	dispatchTable.put("entry",dataKis);
	dispatchTable.put("ver",dataKis);
	dispatchTable.put("urllist",dataKis);
	dispatchTable.put("chr",dataKis);
	dispatchTable.put("tolower",dataKis);
	dispatchTable.put("toupper",dataKis);
	dispatchTable.put("split",dataKis);
    }
    
    public String execute(String command,Vector params)
    {
	// ߂lnullł\܂B
	/*StringBuffer dump = new StringBuffer(command+' ');
	int n_params = params.size();
	for (int i = 0;i < n_params;i++) { dump.append((String)params.elementAt(i)+' '); }
	System.out.println(dump.toString());*/
	
	SCKisCommands executer = (SCKisCommands)dispatchTable.get(command);
	if (executer != null) // ĂB
	{
	    try
	    {
		Method method = executer.getClass().getMethod(command,new Class[] {Vector.class});
		return (String)method.invoke(executer,new Object[] {params});
	    }
	    catch (Exception e)
	    {
		return null;
	    }
	}
	else if (command.equals("["))
	{
	    return calcKis.test_blockstyle(params);
	}
	else if (command.equals("if"))
	{
	    return syntKis.syntax_if(params);
	}
	else if (command.equals("while"))
	{
	    return syntKis.syntax_while(params);
	}
	else if (command.equals("?"))
	{
	    return syntKis.syntax_randomselect(params);
	}
	
	return null;
    }
    
    public static boolean evaluateAsBoolean(String str)
    {
	// ,0,falseȂfalseAłȂtrueԂ܂B
	return !(str == null || str.length() == 0 || str.equals("0") || str.equals("false"));
    }
}
