/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.util.*;

public class SCKisDataCommands extends SCKisCommands
{
    public SCKisDataCommands(SCKawari kawari)
    {
	super(kawari);
    }
    
    public String echo(Vector params)
    {
	/*
	    @@Fecho 1 2 3 ... n
	    ߂lFSĂ̈AGXP[vĂ󔒕Ōq
	*/
	StringBuffer result = new StringBuffer();
	final int n_args = params.size();
	for (int i = 0;i < n_args;i++)
	{
	    String element = SCKawariDictionary.unescape((String)params.elementAt(i));
	    result.append(result.length() == 0 ? element : ' '+element);
	}
	return result.toString();
    }
    
    public String eval(Vector params)
    {
	/*
	    @@Feval 
	    ߂lF
	    
	    ĕ]ĕԂ܂B
	*/
	if (params.size() > 0)
	{
	    String str = (String)params.elementAt(0);
	    str = SCKawariDictionary.unescape(str); // NH[gB
	    str = SCKawariDictionary.escapeQuoted(str); // u_uNH[gň͂܂ꂽvƂ̂XNvgō쐬ĂꍇɔB
	    str = kawari.evaluator().evaluate(str); // ]
	    return str;
	}
	else
	{
	    return null;
	}
    }
    
    public String date(Vector params)
    {
	/*
	    @@Fdate tH[}bgw蕶
	    ߂lF쐬ꂽt
	    
	    %y,%Y	N(S)
	    %m		(01..12)
	    %n		(1..12)
	    %d		(01..31)
	    %e		(1..31)
	    %H		(00..23)
	    %k		(0..23)
	    %M		(00..59)
	    %N		(0..59)
	    %S		b(00..59)
	    %r		b(0..59)
	    %w		j(0..6) j0
	    %j		̒ʎZ(001..366)
	    %J		̒ʎZ(1..366)
	*/
	if (params.size() < 1) return null;
	
	Calendar cal = Calendar.getInstance();
	cal.setFirstDayOfWeek(Calendar.SUNDAY);
	Hashtable table = new Hashtable();
	table.put("y","" + cal.get(Calendar.YEAR));
	table.put("Y","" + cal.get(Calendar.YEAR));
	table.put("m",(cal.get(Calendar.MONTH)+1) < 10 ? "0"+(cal.get(Calendar.MONTH)+1) : ""+(cal.get(Calendar.MONTH)+1));
	table.put("n","" + (cal.get(Calendar.MONTH)+1));
	table.put("d",cal.get(Calendar.DAY_OF_MONTH) < 10 ? "0"+cal.get(Calendar.DAY_OF_MONTH) : ""+cal.get(Calendar.DAY_OF_MONTH));
	table.put("e","" + cal.get(Calendar.DAY_OF_MONTH));
	table.put("H",cal.get(Calendar.HOUR_OF_DAY) < 10 ? "0"+cal.get(Calendar.HOUR_OF_DAY) : ""+cal.get(Calendar.HOUR_OF_DAY));
	table.put("k","" + cal.get(Calendar.HOUR_OF_DAY));
	table.put("M",cal.get(Calendar.MINUTE) < 10 ? "0"+cal.get(Calendar.MINUTE) : ""+cal.get(Calendar.MINUTE));
	table.put("N","" + cal.get(Calendar.MINUTE));
	table.put("S",cal.get(Calendar.SECOND) < 10 ? "0"+cal.get(Calendar.SECOND) : ""+cal.get(Calendar.SECOND));
	table.put("r","" + cal.get(Calendar.SECOND));
	table.put("w","" + (cal.get(Calendar.DAY_OF_WEEK)-1));
	int doy = cal.get(Calendar.DAY_OF_YEAR);
	if (doy >= 100)
	{
	    table.put("j",""+doy);
	}
	else if (doy >= 10)
	{
	    table.put("j","0"+doy);
	}
	else
	{
	    table.put("j","00"+doy);
	}
	table.put("J",""+doy);
	// e[uBdmȂdddB
	
	StringBuffer buf = new StringBuffer((String)params.elementAt(0));
	while (true)
	{
	    int ppos = buf.toString().indexOf('%');
	    if (ppos == -1) break; // uI
	    
	    String replaced = (String)table.get(buf.substring(ppos+1,ppos+2));
	    buf.replace(ppos,ppos+2,replaced);
	}
	return buf.toString();
    }
    
    public String escape(Vector params)
    {
	/*
	    @@Fescape 
	    ߂lFSAKURA SCRIPTGXP[v
	*/
	if (params.size() < 1) return null;
	StringBuffer buf = new StringBuffer((String)params.elementAt(0));
	int pos = 0;
	while (pos < buf.length())
	{
	    char c = buf.charAt(pos);
	    if (c == '\\' || c == '\u00a5' || c == '%')
	    {
		buf.insert(pos,'\\');
		pos += 2;
	    }
	    else
	    {
		pos++;
	    }
	}
	return buf.toString();
    }
    
    public String entry(Vector params)
    {
	/*
	    @@Fentry Gg
	    ߂lF${Gg}̌
	*/
	if (params.size() < 1) return null;
	return kawari.evaluator().evaluate( "${" + (String)params.elementAt(0) + '}' );
    }
    
    public String ver(Vector params)
    {
	/*
	    @@Fver
	    ߂lFؘ̉aN[̃o[W
	*/
	return SCKawari.KAWARI_CLONE_VERSION;
    }
    
    public String urllist(Vector params)
    {
	/*
	    @@Furllist TCg1 URL1 oi[URL1 ... TCgn URLn oi[URLn
	    ߂lFTCg1[1]URL1[1]oi[URL1[2]...TCgn[1]URLn[1]oi[URLn[2]
	*/
	StringBuffer buf = new StringBuffer();
	Enumeration args = params.elements();
	while (args.hasMoreElements())
	{
	    buf.append((String)args.nextElement() + '\u0001');
	    buf.append((String)args.nextElement() + '\u0001');
	    buf.append((String)args.nextElement() + '\u0002');
	}
	return buf.toString();
    }
    
    public String chr(Vector params) throws Exception
    {
	/*
	    @@Fchr l
	    ߂lFlAXL[R[hƌ􂵂ʂ1
	*/
	int num = Integer.parseInt((String)params.elementAt(0));
	char c = (char)(num & 0xff);
	return ""+c;
    }
    
    public String tolower(Vector params)
    {
	/*
	    @@Ftolower 1 2 ...
	    ߂lFSĂ̈1byteAt@xbgɕϊ
	*/
	return _convertCase(params,false);
    }
    
    public String toupper(Vector params)
    {
	/*
	    @@Ftoupper 1 2 ...
	    ߂lFSĂ̈1byteAt@xbg啶ɕϊ
	*/
	return _convertCase(params,true);
    }
    
    private String _convertCase(Vector params,boolean upper)
    {
	// ܂͑SĂ̈A
	StringBuffer buf = new StringBuffer();
	for (Enumeration e = params.elements();e.hasMoreElements();)
	{
	    buf.append((String)e.nextElement()+' ');
	}
	buf.setLength(buf.length()-1); // Ōɗ]vȔpXy[XtB
	
	// ϊĕԂ
	return (upper ? buf.toString().toUpperCase() : buf.toString().toLowerCase());
    }
    
    public String split(Vector argv)
    {
	/*
	    @@Fsplit ۑGg  f~^
	    ߂lF
	    
	    ꂽ[ۑGg].1,[ۑGg].2,...ɓA
	    [ۑGg].sizeɓB
	    ̃g[Ng[NƂďB
	*/
	final String destination = SCKawariDictionary.unescape((String)argv.elementAt(0));
	final String string = SCKawariDictionary.unescape((String)argv.elementAt(1));
	final String delim = SCKawariDictionary.unescape((String)argv.elementAt(2));
	SCKawariDictionary dic = kawari.dictionary();
	
	int count = 0;
	StringBuffer buf = new StringBuffer(string);
	final int delim_len = delim.length();
	while (true)
	{
	    int pos = buf.toString().indexOf(delim);
	    
	    count++;
	    String entry = destination+"."+count;
	    dic.clearEntry(entry);
	    if (pos > 0) // łȂB
	    {
		dic.addToken(entry,buf.substring(0,pos));
	    }
	    else if (pos == -1 && buf.length() > 0) // ł͂ȂꂪŌ̃g[NłB
	    {
		dic.addToken(entry,buf.toString());
	    }
	    buf.delete(0,pos+delim_len);
	    
	    if (pos == -1) break;
	}
	
	String size_entry = destination+".size";
	dic.clearEntry(size_entry);
	dic.addToken(size_entry,Integer.toString(count));
	
	return null;
    }
}
