/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCKisFileCommands extends SCKisCommands
{
    public SCKisFileCommands(SCKawari kawari)
    {
	super(kawari);
    }
    
    public String load(Vector params)
    {
	/*
	    @@Fload t@C
	    ߂lF
	    
	    ÍĂĂǂݍ݂܂B
	*/
	if (params.size() < 1) return null;
	
	kawari.dictionary().loadDictFile((String)params.elementAt(0));
	return null;
    }
    
    public String save(Vector params)
    {
	/*
	    @@Fsave t@C Gg1 [Gg2 Gg3 ...]
	    ߂lF
	    
	    Íɕۑ܂B
	*/
	return _save(params,false);
    }
    
    public String savecrypt(Vector params)
    {
	/*
	    @@Fsavecrypt t@C Gg1 [Gg2 Gg3 ...]
	    ߂lF
	    
	    Íĕۑ܂B
	*/
	return _save(params,true);
    }
    
    private String _save(Vector params,boolean encrypt)
    {
	if (params.size() < 2) return null;
	
	String fname = (String)params.elementAt(0);
	int n_params = params.size() - 1;
	String[] ents = new String[n_params];
	for (int i = 0;i < n_params;i++)
	{
	    ents[i] = (String)params.elementAt(i+1);
	}
	
	kawari.dictionary().saveEntriesToDictFile(fname,ents,encrypt);
	
	return null;
    }
    
    public String textload(Vector params) throws Exception
    {
	/*
	    @@Ftextload t@C Gg
	    ߂lF
	    
	    t@CǂݍŁÅesGg.1,Gg.2,...ɏ݁A
	    Gg.sizeɍsށB
	*/
	String fpath = SCKawariDictionary.convertWinPathToUnixOne((String)params.elementAt(0));
	String target = (String)params.elementAt(1);
	
	File src = new File(kawari.getGhostRootDir(),fpath);
	if (!src.exists() || !src.isFile()) return null;
	
	BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(src),"SJIS"));
	final SCKawariDictionary dic = kawari.dictionary();
	int line_count = 0;
	while (true)
	{
	    String line = br.readLine();
	    if (line == null) break; // eof
	    
	    line_count++;
	    String entryname = target+'.'+line_count;
	    dic.clearEntry(entryname);
	    dic.addToken(entryname,line);
	}
	
	String size_entry = target+".size";
	dic.clearEntry(size_entry);
	dic.addToken(size_entry,Integer.toString(line_count));
	
	return null;
    }
    
    public String readdir(Vector args)
    {
	/*
	    @@Ftextload fBNg Gg
	    ߂lF
	    
	    w肳ꂽfBNgɊ܂܂SẴfBNgƃt@C
	    w肳ꂽGgɑSďށB
	    Ahbgt@C͏OBiUьƎ̎dlBȂ.DS_Store⃊\[Xt@Cǂ܂ꂩ˂ȂBj
	    fBNg݂Ȃ󂾂肵ꍇ͉ȂB
	    ΃pX̊̓S[XgfBNgi[home]/ghost/master/jƂB
	*/
	String path = (String)args.elementAt(0);
	String entry = (String)args.elementAt(1);
	SCKawariDictionary dic = kawari.dictionary();
	dic.clearEntry(entry);
	
	File dir = new File(kawari.getGhostRootDir(),SCKawariDictionary.convertWinPathToUnixOne(path));
	if (dir.exists() && dir.isDirectory())
	{
	    String[] files = dir.list();
	    for (int i = 0;i < files.length;i++)
	    {
		if (files[i].charAt(0) != '.') dic.addToken(entry,files[i]);
	    }
	}
	
	return null;
    }
}
