/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


public class SCKisTokenizer
{
    /*
	Kis̃R}hXe[gg$()̃lXglȂ番܂B
	
	j
	
	A ; B ; C ; D
	
	A,B,C,D
	
	A ; B ; $(X ; Y) ; C ; D
	
	A,B,$(X ; Y),C,D
	
	A B $(X ; Y) C
	
	A,B,$(X ; Y),C
    */
    StringBuffer buf;
    String delim;
    
    public SCKisTokenizer(String str,String delim)
    {
	buf = new StringBuffer(str);
	this.delim = delim;
    }
    
    public boolean hasMoreTokens()
    {
	int len = buf.length();
	for (int i = 0;i < len;i++)
	{
	    if (delim.indexOf(buf.charAt(i)) == -1) return true;
	}
	return false;
    }
    
    public String nextToken()
    {
	int searchOffset = 0;
	while (true)
	{
	    int scpos = buf.toString().indexOf(delim,searchOffset);
	    if (scpos == -1)
	    {
		String result = buf.toString();
		buf.setLength(0);
		return result;
	    }
	    
	    if (isSurrounded(scpos,buf.toString())) // ͂܂Ă
	    {
		searchOffset = scpos+1;
	    }
	    else
	    {
		searchOffset = 0;
		if (scpos == 0) // 󂾂
		{
		    buf.deleteCharAt(0);
		    continue;
		}
		else
		{
		    String result = buf.substring(0,scpos);
		    buf.delete(0,scpos+1);
		    return result;
		}
	    }
	}
    }
    
    private boolean isSurrounded(int pos,String str)
    {
	// str̒posԖڂ̕$()ň͂܂ĂtrueԂB
	StringBuffer buf = new StringBuffer(str);
	
	while (true)
	{
	    int blockstart = buf.toString().lastIndexOf("$(",pos);
	    if (blockstart == -1) return false; // posOŊJĂȂB
	    int blockend = buf.toString().indexOf(')',blockstart);
	    if (blockend > pos) // ͂܂Ă邱ƂmB
	    {
		return true;
	    }
	    else
	    {
		buf.delete(blockstart,blockend+1); // Ă͈͂͏ČJԂB
		pos -= blockend - blockstart + 1;
	    }
	}
    }
}
