/*  $Id: SCMailCheckDaemon.java,v 1.2 2003/12/24 06:02:13 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCMailCheckDaemon extends Thread {
    private volatile boolean signal_stop;
    private volatile long interval_millisec;
    
    public SCMailCheckDaemon() {
	reloadPref();
    }
    
    public void reloadPref() {
	// defaultsݒǂݍ݂܂B
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	interval_millisec = defaults.integerForKey("mailcheck_autocheck_interval") * 60 * 1000;
	
	if (isAlive()) interrupt();
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	
	while (!signal_stop) {
	    if (interval_millisec <= 0) { // sȐ
		try {
		    sleep(30 * 1000);
		}
		catch (InterruptedException e) {
		    // 荞݂烋[v̐擪ցB
		    continue;
		}
	    }
	    else {
		try {
		    sleep(interval_millisec);
		}
		catch (InterruptedException e) {
		    // 荞݂烋[v̐擪ցB
		    continue;
		}
		
		// [`FbJ[NB
		int inner_pool = NSAutoreleasePool.push();
		SCFoundation.sharedFoundation().doMailCheck();
		NSAutoreleasePool.pop(inner_pool);
	    }
	}
	
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate() {
	if (!isAlive()) return;
	
	signal_stop = true;
	interrupt();
	while (isAlive()) {}
    }
}
