/*  $Id: SCMiscUtils.java,v 1.3 2004/01/20 17:34:16 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.security.MessageDigest;
import java.util.*;

public class SCMiscUtils {
    public static String getMD5AsString(String str) {
	// Java`̂܂܃oCgɕϊAMD516i̕ƂĕԂ܂B
	return bytesToHexString(calcMD5(str));
    }
    
    public static byte[] calcMD5(String str) {
	// ftHgR[hŃoCgɕϊAMD5߂B
	// ̂Ȏdlɂ̂YꂽAgȂB
	try {
	    MessageDigest md5sum = MessageDigest.getInstance("MD5");
	    md5sum.update(str.getBytes());
	    return md5sum.digest();
	}
	catch(Exception e) {
	    e.printStackTrace();
	    return null;
	}
    }
    
    public static String bytesToHexString(byte[] bytes) {
	// oCg16i̕ƂĕԂ܂B
	StringBuffer sb = new StringBuffer();
	for (int i = 0;i < bytes.length;i++) {
	    String hexstr = Integer.toHexString((int)bytes[i] & 0x000000ff);
	    sb.append(hexstr.length() == 1 ? '0'+hexstr : hexstr);
	}
	return sb.toString();
    }
    
    public static int findData(byte[] world, byte[] data) {
	// worlddataA΂̃ItZbgAȂ-1Ԃ܂B
	// Boyer Moore@pB
	int data_len = data.length;
	int[] skip = new int[256];
	for (int i = 0; i < 256; i++) {
	    skip[i] = data_len;
	}
	for (int i = 0; i < data_len-1; i++) {
	    // byte -> -128  +127 ܂ŁB
	    // -1255ɁA-2254ɁAcA-128128ɑΉB
	    // ܂A͈̔͂ł͂ꂼ(256 + n)ɑΉB
	    skip[(data[i] < 0 ? 256 + data[i] : data[i])] = data_len - i - 1;
	}
	int limit = world.length - data.length;
	for (int i = 0;
	     i <= limit;
	     i += skip[(world[i+data_len-1] < 0 ?
			256 + world[i+data_len-1] : world[i+data_len-1])]) {
	    
	    if (world[i+data_len-1] != data[data_len-1]) {
		continue;
	    }
	    
	    boolean matched = true;
	    for (int j = 0; j < data_len; j++) {
		if (world[i+j] != data[j]) {
		    matched = false;
		    break;
		}
	    }
	    if (matched) {
		return i;
	    }
	}
	return -1;
    }
    
    public static Vector split(String src,String delim) {
	// delimɊ܂܂Ă镶Ȃǂł*ꕶP*ŕB
	if (src == null) return null;
	
	Vector result = new Vector();
	StringTokenizer st = new StringTokenizer(src,delim);
	while (st.hasMoreTokens()) {
	    result.add(st.nextToken());
	}
	return result;
    }
    
    public static String join(String delim,Vector vec) {
	// delim̂܂܋؂蕶ƂČB񕶎ȏ゠ĂlB
	StringBuffer result = new StringBuffer();
	
	final int n_elems = vec.size();
	for (int i = 0;i < n_elems;i++) {
	    result.append((String)vec.elementAt(i));
	    if (i < n_elems-1) result.append(delim);
	}
	return result.toString();
    }
}
