/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCNSSystemVariables
{
    Hashtable table; // L[F%܂܂Ȃ^O(String)@lFΉ钆g(String)
    
    public SCNSSystemVariables()
    {
	table = new Hashtable();
	
	// 萔
	put("platform",SCNiseShiori.PLATFORM);
	
	// l
	put("mikire","0");
	put("kasanari","0");
    }
    
    public String get(String name)
    {
	update();
	
	String result = (String)table.get(name);
	return (result == null ? "" : result);
    }
    
    public void put(String name,String data)
    {
	table.put(name,data);
    }
    
    private static final String[] WEEK_STR = {"sun","mon","tue","wed","thu","fri","sat"};
    private void update()
    {
	NSGregorianDate greg = new NSGregorianDate();
	table.put("year","" + greg.yearOfCommonEra());
	table.put("month","" + greg.monthOfYear());
	table.put("day","" + greg.dayOfMonth());
	table.put("hour","" + greg.hourOfDay());
	table.put("minute","" + greg.minuteOfHour());
	table.put("second","" + greg.secondOfMinute());
	table.put("week",WEEK_STR[greg.dayOfWeek()]);
	
	for (int i = 1;i <= 9;i++)
	{
	    StringBuffer buf = new StringBuffer();
	    for (int j = 1;j <= i;j++)
	    {
		int randnum = 0;
		if (i > 1 && j == 1)
		{
		    while (randnum == 0)
		    {
			randnum = (int)((Math.random() * 1000) % 10);
		    }
		}
		else
		{
		    randnum = (int)((Math.random() * 1000) % 10);
		}
		buf.append(randnum);
	    }
	    table.put("rand"+i,buf.toString());
	}
    }
}
