/*
	$Id: SCNarMaker.java,v 1.3 2002/12/08 16:10:05 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.zip.*;

public class SCNarMaker extends Thread
{
    File srcdir,parent_of_src_dir;
    SCSession target;
    
    public SCNarMaker(File srcdir)
    {
		this.srcdir = srcdir;
		this.target = null;
		
		parent_of_src_dir = srcdir.getParentFile();
    }
    
    public SCNarMaker(File srcdir,SCSession target)
    {
		// targetɎw肳ꂽS[XgSHIORICxgM܂B
		this.srcdir = srcdir;
		this.target = target;
		
		parent_of_src_dir = srcdir.getParentFile();
    }
    
    public void run()
    {
		int pool = NSAutoreleasePool.push();
		
		SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
		stat.setTypeToText();
		stat.show();
		stat.texttype_print("Creating Nar Archive...\n");
		
		// ^[Qbgw肳ĂȂΓKɑIԁB
		if (target == null) target = SCFoundation.sharedFoundation().getSession();
		
		final File destination = new File(parent_of_src_dir,srcdir.getName()+".nar");
		final File[] files = srcdir.listFiles();
		
		stat.texttype_println("output : %[color,orange]"+destination.getName()+"%[color,default]");
		
		// Ƃ肠fBNg̃[ginstall.txtΘbɂȂȂB
		boolean foundManifest = false;
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].getName().equals("install.txt"))
			{
				foundManifest = true;
				break;
			}
		}
		if (!foundManifest)
		{
			NSAutoreleasePool.pop(pool);
			return;
		}
		
		// IuWFNg擾ׂinstall.txtǂށB
		SCDescription desc = new SCDescription(new File(srcdir,"install.txt"));
		String objectname = desc.getStrValue("name");
		String objecttype = desc.getStrValue("type");
		stat.texttype_println("object name : %[color,white]"+objectname+"%[color,default]");
		stat.texttype_println("object type : %[color,white]"+objecttype+"%[color,default]");
		
		// OnNarCreatingM
		if (target != null) target.doShioriEvent("OnNarCreating",new String[] {objectname,destination.getName(),objecttype});
		
		// 쐬Jn
		try
		{
			if (destination.exists()) destination.delete();
			ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(destination));
			
			SCStatusWindowController prog_nar = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
			prog_nar.setTypeToProgressBar();
			prog_nar.show();
			prog_nar.pbartype_setText1("Archiving...");
			
			workForDir(srcdir.getName(),zos,prog_nar);
			
			prog_nar.pbartype_setText1("Done.");
			prog_nar.pbartype_setText2(null);
			prog_nar.pbartype_setVal(1.0);
			prog_nar.closeWindow();
			
			zos.finish();
			zos.close();
		}
		catch (Exception e)
		{
			System.err.println("SCNarMaker : Exception occuered in creating nar archive.");
			e.printStackTrace();
			NSAutoreleasePool.pop(pool);
			return;
		}
	
		stat.texttype_print("%[color,white]nar archive created.%[color,default]");
		stat.closeWindow();
		
		// OnNarCreatedM
		if (target != null) target.doShioriEvent("OnNarCreated",new String[] {objectname,destination.getName(),objecttype});
		
		NSAutoreleasePool.pop(pool);
    }
    
    private void workForDir(String path,ZipOutputStream zos,SCStatusWindowController prog_nar) throws Exception
    {
		// path : fBNgsrcdir̐ẽpXBŌɃXbV͕tȂB
		
		// ܂̓fBNgGgǉB
		// ZipEntry dir_entry = new ZipEntry(path+'/');
		// zos.putNextEntry(dir_entry);
		// ʓIzipt@Cƌ݊ƂȂȂ̂łȂBthanx > MacX2.0113
		
		prog_nar.pbartype_setText2(path+'/');
		prog_nar.pbartype_setVal(-1.0);
		
		// ɒgǉB
		final File dir = new File(parent_of_src_dir,path);
		final File[] files = dir.listFiles();
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].isDirectory())
			{
				workForDir(path+'/'+files[i].getName(),zos,prog_nar); // ċA
			}
			else if (files[i].isFile())
			{
				String name = files[i].getName();
				if (name.charAt(0) != '.')
				{
					// hbgt@C͏OB.DS_Store߂I{͂ȂƂȂB
					prog_nar.pbartype_setText2(path+'/'+name);
					prog_nar.pbartype_setVal(-1.0);
					
					ZipEntry entry = new ZipEntry(path+'/'+name);
					zos.putNextEntry(entry);
					
					FileInputStream fis = new FileInputStream(files[i]);
					byte[] buf = new byte[1024];
					while (true)
					{
						int counter = fis.read(buf);
						if (counter == -1) break; // eof
						
						zos.write(buf,0,counter);
					}
				}
			}
		}
    }
    
    public void waitUntilEnd()
    {
		while (isAlive()) {}
    }
    
    public static boolean hasManifestFile(File dir)
    {
		// fBNgdir̃[ginstall.txt݂邩ǂ𒲂ׂ܂B
		// ȂdirfBNgłȂfalseԂ܂B
		if (!dir.isDirectory()) return false;
		
		File[] files = dir.listFiles();
		boolean foundManifest = false;
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].getName().equals("install.txt"))
			{
				foundManifest = true;
				break;
			}
		}
		return foundManifest;
    }
}
