/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "SCNoiseImageDrawer_Impl.h"


@implementation SCNoiseImageDrawer_Impl

- (id)_initWithJavaObject:(id)sender
{
    srand(time(NULL));
    return self;
}

- (void)initWithSize:(NSData *)size
{
    long width,height;
    unsigned long size_bitmap;
    unsigned char *bytes;
    
    bytes = [size bytes];
    width = bytes[0] << 24 | bytes[1] << 16 | bytes[2] << 8 | bytes[3];
    height = bytes[4] << 24 | bytes[5] << 16 | bytes[6] << 8 | bytes[7];
    
    areaSize.width = width;
    areaSize.height = height;
    size_bitmap = width * height * 4;
    bitmapData = [[NSMutableData alloc] initWithLength:size_bitmap];
}

- (void)dealloc
{
    [bitmapData release];
    [super dealloc];
}

- (void)scramble
{
    int i;
    unsigned char *bitmap;
    unsigned long bitmapSize;
    
    bitmap = [bitmapData mutableBytes];
    bitmapSize = [bitmapData length];
    for (i = 0;i < bitmapSize;i += 4)
    {
	unsigned char gray,alpha;
	
	gray = (unsigned char)(rand() % 255);
	alpha = (unsigned char)(rand() % 200);
	
	bitmap[i] = bitmap[i+1] = bitmap[i+2] = gray;
	bitmap[i+3] = alpha;
    }
}

- (void)drawToPoint:(NSData *)point
{
    NSRect r;
    unsigned char *bitmap;
    unsigned char *bytes;
    long x,y;
    
    bytes = [point bytes];
    x = bytes[0] << 24 | bytes[1] << 16 | bytes[2] << 8 | bytes[3];
    y = bytes[4] << 24 | bytes[5] << 16 | bytes[6] << 8 | bytes[7];
    
    r.origin.x = x;
    r.origin.y = y;
    r.size.width = areaSize.width;
    r.size.height = areaSize.height;
    bitmap = [bitmapData mutableBytes];
    
    [self scramble];
    NSDrawBitmap(r,areaSize.width,areaSize.height,8,4,32,areaSize.width * 4,NO,YES,NSCalibratedRGBColorSpace,&bitmap);
}

@end
