/*
	$Id: SCPluginManager.java,v 1.3 2002/12/08 16:10:05 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.io.*;
import java.util.*;
import java.util.jar.*;

/*
    SẴvOCǗNXłB
    SCFoundationNɃCX^X쐬Eێ܂B
*/

public class SCPluginManager
{
    Vector plugins; // content : (SCPlugin)vOCNX{
    
    public SCPluginManager()
    {
		plugins = new Vector();
		rescan();
    }
    
    public void rescan()
    {
		// home/pluginT[`ȂāA܂[hĂȂvOC΃[h܂B
		File home_plugin = new File(SCFoundation.getParentDirOfBundle(),"home/plugin");
		File[] plugin_dirs = home_plugin.listFiles();
		for (int i = 0;i < plugin_dirs.length;i++)
		{
			// fBNgłȂ΃XLbv
			if (!plugin_dirs[i].isDirectory()) continue;
			
			// [hς݂ȂXLbv
			if (findPlugin(plugin_dirs[i]) != null) continue;
			
			// ܂alias.txt[h
			SCDescription descm = new SCDescription(new File(plugin_dirs[i],"alias.txt"));
			String fileName = descm.getStrValue("plugin");
			if (fileName == null)
			{
				File jarfile = new File(plugin_dirs[i],"plugin.jar");
				if (jarfile.exists())
				{
					fileName = "plugin.jar";
				}
				else
				{
					File classfile = new File(plugin_dirs[i],"plugin.class");
					if (classfile.exists())
					{
						fileName = "plugin.class";
					}
					else
					{
						continue; // ȃvOC
					}
				}
			}
	    
			// NX[h
			File targetFile = new File(plugin_dirs[i],fileName);
			if (!targetFile.exists()) continue;
			
			Class pluginClass;
			if (fileName.endsWith(".jar"))
			{
				try
				{
					JarFile jf = new JarFile(targetFile);
					// }jtFXgPlugin-Main-ClassɍŏɃ[hׂNXĂ锤B
					String classname = jf.getManifest().getMainAttributes().getValue("Plugin-Main-Class");
					pluginClass = (new SCJarClassLoader(jf,plugin_dirs[i],"lib",".jnilib")).loadClass(classname);
				}
				catch (Exception e) {continue;}
			}
			else if (fileName.endsWith(".class"))
			{
				pluginClass = (new SCFileClassLoader()).loadClassFile(targetFile);
				if (pluginClass == null) continue;
			}
			else
			{
				// Ȍ`
				continue;
			}
			
			// SCPlugin쐬
			SCPlugin plugin = SCPlugin.newInstance(pluginClass,plugin_dirs[i]);
			
			plugins.add(plugin);
		}
    }
    
    public SCPlugin findPlugin(File plugin_dir)
    {
		// w肳ꂽvOC[hĂ΂Ԃ܂B
		for (Enumeration e = plugins.elements();e.hasMoreElements();)
		{
			SCPlugin current = (SCPlugin)e.nextElement();
			if (current.getRootDir().equals(plugin_dir))
			{
				return current;
			}
		}
		return null;
    }
    
    public SCPlugin[] getPlugins()
    {
		// [hĂvOC̃XgԂ܂B
		Object[] src = plugins.toArray();
		SCPlugin[] dest = new SCPlugin[src.length];
		System.arraycopy(src,0,dest,0,src.length);
		return dest;
    }
    
    public SCPlugin[] getPlugins(String type)
    {
		// vOC^CvtypełvOC̃XgԂ܂B
		Vector vec = new Vector();
		for (Enumeration e = plugins.elements();e.hasMoreElements();)
		{
			SCPlugin plugin = (SCPlugin)e.nextElement();
			if (plugin.getType().equals(type))
			{
				vec.add(plugin);
			}
		}
		
		Object[] src = vec.toArray();
		SCPlugin[] dest = new SCPlugin[src.length];
		System.arraycopy(src,0,dest,0,src.length);
		return dest;
    }
}
