/*  $Id: SCSafetyBalloonController.java,v 1.20 2004/04/13 10:31:51 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.net.*;
import java.util.*;
import util.*;

public class SCSafetyBalloonController extends NSWindowController {
    boolean do_fade_out = true;
    int fade_out_step = 5;
    
    SCSession session;
    boolean atLeft = true; // trueȂVF̍ɂB
    
    int type; // {̂ɂイBSCFoundation̒萔gpB
    int num; // ݂̃o[ԍB
    
    SCBalloonSkinServer bsserver;
    SCBalloonSkin skin; // ݂̃o[Bꂪnull̎̓v~eBuo[gpB
    
    SCSafetyBalloonBackgroundView bgview;
    
    NSScrollView textScrollView;
    SCBalloonTextView textview;
    SCBalloonScrollArrow arrow_up,arrow_down;
    
    SCScriptRunner callback_target_runner = null;
    
    Vector alternatives = null;
    boolean alternative_draw_underline;
    boolean alternative_draw_square;
    NSColor alternative_pen_color;
    NSColor alternative_brush_color;
    // null̂܂܂A̎̃tHgF̊eF
    // 1.0f̂pB
    NSColor alternative_font_color;
    
    Vector anchors = null;
    NSColor anchor_color;
    
    public SCSafetyBalloonController(SCSession s, int t) {
	// SCSessionnullł邩mȂB
	// o[vr[ɂ͂łB
        super("SafetyBalloon");
	window().setAcceptsMouseMovedEvents(true);
	window().setDelegate(this);
	window().setAutodisplay(true);
	window().useOptimizedDrawing(false);
	textScrollView.setDrawsBackground(false);
	
	arrow_up = new SCBalloonScrollArrow(this,SCBalloonSkinServer.ARROW_UP);
	arrow_down = new SCBalloonScrollArrow(this,SCBalloonSkinServer.ARROW_DOWN);
	window().contentView().addSubview(arrow_up);
	window().contentView().addSubview(arrow_down);
	textview.initialize(arrow_up,arrow_down);
	textview.updateArrowsVisibilities();
	
	session = s;
	type = t;
	
	setType(0);
    }
    
    public void close() {
	super.close();
	session = null;
	bsserver = null;
	skin = null;
	textview.close();
	arrow_up.cleanUp(); arrow_up = null;
	arrow_down.cleanUp(); arrow_down = null;
	callback_target_runner = null;
	if (alternatives != null) {
	    alternatives.clear();
	}
	if (anchors != null) {
	    anchors.clear();
	}
    }

    public void setIgnoresMouseEvents(boolean bool) {
	if (SCFoundation.BALLOON_USES_CLICK_THROUGH || bool == false) {
	    window().setIgnoresMouseEvents(bool);
	}
    }

    public void flushWindow() {
	textview.waitUntilFlushed();
	window().flushWindow();
    }
    
    public void scrollWheel(NSEvent event) {
	scroll((float)Math.round(event.deltaY()));
    }
    
    public void scroll(float deltaY) {
	NSClipView clip = (NSClipView)textScrollView.contentView();
	
	NSRect oldrect = clip.documentVisibleRect();
	NSPoint oldpoint = oldrect.origin();
	float old_x = oldpoint.x();
	float old_y = oldpoint.y();
	float max_vert_point = clip.documentRect().height() - oldrect.height();
	
	float x = old_x;
	float y = old_y + deltaY;
	
	if (y < 0) y = 0;
	else if (y > max_vert_point) y = max_vert_point;
	
	clip.scrollToPoint(new NSPoint(x,y));
	textview.updateArrowsVisibilities();
    }
	
    public void mouseDown(NSEvent event) {
	if (callback_target_runner != null) {
	    // _uNbN(͂ȏ)H
	    if (event.clickCount() >= 2) {
		callback_target_runner.terminate(); // ~
	    }
	    else {
		callback_target_runner.speedUp(); // Đxグ
	    }
	}
    }
    
    public void mouseUp(NSEvent event) {
	if (callback_target_runner != null) {
	    callback_target_runner.speedDown(); // Đx
	}
    }
    
    // ngbLO@\B̃NXwindowdelegateɎw肳ĂB
    public void mouseMoved(NSEvent theEvent) {
	if (!window().frame().containsPoint(NSEvent.mouseLocation(),false)) return;
	
	// {XNSViewNSWindow܂ŒH͂̃CxgX|_[`FC
	// ł͂킴킴tɓB
	if (alternatives != null) {
	    final int n_alternatives = alternatives.size();
	    for (int i = 0;i < n_alternatives;i++) {
		NSView alternative = (NSView)alternatives.elementAt(i);
		
		alternative.mouseMoved(theEvent);
	    }
	}
	if (anchors != null) {
	    final int n_anchors = anchors.size();
	    for (int i = 0;i < n_anchors;i++) {
		NSView anchor = (NSView)anchors.elementAt(i);
		
		anchor.mouseMoved(theEvent);
	    }
	}
    }
	
    public SCBalloonAlternative addAlternative(String title,String param) {
	if (alternatives == null) { // ꂪڂ̑I
	    alternatives = new Vector();
	}
	
	// ǉ
	SCBalloonAlternative alt = new SCBalloonAlternative(
	    title,textview.getFont(),textview.getMainColor(),alternative_font_color,
	    alternative_pen_color,alternative_brush_color,alternative_draw_underline,alternative_draw_square,true);
	alt.setAction(new NSSelector("alterAction",new Class[] {Object.class}));
	alt.setTarget(this);
	alt.setRefcon(param);
	alternatives.add(alt);
	
	textview.addSubviewAtCurrentLoc(alt);

	setIgnoresMouseEvents(false);

	return alt;
    }
	
    public void addAnchor(String title,String id) {
	if (anchors == null)
	    anchors = new Vector();
	
	SCBalloonAlternative anc = new SCBalloonAlternative(title,textview.getFont(),anchor_color,anchor_color,
							    anchor_color,anchor_color,true,false,false);
	anc.setAction(new NSSelector("anchorAction",new Class[] {Object.class}));
	anc.setTarget(this);
	anc.setRefcon(id);
	anchors.add(anc);
	
	textview.addSubviewAtCurrentLoc(anc);

	setIgnoresMouseEvents(false);
    }
	
    public void setCallbackTarget(SCScriptRunner runner) {
	// IAJ[NbNꂽɃR[obNsXNvgi[ݒ肷B
	callback_target_runner = runner;
    }
    
    public void alterAction(Object sender) {
	// ̃\bh͒ڌĂяoĂ͂Ȃ܂B
	// IActionƂăR[܂B
	callback_target_runner.alternativeSelected((SCBalloonAlternative)sender);
    }
    
    public void anchorAction(Object sender) {
	callback_target_runner.anchorSelected((SCBalloonAlternative)sender);
    }
    
    private void removeAllAlternatives() {
	if (alternatives == null) return;
	
	int n_alts = alternatives.size();
	for (int i = 0;i < n_alts;i++) {
	    SCBalloonAlternative alt = (SCBalloonAlternative)alternatives.elementAt(i);
	    alt.removeFromSuperview();
	}
	
	alternatives = null;
    }
    
    private void removeAllAnchors() {
	if (anchors == null) return;
	
	int n_ancs = anchors.size();
	for (int i = 0;i < n_ancs;i++) {
	    SCBalloonAlternative anc = (SCBalloonAlternative)anchors.elementAt(i);
	    anc.removeFromSuperview();
	}
	
	anchors = null;
    }

    public void addImage(String name, int x, int y) {
	// FIXME: 摜𒼐ڕ`subviewɂǂBŁB
	
	//System.out.println("adding balloon image to [" + x + "," + y + "]");
        String dir = session.getGhostMasterDirPath();
	File f = new File(dir,name);
        NSImage img = new NSImage(f.getPath(),true);
        //System.out.println("file name is " + f.getPath());
        //System.out.println("file object is " + img.toString());
        NSPoint p = new NSPoint(x,y);
        textview.drawImage(img,p);
    }
    
    public void setType(int num) {
	this.num = num;
	if (bsserver == null) return;
	
	// ɂ΍pɁAEɂΉEpɁAꂼꐔlCB
	if (atLeft) {
	    num = (num % 2 == 0 ? num : num-1);
	}
	else {
	    num = (num % 2 == 0 ? num+1 : num);
	}
	
        skin = bsserver.findSkin(num,type);
        if (skin != null) {
            NSImage background = skin.getImage();
            window().setContentSize(background.size());
	    setBalloonAttributesFromDescription();
            window().setHasShadow(false);
	    bgview.setBGImage(background);
	    textview.changedSize();
	    //textview.display();
	    textview.setNeedsDisplay(true);
        }
        else {
	    bgview.setBGImage(null);
	    window().setHasShadow(true);
	    
	    NSSize newSize;
	    if (type == SCFoundation.HONTAI) {
		if (num == 0 || num == 1) {
		    newSize = new NSSize(326,169);
		}
		else {
		    newSize = new NSSize(326,384);
		}
	    }
	    else {
		newSize = new NSSize(326,96);
	    }
	    window().setContentSize(newSize);
	    setBalloonAttributesFromDescription();
	    bgview.redraw();
	    textview.changedSize();
	    //textview.display();
	    textview.setNeedsDisplay(true);
	}
    }
    
    public void setBalloonServer(SCBalloonSkinServer bsserver) {
	this.bsserver = bsserver;
	setType(num); // [hB
    }
    
    public void setTransparency(double t) {
	bgview.setTransparency(t);
    }
    
    public void setDoesFadeOut(boolean b) {
	do_fade_out = b;
    }
    
    public void beEmpty() {
	textview.beEmpty();
	setIgnoresMouseEvents(true);
    }
    
    public void makeSSTPMsgEmpty() {
	bgview.setSSTPMessage("");
	bgview.redraw();
    }
    
    public void addText(String text,long wait) throws InterruptedException {
        // wait~b̃EGCgtextꕶǉ܂B
        // EGCĝŃCXbhĂяo肵ȂŉB
        // ܂Ã\bhĂяoXbhɃC^vgꍇ́A𒆎~܂B
        int n_chars = text.length();
	
        for (int i = 0;i < n_chars;i++) {
            addChar(text.charAt(i));
	    if (wait > 0) {
		Thread.sleep(wait);
	    }
        }
    }
    
    public void addChar(char c) {
	textview.addChar(c);
    }
    
    public void showSSTPMessage(String msg) {
	bgview.setSSTPMessage(msg);
	bgview.redraw();
    }
    
    public void setLoc(NSPoint loc) {
        window().setFrameTopLeftPoint(loc);
	checkWentOut();
    }
    
    public void setOrigin(NSPoint loc) {
        window().setFrameOrigin(loc);
	checkWentOut();
    }
    
    public void checkWentOut() {
	// o[؂ĂΔΑɂ܂킷B
	// AΑɂ܂킵Ă؂Ă΁A؂̓xȂقIԁB
	if (session != null) {
	    final int screenWidth = (int)NSScreen.mainScreen().frame().width();

	    // ؂Ăΐ̒lB
	    int left_mikire_width = -1 *
		session.simulateHorizLoc(type == SCFoundation.HONTAI, true);
	    // ؂Ăΐ̒lB
	    int right_mikire_width = -1 *
		(screenWidth -
		 (session.simulateHorizLoc(type == SCFoundation.HONTAI, false) +
		  (int)width()));
	    
	    if (x() < 0) {
		if (right_mikire_width <= 0 || left_mikire_width > right_mikire_width) {
		    setToRight();
		}
	    }
	    else if (x() + width() > screenWidth) {
		if (left_mikire_width <= 0 || left_mikire_width < right_mikire_width) {
		    setToLeft();
		}
	    }
	}
    }
    
    public void setToLeft() {
	if (atLeft) {
	    return;
	}
	
	atLeft = true;
	setType((num % 2 == 1 ? num-1 : num));
	
	if (session != null) {
	    session.recalcBalloonsLoc();
	}
    }
    
    public void setToRight() {
	if (!atLeft) {
	    return;
	}
	
	atLeft = false;
	setType((num % 2 == 0 ? num+1 : num));
	
	if (session != null) {
	    session.recalcBalloonsLoc();
	}
    }
    
    public boolean isAtLeft() {
	return atLeft;
    }
    
    public float width() {
        return window().frame().width();
    }
    
    public float height() {
        return window().frame().height();
    }
    
    public float x() {
        return window().frame().x();
    }
    
    public float y() {
        return window().frame().y();
    }
    
    public NSSize size() {
	return window().frame().size();
    }
    
    public void show() {
	if (SCFoundation.LOCK_BALLOONS) return;
	if (window().isVisible()) return;
	
	//showWindow(null);
	NSTimer open_timer = new NSTimer(
	    0.0,
	    this,
	    new NSSelector("showWindow",new Class[] {NSNull.class}),
	    new Object[] {NSNull.nullValue()},
	    false);
	SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
	if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
	
	//beEmpty();
	//bgview.redraw();
    }
    
    public void hide() {
	if (!window().isVisible()) return;
	
	if (do_fade_out) {
	    for (int i = fade_out_step-1;i >= 1;i--) {
		window().setAlphaValue((float)i / (float)fade_out_step);
	    }
	    window().orderOut(null);
	    //makeMainThreadCallOrderOut();
	    window().setAlphaValue(1.0f);
	}
	else {
	    window().orderOut(null);
	    //makeMainThreadCallOrderOut();
	}
	
        //beEmpty();
        //makeSSTPMsgEmpty();
	
	// őIĂ܂ƁA낢肪NB
	
	cleanUp();
    }
    private void makeMainThreadCallOrderOut() {
	NSTimer close_timer = new NSTimer(
	    0.0,
	    window(),
	    new NSSelector("orderOut",new Class[] {NSNull.class}),
	    new Object[] {NSNull.nullValue()},
	    false);
	SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(close_timer,NSRunLoop.DefaultRunLoopMode);
	if (!Thread.currentThread().getName().equals("main")) while (window().isVisible()) {} // ҋ@
    }
    
    public void cleanUp() {
	removeAllAlternatives();
	removeAllAnchors();
	beEmpty();
	//makeSSTPMsgEmpty();
	bgview.redraw();
	callback_target_runner = null; // ͂svȂ̂ŎQƂB

	// AJ[Ȃꍇ̂ŁAOtextview̑STuNXB
	for (Enumeration enu = textview.subviews().objectEnumerator();
	     enu.hasMoreElements(); ) {
	    ((NSView)enu.nextElement()).removeFromSuperview();
	}
    }
    
    public boolean isVisible() {
	return window().isVisible();
    }
    
    public NSScrollView getTextScrollView() {
	return textScrollView;
    }
    
    public void setLevel(int level) {
        window().setLevel(level);
    }
    
    public void requestChangeFont(NSFont newfont) {
        textview.setFont(newfont);
    }
    
    public void setFontColor(NSColor color) {
	textview.setMainColor(color);
    }
    
    public void setShadowColor(NSColor color) {
	textview.setMainShadowColor(color);
    }
    
    public void setSSTPMessageColor(NSColor color) {
	bgview.setSSTPMessageColor(color);
    }
    
    public void setSSTPMessageLoc(NSPoint point) {
	bgview.setSSTPMessageLoc(point);
    }
    
    public void setSSTPMarkerLoc(NSPoint point) {
	bgview.setSSTPMarkerLoc(point);
    }
    
    public void setSSTPMarkerImage(NSImage img) {
	bgview.setSSTPMarkerImage(img);
    }
    
    public float getSSTPMessageFontHeight() {
	return bgview.getSSTPMessageFontHeight();
    }

    public SCSafetyBalloonBackgroundView getBGView() {
	return bgview;
    }
    
    private void setBalloonAttributesFromDescription() {
	float r,g,b;
	// ̂o[XLȂ炻̑ǂݍށB
	SCDescription desc = (skin == null ? bsserver.getDescription() : skin.getDescription());
	
	// originwordwrappoint擾AtextScrollVieẅʒuƃTCY
	int origin_x,origin_y; // tWnł̍W
	if (desc.exists("origin.x")) {
	    origin_x = desc.getIntValue("origin.x");
	    origin_y = desc.getIntValue("origin.y");
	}
	else {
	    origin_x = origin_y = 10;
	}
	if (origin_x < 0) origin_x = 0;
	if (origin_y < 0) origin_y = 0;
	int tvWidth,tvHeight;
	if (desc.exists("wordwrappoint.x")) {
	    int wwp_x = desc.getIntValue("wordwrappoint.x");
	    tvWidth = (wwp_x > 0 ? wwp_x - origin_x : (int)width() + wwp_x - origin_x);
	}
	else {
	    tvWidth = (int)width() - 2 - SCBalloonScrollArrow.DEFAULT_WIDTH - 2 - origin_x;
	}
	if (tvWidth < 0) tvWidth = 0;
	if (origin_x + tvWidth > width()) tvWidth = (int)width() - origin_x - 1;
	if (desc.exists("validrect.bottom")) {
	    int vr_b = desc.getIntValue("validrect.bottom");
	    if (vr_b > (int)height()) vr_b = (int)height();
	    tvHeight = (vr_b > 0 ? vr_b - origin_y : (int)height() + vr_b - origin_y);
	}
	else {
	    tvHeight = (int)height() - 15 - origin_y;
	}
	if (tvHeight < 0) tvHeight = 0;
	if (origin_y + tvHeight > height()) tvHeight = (int)height() - origin_y - 1;
	textScrollView.setFrame(new NSRect(origin_x,height() - origin_y - tvHeight,tvWidth,tvHeight));
	
	// tHg̐F
	r = desc.getIntValue("font.color.r") / 255.0f;
	g = desc.getIntValue("font.color.g") / 255.0f;
	b = desc.getIntValue("font.color.b") / 255.0f;
	setFontColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
	
	// e̐F
	if (desc.exists("font.shadowcolor.r")) {
	    if (desc.getIntValue("font.shadowcolor.r") == -1) {
		// e 
		setShadowColor(null);
	    }
	    else {
		r = desc.getIntValue("font.shadowcolor.r") / 255.0f;
		g = desc.getIntValue("font.shadowcolor.g") / 255.0f;
		b = desc.getIntValue("font.shadowcolor.b") / 255.0f;
		setShadowColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
	    }
	}
	else {
	    // setShadowColor(NSColor.colorWithCalibratedWhite(0.0f,0.3f));
	    setShadowColor(null);
	}
	
	// SSTPbZ[W̐F
	if (!desc.exists("sstpmessagecolor.r")) {
	    r = g = b = 0.5f;
	}
	else {
	    r = desc.getIntValue("sstpmessagecolor.r") / 255.0f;
	    g = desc.getIntValue("sstpmessagecolor.g") / 255.0f;
	    b = desc.getIntValue("sstpmessagecolor.b") / 255.0f;
	}
	setSSTPMessageColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
	
	// SSTPbZ[Wʒu
	if (desc.exists("sstpmessage.x")) {
	    int horiz = desc.getIntValue("sstpmessage.x");
	    int vert = desc.getIntValue("sstpmessage.y");
	    
	    setSSTPMessageLoc(new NSPoint(horiz,(vert > 0 ? height() - vert : -1 * vert) - (int)getSSTPMessageFontHeight()));
	}
	else {
	    setSSTPMessageLoc(new NSPoint(2,2));
	}
	
	// SSTP}[J[摜ƈʒu
	NSImage marker = bsserver.getSstpMarkerImage();
	setSSTPMarkerImage(marker);
	if (marker != null) {
	    if (desc.exists("sstpmarker.x")) {
		int horiz = desc.getIntValue("sstpmarker.x");
		int vert = desc.getIntValue("sstpmarker.y");
		
		setSSTPMarkerLoc(new NSPoint(horiz,(vert > 0 ? height() - vert : -1 * vert) - (int)marker.size().height()));
	    }
	    else {
		setSSTPMarkerLoc(new NSPoint(2,2));
	    }
	}
	
	// I
	if (!desc.exists("cursor.style")) {
	    alternative_draw_underline = alternative_draw_square = true;
	}
	else {
	    String style_str = desc.getStrValue("cursor.style");
	    if (style_str.equals("square")) {
		alternative_draw_square = true;
	    }
	    else if (style_str.equals("underline")) {
		alternative_draw_underline = true;
		alternative_draw_square = false;
	    }
	    else if (style_str.equals("square+underline")) {
		alternative_draw_underline = alternative_draw_square = true;
	    }
	}
	
	if (!desc.exists("cursor.pen.color.r")) {
	    r = g = b = 10.0f / 255.0f;
	}
	else {
	    r = desc.getIntValue("cursor.pen.color.r") / 255.0f;
	    g = desc.getIntValue("cursor.pen.color.g") / 255.0f;
	    b = desc.getIntValue("cursor.pen.color.b") / 255.0f;
	}
	alternative_pen_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
	
	if (!desc.exists("cursor.brush.color.r")) {
	    r = g = b = 0.5f;
	}
	else {
	    r = desc.getIntValue("cursor.brush.color.r") / 255.0f;
	    g = desc.getIntValue("cursor.brush.color.g") / 255.0f;
	    b = desc.getIntValue("cursor.brush.color.b") / 255.0f;
	}
	alternative_brush_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
	
	alternative_font_color = null;
	if (desc.exists("cursor.font.color.r")) {
	    String blendmethod = desc.getStrValue("cursor.blendmethod");
	    if ((blendmethod != null && blendmethod.equals("none")) || blendmethod == null) {
		r = desc.getIntValue("cursor.font.color.r") / 255.0f;
		g = desc.getIntValue("cursor.font.color.g") / 255.0f;
		b = desc.getIntValue("cursor.font.color.b") / 255.0f;
		
		alternative_font_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
	    }
	}
	
	// XN[A[
	NSImage image_arrow_up = bsserver.getArrowImage(SCBalloonSkinServer.ARROW_UP);
	NSImage image_arrow_down = bsserver.getArrowImage(SCBalloonSkinServer.ARROW_DOWN);
	//Logger.log(this, Logger.DEBUG, "arrow up: {"+image_arrow_up+"}");
	arrow_up.setImage(image_arrow_up);
	arrow_down.setImage(image_arrow_down);
	float x,y;
	if (!desc.exists("arrow0.x")) {
	    x = width() - 2 - arrow_up.width();
	    y = height() - 2 - arrow_up.height();
	}
	else {
	    x = desc.getIntValue("arrow0.x");
	    y = desc.getIntValue("arrow0.y");
	    if (x < 0) x = width() + x;
	    if (y < 0)
		y = -1*y - arrow_up.height();
	    else
		y = height() - y - arrow_up.height();
	}
	arrow_up.setFrameOrigin(x,y);
	//Logger.log(this, Logger.DEBUG, "width: "+width()+"; arrow_up: {"+arrow_up+"}");
	
	if (!desc.exists("arrow1.x")) {
	    x = width() - 2 - arrow_down.width();
	    y = 2;
	}
	else {
	    x = desc.getIntValue("arrow1.x");
	    y = desc.getIntValue("arrow1.y");
	    if (x < 0) x = width() + x;
	    if (y < 0)
		y = -1*y - arrow_down.height();
	    else
		y = height() - y - arrow_down.height();
	}
	arrow_down.setFrameOrigin(x,y);
	
	// AJ[
	if (!desc.exists("anchor.font.color.r")) {
	    r = b = 0.0f;
	    g = 0.8f;
	}
	else {
	    r = desc.getIntValue("anchor.font.color.r") / 255.0f;
	    g = desc.getIntValue("anchor.font.color.g") / 255.0f;
	    b = desc.getIntValue("anchor.font.color.b") / 255.0f;
	}
	anchor_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("session: {").append(session).append('}');
	buf.append("; type: ").append(type);
	buf.append("; skin id: ").append(num);
	if (skin != null) {
	    buf.append("; skin: {").append(skin).append('}');
	}
	return buf.toString();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
}
