/*  $Id: SCSerikoSeqPatternEntry.java,v 1.4 2004/01/30 08:04:25 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
/*
  SCSerikoSeqPatternEntry
  
  patternGg̃f[^\܂B
*/
public class SCSerikoSeqPatternEntry {
    // p[^́AgȂ\bhłꍇ͏0ƂȂ܂B
    // I^ieBuX^[g̃GgXgȂnullɂȂ܂B
    
    // {p[^
    int surfaceid;
    int interval; // Pʂ͏Ƀ~b
    String method;
    int offsetx,offsety;
    
    // startp
    int seq_id;
    
    // alternativestartp
    Vector entries; // gIntegerB
    
    // insertp
    int bind_id;
    
    public SCSerikoSeqPatternEntry(int version, String dataline) {
	/*
	  datalineɂ́A[seqid]pattern[index],̌̃f[^w肵ĉB
	  
	  Ⴆ΁A
	  1pattern0,50,20,overlay,10,0
	  
	  50,20,overlay,10,0
	  łB
	*/
	StringTokenizer st = new StringTokenizer(dataline, ",");

	if (version == 0) {
	    // surfaceidinterval̃tB[h́AႦ0ŃpfBOĂɂK݂B
	    try {
		surfaceid = Integer.parseInt(st.nextToken());
	    } catch (Exception e) {
		throw new RuntimeException(
		    "Invalid surcace ID in `"+dataline+"'; version "+version);
	    }
	    try {
		interval = Integer.parseInt(st.nextToken());
	    } catch (Exception e) {
		throw new RuntimeException(
		    "Invalid interval in `"+dataline+"'; version "+version);
	    }
	    try {
		method = st.nextToken();
	    }
	    catch (Exception e) {
		throw new RuntimeException(
		    "Missing method in `"+dataline+"'; version "+version);
	    }
	    
	    // intervalSERIKO/2.0łȂ10msdʂɂȂĂB
	    interval *= 10;
	}
	else {
	    // method͏ɑ݂B
	    try {
		method = st.nextToken();
	    }
	    catch (Exception e) {
		throw new RuntimeException(
		    "Missing method in `"+dataline+"'; version "+version);
	    }
	}
	
	// methodɏ]Aǉf[^ǂݍށB
	if (method.equals("start")) {
	    try{
		seq_id = Integer.parseInt(st.nextToken());
	    } catch (Exception e) {
		throw new RuntimeException(
		    "Invalid sequense ID in start method `"+dataline+"'; version "+version);
	    }
	}
	else if (method.equals("insert")) {
	    try {
		bind_id = Integer.parseInt(st.nextToken());
	    } catch (Exception e) {
		throw new RuntimeException(
		    "Invalid bind ID in insert method `"+dataline+"'; version "+version);
	    }
	}
	else if (method.equals("alternativestart")) {
	    String altana_param = st.nextToken(""); // kSĎoB
	    if (altana_param.length() > 0 && altana_param.charAt(0) == ',') {
		altana_param = altana_param.substring(1);
	    }
	    
	    // O̊ʂBSERIKO/2.0ł́u()vAłȂ΁u[]vB
	    char blockstart = altana_param.charAt(0);
	    char blockend = altana_param.charAt(altana_param.length() - 1);
	    if (altana_param.length() <= 2 ||
		(version == 0 && blockstart != '[' && blockend != ']') ||
		(version == 1 && blockstart != '(' && blockend != ')')) {
		throw new RuntimeException(
		    "Malformed parameter of alternativestart: `"+dataline+"'; version "+version);
	    }
	    String entry_list = altana_param.substring(1, altana_param.length() - 1);
	    
	    entries = new Vector();
	    StringTokenizer ent_st = new StringTokenizer(
		entry_list, version == 0 ? "." : ","); // SERIKO/2.0ł̓f~^ӁB
	    while (ent_st.hasMoreTokens()) {
		String token = ent_st.nextToken();
		try {
		    entries.add(new Integer(token));
		} catch (Exception e) {
		    throw new RuntimeException(
			"Invalid parameter of alternative start: `"+token+"' in `"+
			dataline+"'; version "+version);
		}
	    }
	}
	else {
	    if (version == 1) {
		try {
		    surfaceid = Integer.parseInt(st.nextToken());
		} catch (Exception e) {
		    throw new RuntimeException(
			"Invalid surcace ID in `"+dataline+"'; version "+version);
		}
		try {
		    interval = Integer.parseInt(st.nextToken());
		} catch (NumberFormatException e) {
		    throw new RuntimeException(
			"Invalid interval in `"+dataline+"'; version "+version);
		} catch (Exception e) {} // interval݂͑ȂmȂB
	    }
	    
	    try {
		offsetx = Integer.parseInt(st.nextToken());
	    } catch (NumberFormatException e) {
		throw new RuntimeException(
		    "Invalid offset-x in `"+dataline+"'; version "+version);
	    } catch (Exception e) {} // offsetx, offsety݂͑ȂmȂB
	    
	    try {
		offsety = Integer.parseInt(st.nextToken());
	    } catch (NumberFormatException e) {
		throw new RuntimeException(
		    "Invalid offset-y in `"+dataline+"'; version "+version);
	    } catch (Exception e) {}
	}
    }
    
    public void dump() {
	System.out.println(surfaceid+","+interval+","+method+","+offsetx+","+offsety);
    }
    
    public int surfaceid() {
	return surfaceid;
    }
    
    public int interval() {
	return interval;
    }
    
    public String method() {
	return method;
    }
    
    public int offsetx() {
	return offsetx;
    }
    
    public int offsety() {
	return offsety;
    }
    
    public int seq_id() {
	return seq_id;
    }
    
    public Vector entries() {
	return entries;
    }
    
    public int bind_id() {
	return bind_id;
    }
}
