/*  $Id: SCSerikoSequence.java,v 1.5 2004/02/05 09:29:35 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
/*
    SCSerikoSequence
    
    V[PX\܂B
    ႦΎ̂悤Ȃ̂łB
    
    0interval,sometimes
    0pattern0,100,5,overlay,0,0
    0pattern1,101,5,overlay,0,0
    0pattern2,100,5,overlay,0,0
    0pattern3,-1,5,overlay,0,0
*/
public class SCSerikoSequence {
    SCSerikoSeqIntervalEntry interval; // intervalGg̒gB
    SCSerikoSeqOptionEntry option; // optionGg̒gBȗĂnullB
    Vector patterns; // patternGg̒gBgSCSerikoSeqPatternEntry܂nullBp^[IDƔzID͊SɈv܂B
    int seq_id;
    
    public SCSerikoSequence(int seq_id) {
	patterns = new Vector();
	this.seq_id = seq_id;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("ID: ").append(seq_id);
	buf.append("; interval: {").append(interval).append('}');
	if (option != null) {
	    buf.append("; option: {").append(option).append('}');
	}
	return buf.toString();
    }
    
    public void dump() {
	System.out.println("### Sequence ID : "+seq_id);
	interval.dump();
	if (option != null) option.dump();
	
	final int n_pats = patterns.size();
	for (int i = 0;i < n_pats;i++) {
	    Object entry = patterns.elementAt(i);
	    if (entry instanceof SCSerikoSeqPatternEntry) ((SCSerikoSeqPatternEntry)entry).dump();
	}
    }
    
    public void add(int version, String dataline) {
	/*
	  VɃGgǉ܂B
	  Gǧ`
	  interval,sometimes
	  pattern0,100,5,overlay,0,0
	  łāA
	  0interval,sometimes
	  0pattern0,100,5,overlay,0,0
	  ł͂܂B

	  SERIKO/2.0̏ꍇłɁA
	  animation0.pattern0,100,5,overlay,0,0
	  ̑͂
	  pattern0,100,5,overlay,0,0
	  Ŏw肵ĉB
	*/
	
	if (dataline.startsWith("interval")) {
	    interval = new SCSerikoSeqIntervalEntry( dataline.substring(9) );
	}
	else if (dataline.startsWith("pattern") || dataline.startsWith("patturn")) {
	    /*
	      Քn̎d鏑̌뎚ŁApatternpatturnɂȂĂB
	      ̂߁AۂpatturngĂVF݂B
	    */
	    
	    // p^[IDoB
	    int pat_id_begin = 7;
	    int pat_id_end = 7;
	    while (Character.isDigit(dataline.charAt(pat_id_end))) {
		pat_id_end++;
	    }

	    if (pat_id_begin == pat_id_end) {
		// p^[IDB
		throw new RuntimeException(
		    "Parse failed: missing pattern ID in pattern line `"+dataline+"'; version "+version);
	    }
	    
	    int patId = -1;
	    try {
		patId = Integer.parseInt(dataline.substring(pat_id_begin,pat_id_end));

		// ̃p^[IDɑΉSCSerikoSeqPatternEntryɃf[^i[B
		setPatternEntry(version, patId, dataline.substring(pat_id_end+1));
	    } catch(Exception e) {
		throw new RuntimeException(
		    "Parse failed: pattern line `"+dataline+"'; version "+version, e);
	    }
	}
	else if (dataline.startsWith("option")) {
	    option = new SCSerikoSeqOptionEntry( dataline.substring(7) );
	}
    }
    
    public int id() {
	return seq_id;
    }
    
    public SCSerikoSeqIntervalEntry interval() {
	return interval;
    }
    
    public SCSerikoSeqOptionEntry option() {
	return option; // ȗĂnullԂ܂B
    }
    
    public Vector patterns() {
	// SĂpatternGgԂ܂B
	// z̃CfBbNXƃp^[CfBbNX͈vĂ̂ŁA
	// ԍĂꍇnullŃpfBOĂ܂B
	return patterns;
    }
    
    private void setPatternEntry(int version, int patId, String pattern_param) {
	// patternspatIdɑΉʒuɃf[^Zbg܂B
	// KvȂnullŃpfBO܂B
	
	if (patId < 0) {
	    throw new RuntimeException(
		"Pattern ID is negative: `"+patId+"'; This must be zero or positive.");
	}
	
	SCSerikoSeqPatternEntry patEntry = new SCSerikoSeqPatternEntry(version, pattern_param);	
	if (patterns.size() >= patId+1) { // Ƀf[^Ă̂ŁÂB
	    patterns.setElementAt(patEntry,patId);
	}
	else {
	    // KvȂnullŃpfBOB
	    while (patId > patterns.size()) {
		patterns.add(null);
	    }
	    
	    patterns.add(patEntry);
	}
    }
}
