/*  $Id: SCSerikoSequenceRunner.java,v 1.9 2005/04/24 08:03:02 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.util.*;
import util.*;

public class SCSerikoSequenceRunner extends Thread {
    SCShell shell;
    SCSeriko seriko;
    SCSerikoSequence seq;
    SCShellWindowController target;
    SCSession session;
    boolean end_and_quit; // trueȂV[PXIɃi[~܂BrunonceŎg܂B
    int exec_probability = 1; // Ȏ҂ԁib̔mjłBrandom(rarelỹ}N܂ށj̏ꍇ݈̂Ӗ܂BłȂ1ɂȂ܂B
    SCShellLayer layer; // overlaypC[łBV[PXŏ߂overlayoĂɍ쐬܂B
    boolean hontai;
    
    private volatile boolean signal_stop = false;
    
    /*
      i[͓ƗXbhłB
      
      ̃^Cv͏펞NĂ܂BV[PXIA̔^C~O܂ŃX[v܂B
      random (sometimes,rarely)
      always
      talk
      yen-e
      
      ̃^Cv͕KvȎɋNAV[PXIɃXbh~܂B
      runonce
      never
      
      talk,yen-e͏펞NĂ܂Aۂɓo^C~O͕słB
      Ȃ̂ŁA^C~O͊OʒmĂ炤Kv܂B
      
      펞N^Cv́Aɂ̓X[vĂ甭AX[vĂ甭AƂs܂B
      ̓V[PXO[v؂ւۂrunoncesometimesrarelyalwaysxɑSē̂h߂łB
    */
    
    public SCSerikoSequenceRunner(SCSeriko seriko,SCShell shell,SCSerikoSequence seq,boolean hontai,SCSession session) {
	this.shell = shell;
	this.seriko = seriko;
	this.hontai = hontai;
	this.seq = seq;
	this.session = session;
	target = (hontai ? session.getHontai() : session.getUnyuu());
	
	String interval_type = seq.interval().type();
	if (interval_type.equals("runonce") || interval_type.equals("never")) {
	    end_and_quit = true;
	}
	
	if (interval_type.equals("random")) {
	    exec_probability = seq.interval().probability();
	}
    }
    
    public void run() {
	// exclusiveɕAȂȂ̂ł̃\bhł͌returngȂ悤ɁB
	int pool = NSAutoreleasePool.push();
	boolean exc_lock = (seq.option() != null ? seq.option().type().equals("exclusive") : false);
	
	while (!signal_stop) {
            int inner_pool = NSAutoreleasePool.push();
	    // OEGCgBb̔mB
	    
	    /*
	      xȏAĔĂ͂ȂȂB
	      EGCgyȓꍇ͘AĂƌȂB
	      
	      Ƃ肠x3Ay2ƂĂB
	    */
	    try {
		final int x = 3,y = 2;
		int repeat = 0,wait_times_since_break = 0;
		
		while(true) {
		    if (exec_probability == 1) {
			break;
		    }
		    else {
			if ((int)Math.round(Math.random() * exec_probability) == 0) {
			    if (repeat < x) {
				repeat++;
				break; // EGCgI
			    } // xȏAĂ狭IɃX[vB
			}
			
			sleep(1 * 1000);
			wait_times_since_break++;
			
			if (wait_times_since_break > y) { // KvȃEGCgs
			    repeat = wait_times_since_break = 0; // Zbg
			}
		    }
		}
	    }
	    catch (InterruptedException e) {
                // IwoĂXbhIB
                signal_stop = true;
		continue;
	    }
	    
      	    // 点B
	    Vector patterns = seq.patterns();
	    
	    /*
	      KvȂexclusivebNB
	      talkyen-eƎ~܂Ƃ܂Xbĥ͎~߂ȂA
	      ꂾalwaysȂ񂩂ɓĂ炻̃ubNoȂB
	      ܁A͂̂ȂƂ܂B܂Ƃ̎dlł܂ĂȂB
	    */
	    if (exc_lock) {
		seriko.setExclusiveLocked(true);
		seriko.interruptAllRunners(hontai);
		//seriko.terminateAllRunnersOverlay(hontai);

		Logger.log(this, Logger.DEBUG, "Exclusive Locked");
	    }
	    
	    int n_patterns = patterns.size();
	    for (int i = 0;i < n_patterns;i++) {
		if (signal_stop) break; // IwoĂIB

		// ̃XbhɂexclusivebNĂ҂B
		if (!exc_lock) {
		    waitForUnlocked();
		}
		
		Object obj = patterns.elementAt(i);
		if (obj == null) {
		    continue; // pfBOĂ
		}
		SCSerikoSeqPatternEntry pat = (SCSerikoSeqPatternEntry)obj;
				
		// \bh
		String method = pat.method();
		if (method.equals("overlay") || method.equals("overlayfast")) { // ǂ
		    if (pat.surfaceid() == -1) { // terminate
			if (layer != null) {
			    layer.setVis(false);
			    //target.getWindow().display();
			    target.setViewsNeedDisplay(true);
			}
		    }
		    else if (pat.surfaceid() == -2) { // terminate all
			seriko.terminateAllRunnersOverlay(hontai);
		    }
		    else {
			if (layer == null) {
			    layer = target.getView().addLayer(
				shell.getSurfaceServer(),
				pat.surfaceid(),
				seq.id(),
				new NSPoint(pat.offsetx(),pat.offsety()),
				true);
			}
			else {
			    layer.setImage( shell.getSurfaceServer(),pat.surfaceid() );
			    layer.setLoc( new NSPoint(pat.offsetx(),pat.offsety()) );
			    layer.setVis(true);
			}
			//target.getWindow().display();
			target.setViewsNeedDisplay(true);
		    }
		}
		else if (method.equals("move")) {
		    double ratio = target.getRatio();
		    target.setOffset( (float)(pat.offsetx() * ratio) , (float)(pat.offsety() * -1 * ratio) );
		}
		else if (method.equals("base")) {
		    if (pat.surfaceid() == -1) {
			target.tempChangeBase( shell.getSurfaceServer() , target.baseSurfaceId() );
		    }
		    else {
			target.tempChangeBase( shell.getSurfaceServer() , pat.surfaceid() );
		    }
		}
		else if (method.equals("start")) {
		    seriko.execute(pat.seq_id(),hontai);
		}
		else if (method.equals("alternativestart")) {
		    int select = (int)((Math.random() * Integer.MAX_VALUE) % pat.entries().size());
		    seriko.execute(((Integer)pat.entries().elementAt(select)).intValue(),hontai);
		}
		
		// EGCg
		if (pat.interval() > 0) {
		    try {
			sleep( pat.interval() );
		    }
		    catch (InterruptedException e) {
			if (signal_stop) break; // for[vIwhile[vI
		    }
		}
	    }
	    
	    // KvȂexclusiveAB
	    if (exc_lock) {
		seriko.setExclusiveLocked(false);
		seriko.interruptAllRunners(hontai);
		
		Logger.log(this, Logger.DEBUG, "Exclusive Unlocked");
	    }
	    
		//end_and_quit=trueȂrunoncenever
		//UIĂ܂overlayꂽ摜NAĂ܂̂Œ~w܂ő҂B
		if(end_and_quit){
			while(true){
				//CPUǂHĂɑΏ
				//tO`FbN͂PbɂP񂭂炢\ł命B
				try {
                        sleep(1000);     // PbԒ~
                } catch (InterruptedException e) {
                        
                }
				if(signal_stop){
					//~ŵŃ[v
					break;
				}
			}
		}
		
	    // IȂIB
	    if (!signal_stop) {
                signal_stop = end_and_quit;
            }
            NSAutoreleasePool.pop(inner_pool);
	}
	
	// C[Ă폜
	if (layer != null) {
	    target.getView().removeLayer(layer);
	    //target.getWindow().display();
	    target.setViewsNeedDisplay(true);
	}
	NSAutoreleasePool.pop(pool);
    }

    protected void waitForUnlocked() {
	// bNȂ܂ő҂B
	if (seriko.isExclusiveLocked()) {
	    // C[ΉB
	    if (layer != null) {
		layer.setVis(false);
		target.setViewsNeedDisplay(true);
	    }

	    Logger.log(this, Logger.DEBUG, "Waiting for exclusive unlocked...");
	    while (seriko.isExclusiveLocked()) {
		try {
		    sleep(200);
		}
		catch (Exception e) {}
	    }
	    Logger.log(this, Logger.DEBUG, "Exclusive lock is no longer locked. I'll go ahead. ");

	    if (layer != null) {
		layer.setVis(true);
		target.setViewsNeedDisplay(true);
	    }
	}
    }
    
    public void terminateOverlay() {
	// overlaygȂV[PX疳B
	
	if (layer != null) {
	    layer.setVis(false);
	    //target.getWindow().display();
	    target.setViewsNeedDisplay(true);
	}
    }
    
    public void terminateThread() {
	if (!isAlive()) return;
	
	signal_stop = true;
	interrupt();
	while (isAlive()) {
	    try {
		sleep(10);
	    } catch (InterruptedException e) {}
	}
    }
    
    public boolean isHontai() {
	return hontai;
    }
    
    public int getSeqID() {
	return seq.id();
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("sequence: {").append(seq).append('}');
	if (layer != null) {
	    buf.append("; with layer");
	}
	buf.append("; scope: ").append(hontai ? 0 : 1);
	return buf.toString();
    }
}
