/*  $Id: SCSession.java,v 1.26 2004/02/05 09:29:35 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import java.net.*;
import util.*;

public class SCSession extends Thread {
    //public static final int MAX_QUEUE_SIZE = 20;
    
    public static final int UNAVAILABLE = 1;
    // f[^̃[h̗RŁAꎞIɃZbVɃANZXłȂԂ\܂B
    
    public static final int CLOSED = 2;
    // ZbVɕꂽԂ\܂B̏Ԃł̓ANZXĂ͂܂B
    
    public static final int AVAILABLE = 3;
    // ZbVNŁAÕANZXĂԂ\܂B
    
    volatile boolean flagClosing = false; // trueȂZbV悤ƂĂ܂B
    
    SCShell currentShell;
    SCSpirit masterSpirit;
    //Vector slaveSpirits; // gSCSpiritB
    
    SCBalloonSkinServer balserver;
    SCShellWindowController hontai,unyuu;
    SCSafetyBalloonController hontai_b,unyuu_b;
    SCScriptRunner scrrunner;
    SCScriptServer tmpScriptServer; // SSTP̑IpBi[xI閈sweepAway()܂B
    SCCommunicateBoxController comBox;
    SCVanishWindowController vanishDialog;
    SCShellContextMenuMaker shellContextMenuMaker;
    SCMenuAppearanceServer menuAppearance;
    SCShellChangingSession lastShellChangingSession; // ŌɋNꂽVFύXZbVB
    SCNetworkUpdater lastNetworkUpdater; // ŌɋNꂽlbg[NAbvf[^B
    SCTeachSession lastTeachSession; // ŌɋNꂽTeachZbVB
    SCInputBoxSession lastInputBoxSession; // ŌɋNꂽINPUTZbVB
    SCSessionCloser closer; // ꂪNďIɂ̓ZbVB
	
    private Vector queue; // SHIORItH[h|[g̃L[BgStringB
    
    String currentSelfName;
    String currentKeroName;
    
    File ghost_dir;
    String ghost_path;
    File readmeFile;
    
    private int status = UNAVAILABLE;
    private long boottime;
    private boolean passive_mode = false;
    
    final boolean light_mode; // Cg[hŋNǂB
    final boolean special_shell_mode; // VFw胂[h(Cg[hp)ŋNB
    
    public SCSession(String ghost_path, String balloon_path) {
	this(ghost_path, null, balloon_path, false);
    }
    public SCSession(
	String ghost_path, String balloon_path, boolean light_mode) {
	this(ghost_path, null, balloon_path, light_mode);
    }
    public SCSession(
	String ghost_path, String shelldir_name,
	String balloon_path, boolean light_mode) {
	// ghost_path : home/ghost/[ghostname]
	// shelldir_name: shell/̃fBNgBnullȂݒ肳ꂽVFgB
	// light_mode : trueȂ烉Cg[hŋNB
	
	long boot_begin_time = System.currentTimeMillis();
	this.light_mode = light_mode;

	if (shelldir_name != null) {
	    // VFw̓Cg[hpB
	    if (light_mode) {
		special_shell_mode = true;
	    }
	    else {
		Logger.log(
		    this, Logger.WARN,
		    "Special shell-dir was specified in constructor while light-mode is disabled. "+
		    "shell-dir will be ignored.");
		shelldir_name = null;
		special_shell_mode = false;
	    }
	}
	else {
	    special_shell_mode = false;
	}
	
	SCStatusWindowController stat = null;
	if (!SCFoundation.isHereMainThread() && !light_mode) {
	    stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	    stat.setTypeToText();
	    stat.show();
	    stat.texttype_print("%[color,yellow]Materializing ghost...%[color,default]\n");
	}
	
	boottime = System.currentTimeMillis();
        this.ghost_path = ghost_path;
	ghost_dir = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
        
        NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	
	readmeFile = new File(ghost_dir,"readme.txt");
	
        // master spirit N
	masterSpirit = new SCSpirit(this,"master",stat);
	
        // {̂Ƃɂイp̃EChE쐬
	hontai = new SCShellWindowController(this,SCFoundation.HONTAI);
	unyuu = new SCShellWindowController(this,SCFoundation.UNYUU);
	
	// shell N
	currentShell = new SCShell(
	    this,
	    shelldir_name != null ? shelldir_name : getShellDirName(),
	    stat);
	currentShell.start();
        
        // ʒu
	hontai.setHorizLoc(getHorizontalLocationOfShell(currentShell.getDirName(),SCFoundation.SAKURA));
	unyuu.setHorizLoc(getHorizontalLocationOfShell(currentShell.getDirName(),SCFoundation.KERO));
	
	// o[T[o[N
        balserver = SCFoundation.sharedFoundation().getBalloonServer(balloon_path,stat);
        
        // o[
        hontai_b = new SCSafetyBalloonController(this,SCFoundation.HONTAI);
        unyuu_b = new SCSafetyBalloonController(this,SCFoundation.UNYUU);
	hontai_b.setBalloonServer(balserver);
	unyuu_b.setBalloonServer(balserver);
        hontai.setBalloon(hontai_b);
        unyuu.setBalloon(unyuu_b);
	
	// o[x
	double balloon_transparency = defaults.doubleForKey("display_slider_transparency"); // `Ȃ[̂܂܁B
	hontai_b.setTransparency(balloon_transparency);
	unyuu_b.setTransparency(balloon_transparency);
	
	// o[tF[hAEg
	if (defaults.objectForKey("display.balloon.fadeout") == null) {
	    hontai_b.setDoesFadeOut(true); // ftHgŃtF[hAEgs
	    unyuu_b.setDoesFadeOut(true);
	}
	else {
	    boolean bool = (defaults.integerForKey("display.balloon.fadeout") == 1);
	    hontai_b.setDoesFadeOut(bool);
	    unyuu_b.setDoesFadeOut(bool);
	}
        
        // ʒu
        recalcBalloonsLoc();
        
        // x
        int level = defaults.integerForKey("display_levelselect");
        // Gg݂Ȃ0Ԃ遨NSWindow.NormalWindowLevel0łB
        hontai.setLevel(level);
        unyuu.setLevel(level);
        hontai_b.setLevel(level);
        unyuu_b.setLevel(level);
        
        // tHg
        String fontname = (String)defaults.objectForKey("display_fontname");
        float fontsize = defaults.floatForKey("display_fontsize");
        if (fontname == null) fontname = "Osaka";
        if (fontsize == 0) fontsize = 9.0f;
        hontai_b.requestChangeFont(NSFont.fontWithNameAndSize(fontname,fontsize));
        unyuu_b.requestChangeFont(NSFont.fontWithNameAndSize(fontname,fontsize));
        
	// ꎞXNvg(SSTP/1.2p)
	tmpScriptServer = new SCScriptServer();
	
	if (!light_mode) {
	    // COMMUNICATE BOX [h
	    comBox = new SCCommunicateBoxController(this);
	    
	    // SHIORIJ[lNOTIFY OwnerGhostName𑗐M
	    // ̎_ł͂܂FORWARD PORTNĂȂ̂forwardĂ͂ȂB
	    if (masterSpirit.getShioriProtocolVersion() == 2) {
		masterSpirit.doShioriSession(
		    "NOTIFY OwnerGhostName SHIORI/2.3\r\nSender: "+
		    SCFoundation.STRING_FOR_SENDER+"\r\nGhost: "+
		    masterSpirit.getSelfName()+"\r\n\r\n");
	    }
	    
	    // ReNXgj[ Look&Feel
	    menuAppearance = new SCMenuAppearanceServer(this);
	    
	    // ReNXgj[
	    shellContextMenuMaker = new SCShellContextMenuMaker(this);
	}
	
	long elapsed_time_to_materialize = System.currentTimeMillis() - boot_begin_time;
	if (stat != null) {
	    stat.texttype_print(
		"%[color,orange]ghost \"%[color,white]"+
		masterSpirit.getName()+
		"%[color,orange]\" materialized.\n");
	    stat.texttype_print(
		"%[color,orange]"+
		(elapsed_time_to_materialize / 1000.0)+
		" sec elapsed.");
	    stat.closeWindow();
	}
	else {
	    Logger.log(
		this, Logger.NOTICE,
		(elapsed_time_to_materialize / 1000.0)+
		" sec elapsed to materialize.");
	}
	
	queue = new Vector();
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("path: ").append(ghost_path);

	buf.append("; status: ");
	if (status == UNAVAILABLE) {
	    buf.append("unavailable");
	}
	else if (status == CLOSED) {
	    buf.append("closed");
	}
	else if (status == AVAILABLE) {
	    buf.append("available");
	}
	else {
	    buf.append("*unknown*");
	}
	
	buf.append("; uptime: ").append(
	    System.currentTimeMillis() - boottime).append("ms");

	if (flagClosing) {
	    buf.append("; closing");
	}
	if (passive_mode) {
	    buf.append("; passive");
	}
	if (light_mode) {
	    buf.append("; light");
	}
	if (special_shell_mode) {
	    buf.append("; special-shell");
	}
	
	return buf.toString();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
    
    private volatile boolean flagTerm = false;
    public void run() {
	int pool = NSAutoreleasePool.push();
	
	status = AVAILABLE;
	
	while (!flagTerm) {
	    if (queue.size() > 0) {
		String req = (String)queue.elementAt(0); // 擪oB
		queue.removeElementAt(0);

		int inner_pool = NSAutoreleasePool.push();
		shioriResponceWork(masterSpirit.doShioriSession(req));
		NSAutoreleasePool.pop(inner_pool);
	    }
	    else {
		if (flagTerm) break;
		
		try {
		    sleep(30 * 1000); // KBL[ɃvbVinterrupt()鎖B
		} catch (InterruptedException e) {
		    if (flagTerm) break;
		}
	    }
	}
	
	NSAutoreleasePool.pop(pool);
    }
    public void forwardToShioriKernel(String request) {
	// SHIORI/2.xNGXg̃ZbVɃtHA[h܂B
	// ʂ͕Ԃ܂B

	//if (queue.size() < MAX_QUEUE_SIZE) {
	//if (scrrunner == null ||
	//    !scrrunner.isAlive() ||
	//    scrrunner.interruptAllowed()) {
	    // NeBJZbV̓L[ɗ߂ȂB
	    queue.add(request);
	    //    System.out.println("QUEUE: "+queue.size());
	    //}
	interrupt();
    }
    public void clearQueue() {
	queue.clear();
	//System.out.println("QUEUE CLEARED");
    }
    
    public boolean isLightMode() {
	return light_mode;
    }
    
    public boolean isInPassiveMode() {
	return passive_mode;
    }
    
    public void setPassiveMode(boolean bool)
    {
		passive_mode = bool;
	
		if (passive_mode)
		{
			comBox.close(); // COMMUNICATE BOX
			if (lastTeachSession != null && lastTeachSession.isAlive()) lastTeachSession.terminate(); // TEACHZbVNȂ狭I
		}
		
		NSMutableDictionary userinfo = new NSMutableDictionary();
		userinfo.setObjectForKey(this,"session");
		NSNotificationCenter.defaultCenter().postNotification("passivemode",passive_mode ? "enter" : "leave",userinfo);
    }
    
    public int hoursFromBootTime() {
	// ZbVNĂ̌oߎԂԂ܂B
	return (int)Math.round((double)(System.currentTimeMillis() - boottime) / (1000.0 * 60.0 * 60.0));
    }
    
    public void changeSurface(int id,boolean hontai) {
	SCShellWindowController iwc = (hontai ? getHontai() : getUnyuu());
	
	if (iwc.currentSurfaceId() != id) {
	    iwc.changeSurface(currentShell.getSurfaceServer(),id);
	    currentShell.getSeriko().surfaceChanged(id,hontai);
	    
	    doShioriEvent(
		"OnSurfaceChange", new String[] {
		    Integer.toString(getHontai().currentSurfaceId()),
		    Integer.toString(getUnyuu().currentSurfaceId())});
	}
    }
    
    public void changeShell() {
	// JgVFύX܂B
	// ݒdefaultsǂݍ݂܂B

	if (special_shell_mode) {
	    // VFŒB
	    return;
	}
	
	// ݃VFύXZbVNȂ牽ɏIB
	if (lastShellChangingSession != null && lastShellChangingSession.isAlive()) return;

	lastShellChangingSession = new SCShellChangingSession(this);
	lastShellChangingSession.start();
    }
    
    public void changeShell(SCShell newShell)
    {
		// JgVFύX܂B
		// ̃\bhSHIORIɃCxg𑗐MɃJgVFύX݂̂łB
		// ۂɕύXɂchangeShell()gpĂB
		if (status != AVAILABLE) return;
		
		status = UNAVAILABLE;
		currentShell.close();
		currentShell = newShell;
		currentShell.start();
		status = AVAILABLE;
    }
    
    public void doNetworkUpdate()
    {
		if (status != AVAILABLE) return;
		if (lastNetworkUpdater != null && lastNetworkUpdater.isAlive()) return;
		
		lastNetworkUpdater = new SCNetworkUpdater(this);
		lastNetworkUpdater.start();
    }
    
    public Object getGhostDefaults(String entry)
    {
		// plist̃S[Xgdefaultsf[^擾܂B
		// ȂnullԂ܂B
		NSMutableDictionary defaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
		return defaults.objectForKey(entry);
    }
    
    public void setGhostDefaults(String entry,Object obj)
    {
		// plist̃S[XgdefaultsɃf[^ݒ肵܂B
		NSMutableDictionary defaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
		defaults.setObjectForKey(obj,entry);
		SCGhostManager.sharedGhostManager().setGhostDefaults(ghost_path,defaults);
    }
    
    public void doFirstBootEvent()
    {
		// OnFirstBootCxg𔭍s܂B
		NSMutableDictionary defaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
		Object vanish_count = defaults.objectForKey("vanish_count");
		if (vanish_count instanceof Integer)
		{
			doShioriEvent("OnFirstBoot",new String[] {Integer.toString(vanish_count == null ? 0 : ((Integer)vanish_count).intValue())});
		}
		else
		{
			doShioriEvent("OnFirstBoot",new String[] {Long.toString(vanish_count == null ? 0 : ((Long)vanish_count).longValue())});
		}
    }
    
    public void mouseEventOccuredOnShell(String type,String x,String y,String wheel,String owner,String collision) {
	// SCShellWindowpB

	//if (type.equals("OnMouseDoubleClick")) {
	    // _uNbNȂL[NAB
	    //clearQueue();
	//}
	
	if (SCFoundation.sharedFoundation().isThisInVanishEvent(this) && type.equals("OnMouseDoubleClick")) {
	    // ~߂B
	    SCFoundation.sharedFoundation().holdVanishSession();
	    clearQueue();
	    forceTerminateScriptRunnder();
	    
	    doShioriEvent("OnVanishButtonHold");
	}
	else {
	    doShioriEvent(type,new String[] {x,y,wheel,owner,collision});
	}
    }
    
    public boolean hasBootedBefore()
    {
		// ̃S[XgߋɈxłNƂLtrueԂ܂B
		String flag = (String)getGhostDefaults("has_booted_before");
		return (flag != null && flag.equals("true"));
    }
    
    public void doTeach()
    {
		if (status != AVAILABLE) return;
		if (isInPassiveMode()) return;
		if (lastTeachSession != null && lastTeachSession.isAlive()) return;
		
		lastTeachSession = new SCTeachSession(this);
		lastTeachSession.start();
    }
	
	public void startInputBoxSession(String symbol,int timeout)
	{
		if (status != AVAILABLE) return;
		if (isInPassiveMode()) return;
		if (lastInputBoxSession != null && lastInputBoxSession.isAlive()) return;
		
		lastInputBoxSession = new SCInputBoxSession(this,symbol,timeout);
		lastInputBoxSession.start();
	}
    
    public void doHLSensing(SCHLSensorPlugin plugin)
    {
		SCHeadlineSession s = new SCHeadlineSession(this,plugin);
		s.start();
    }
    
    public void openVanishDialog()
    {
		if (status != AVAILABLE) return;
		if (vanishDialog != null && vanishDialog.window().isVisible()) return;
		
		if (vanishDialog == null)
		{
			vanishDialog = new SCVanishWindowController(this);
		}
		vanishDialog.show();
    }
    
    public synchronized SCScriptRunner runScript(String script,boolean useMakoto) {
	return runScript(script,null,useMakoto);
    }
    public synchronized SCScriptRunner runScript(String script,Hashtable options,boolean useMakoto) {
	// ܂SHIORIŃgX[g܂B
        // useMakotofalseȂ炻̂܂܁AłȂmakotołgX[g܂B
        // i[NŃC^vgĂȂnullԂ܂B
	// AvP[VBĂԂł͏ɒ܂B
	if (script == null || script.length() == 0) return null;
	if (NSApplication.sharedApplication().isHidden()) return null;
	String s = masterSpirit.translateWithShiori(script);
        if (useMakoto) s = masterSpirit.translateWithMakoto(s);
	
        if (scrrunner == null || !scrrunner.isAlive()) {
            scrrunner = new SCScriptRunner(this,s,options);
            scrrunner.start();
            return scrrunner;
        }
        else if (scrrunner.interruptAllowed()) {
            scrrunner.terminate();
            
            scrrunner = new SCScriptRunner(this,s,options);
            scrrunner.start();
            return scrrunner;
        }
        else
        {
            return null;
        }
    }
    
    public void forceTerminateScriptRunnder()
    {
		// XNvgi[sɁA^CNeBJZbVɓĂ悤
		// I낤ƁAIterminate()s܂B
		if (scrrunner != null && scrrunner.isAlive())
		{
			scrrunner.terminate();
		}
    }
    
    public void doShioriRandomTalk()
    {
		if (masterSpirit.getShioriProtocolVersion() == 2)
			forwardToShioriKernel("GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n\r\n");
    }
    
    
    public void doShioriEvent(String eventType)
    {
		doShioriEvent(eventType,null);
    }
    
    public void doShioriEvent(String eventType,String[] references)
    {
		// SHIORIɃCxg𑗂܂B
		if (SCFoundation.LOCK_SHIORI_EVENTS) return;
		if (status != AVAILABLE) return;
		if (masterSpirit.getShiori() == null) return; // SHIORINĂȂΉȂB
		
		// ܂̓NGXg쐬B
		StringBuffer sb = new StringBuffer();
		if (masterSpirit.getShioriProtocolVersion() == 2)
		{
			sb.append("GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
			sb.append("SecurityLevel: local\r\n");
			sb.append("Event: "+eventType+"\r\n");
		}
		else
		{
			sb.append("GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
			sb.append("ID: "+eventType+"\r\n");
		}
		
		if (references != null)
		{
			for (int i = 0;i < references.length;i++)
			{
				sb.append("Reference"+i+": "+references[i]+"\r\n");
			}
		}
		sb.append("\r\n"); // NGXgB
		
		forwardToShioriKernel(sb.toString());
    }
    
    public void doShioriCommunicateFromUser(String message)
    {
		// SHIORISender: UserSentencetGET Sentence𑗂܂B
		if (masterSpirit.getShioriProtocolVersion() == 2)
			forwardToShioriKernel("GET Sentence SHIORI/2.0\r\nSender: User\r\nSentence: "+message+"\r\n\r\n");
		else
			forwardToShioriKernel("GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nID: OnCommunicate\r\nReference0: User\r\nReference1: "+message+"\r\n\r\n");
    }
    
    public void shioriResponceWork(SCShioriSessionResponce resp) {
	shioriResponceWork(resp,true);
    }
    
    public void shioriResponceWork(SCShioriSessionResponce resp,boolean wait) {
	// ̃\bh̓ZbVSHIORI FORWARD PORT,SCShellChangingSessionSCTeachSessionĂяo܂B
	// ăCXbh璼ڌĂł͂܂B
	
	// ̃\bh̓i[A
	// 1) wait == trueȂDONEɂȂ܂ŁA
	// 2) wait == falseȂSCRIPT_ENDɂȂ0.5bo߂܂ŃubN܂B
	if (status != AVAILABLE) return;
	if (resp == null) return;
	if (masterSpirit.getShiori() == null || resp == null) return;
	if (resp.getHeader().indexOf("200 OK") == -1 &&
	    resp.getHeader().indexOf("311 Not Enough") == -1 &&
	    resp.getHeader().indexOf("312 Advice") == -1) return;
	
	String script = (resp.getHeader().startsWith("SHIORI/2.") ? resp.getRespForKey("Sentence") : resp.getRespForKey("Value"));
	SCScriptRunner runner = runScript(script,true);
	if (runner == null) return;

	//if (!runner.interruptAllowed()) {
	    // C^vg֎~ȃXNvgł΁AI܂ő҂B
	    
	    while (runner.isAlive() && // i[񂾂eɊp[v߁B
		   runner.getStatus() != SCScriptRunner.DONE &&
		   runner.getStatus() != SCScriptRunner.TERMINATED) {
		try {
		    sleep((long)0.25 * 1000); // l̈buɃXe[^XB
		}
		catch (InterruptedException e) {
		    if (flagTerm) break;
		}
	    }
	    //}
	
	if (runner.getStatus() == SCScriptRunner.TERMINATED) {
	    // i[Iꂽ҂ɔB
	    return;
	}
	
	if (!wait) {
	    // 0.5bҋ@BłȂƑI߂B
	    try {
		sleep(500);
	    }
	    catch (Exception e){}
	}
	
	String to,age,sender;
	if (resp.getHeader().startsWith("SHIORI/2.")) {
	    // b鑤2.x
	    to = resp.getRespForKey("To");
	    age = resp.getRespForKey("Age");
	    sender = resp.getRespForKey("Sender");
	}
	else {
	    to = resp.getRespForKey("Reference0"); // bdl炵B
	    age = null;
	    sender = masterSpirit.getSelfName();
	}
	
	if (to != null) {
	    SCSession destSession = SCFoundation.sharedFoundation().getSession(to,false); // toZbVTĂ݂B
	    if (destSession != null && destSession != this) {
		// 瑗MBgȂ疳B
		StringBuffer buf = new StringBuffer();
		if (destSession.getMasterSpirit().getShioriProtocolVersion() == 2) {
		    // b|鑤2.x
		    buf.append("GET Sentence SHIORI/2.3\r\n");
		    buf.append("Sender: "+sender+"\r\n");
		    buf.append("Age: "+age+"\r\n");
		    buf.append("Surface: "+hontai.baseSurfaceId()+","+unyuu.baseSurfaceId()+"\r\n");
		    buf.append("Sentence: "+script+"\r\n");
		    for (int i = 0;i <= 7;i++) {
			// Reference
			String ref = resp.getRespForKey("Reference"+i);
			if (ref != null) buf.append("Reference"+i+": "+ref+"\r\n");
		    }
		    buf.append("\r\n"); // NGXg
		}
		else {
		    // b|鑤3.0
		    buf.append("GET SHIORI/3.0\r\n");
		    buf.append("Sender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
		    buf.append("ID: OnCommunicate\r\n");
		    buf.append("Reference0: "+sender+"\r\n");
		    buf.append("Reference1: "+script+"\r\n");
		    buf.append("\r\n");
		}
		destSession.forwardToShioriKernel(buf.toString()); // MZbVɃNGXg𓊂B
	    }
	}
    }
    
    public String getWordFromShiori(String type)
    {
		// typeɎw肷̂́ms,mž`B
		// ̓obNXbVł͂ȂA\u00a5Ŏw肵ĉB
		// 炩̗RŒPꂪ擾oȂnullԂ܂B
		if (masterSpirit.getShioriProtocolVersion() != 2) return null; // SHIORI/3.0ł͔p~ꂽB
		
		SCShioriSessionResponce resp = masterSpirit.doShioriSession(
				"GET Word SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nType: "+type+"\r\n\r\n");
		if (resp == null) return null;
		if (resp.getHeader().indexOf("200 OK") == -1) return null;
		
		return (String)resp.getResponce().get("Word");
    }
    
    public String getStringFromShiori(String id)
    {
		// SHIORIGET String𔭍s܂B
		// 擾ɎsnullԂ܂B
		return masterSpirit.getStringFromShiori(id);
    }
    
    public void resetSurfaces()
    {
		changeSurface(0,true);
		changeSurface(10,false);
    }
    
    public void hideBalloons()
    {
		hontai_b.hide();
        unyuu_b.hide();
    }
    
    public void showCommunicateBox()
    {
		if (isInPassiveMode()) return;
		comBox.show();
    }
    
    public void setStatusClosing()
    {
		// SCSessionChanger,SCSessionVanisherȊO͌ČĂł͂Ȃ܂B
		
		/*
			{͂ȂƂSCSessionChangerZbVɂ邱Ƃo邪A
			SCSessionChanger͏L҂łZbVIĂ܂΂肩
			̃ZbVNƂŝŁAZbVɂ邱Ƃ͕sKłB
			ȂSCSessionChangerNotification𔭍sƂ邪Aobserver̓o^/ʓ|łB
		*/
		flagClosing = true;
		
		// N
		if (!hasBootedBefore())
		{
			setGhostDefaults("has_booted_before","true");
		}
    }
    
    public void clearStatusClosing()
    {
		// SCSessionChanger,SCSessionVanisherȊO͌ČĂł͂Ȃ܂B
		flagClosing = false;
    }
    
    public boolean isStatusClosing()
    {
		return flagClosing;
    }
    
    public void performClose()
    {
		// OnClose𔭍sĒIĂZbV܂B
		if (closer != null && closer.isAlive()) return;
		
		// N
		if (!hasBootedBefore())
		{
			setGhostDefaults("has_booted_before","true");
		}
		
		flagClosing = true;
		closer = new SCSessionCloser(this);
		closer.start();
    }
    
    public void close() {
        // J[lIđSẴEChE܂B
	if (status == CLOSED) return;
	status = CLOSED;
	
	flagTerm = true; interrupt(); while(isAlive()) {}
	masterSpirit.close(); masterSpirit = null;
	currentShell.close(); currentShell = null;
	balserver = null;
	if (scrrunner != null && scrrunner.isAlive()) {
	    scrrunner.terminate();
	}
	scrrunner = null;
	tmpScriptServer = null;
	if (comBox != null) {
	    comBox.close();
	}
	comBox = null;
	if (vanishDialog != null) {
	    vanishDialog.close();
	    vanishDialog = null;
	}
	menuAppearance = null;
	if (lastShellChangingSession != null && lastShellChangingSession.isAlive()) {
	    lastShellChangingSession.terminate();
	}
	lastShellChangingSession = null;
	if (lastNetworkUpdater != null && lastNetworkUpdater.isAlive()) {
	    lastNetworkUpdater.terminate();
	}
	lastNetworkUpdater = null;
	if (lastTeachSession != null && lastTeachSession.isAlive()) {
	    lastTeachSession.terminate();
	}
	lastTeachSession = null;
	if (lastInputBoxSession != null && lastInputBoxSession.isAlive()) {
	    lastInputBoxSession.terminate();
	}
	lastInputBoxSession = null;
	hontai.close(); hontai = null;
	unyuu.close(); hontai = null;
	hontai_b.close(); hontai_b = null;
        unyuu_b.close(); unyuu_b = null;
	// SCSessionCloser͂ł͕ĒuB
	queue.clear();
    }
    
    public int getStatus()
    {
        return status;
    }
    
    public void recalcBalloonsLoc()
    {
        // o[̈ʒuČvZĈړ܂B
        int x,y;
        final int screenBottom = (int)NSScreen.mainScreen().visibleFrame().y();

		hontai_b.checkWentOut();
		x = simulateHorizLoc(true,hontai_b.isAtLeft());
        y = (int)hontai.height() - currentShell.getDescManager().getIntValue("sakura.balloon.offsety"); // MacOS X̍Wn͈ʓIPĈYtB
	
		if (y < (int)hontai_b.height() + screenBottom) y = (int)hontai_b.height() + screenBottom; // ɂ͂ݏoȂ悤ɁB
        hontai_b.setLoc(new NSPoint(x,y));
        
		unyuu_b.checkWentOut();
		x = simulateHorizLoc(false,unyuu_b.isAtLeft());
		y = (int)unyuu.height() - currentShell.getDescManager().getIntValue("kero.balloon.offsety");
		if (y < (int)unyuu_b.height() + screenBottom) y = (int)unyuu_b.height() + screenBottom;
        unyuu_b.setLoc(new NSPoint(x,y));
    }
    
    public int simulateHorizLoc(boolean isHontai,boolean left)
    {
		// o[ɒuꍇitruej܂͉Eɒuꍇifalsejł
		// o[xWvZĕԂ܂B
		if (isHontai)
		{
			if (left)
				return (int)hontai.x() - (int)hontai_b.width() + currentShell.getDescManager().getIntValue("sakura.balloon.offsetx");
			else
				return (int)hontai.x() + (int)hontai.width() - currentShell.getDescManager().getIntValue("sakura.balloon.offsetx");
		}
		else
		{
			if (left)
				return (int)unyuu.x() - (int)unyuu_b.width() + currentShell.getDescManager().getIntValue("kero.balloon.offsetx");
			else
				return (int)unyuu.x() + (int)unyuu.width() - currentShell.getDescManager().getIntValue("kero.balloon.offsetx");
		}
    }
    
    public void restartBalloonSkinServer(String balloon_path)
    {
        // balloon_path : home/balloon/...
		SCStatusWindowController stat = null;
		if (!SCFoundation.isHereMainThread())
		{
			stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
			stat.setTypeToText();
			stat.show();
			stat.texttype_print("restarting balloon server...\n");
		}
		
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		
        // o[XLT[o[ċNāA̃o[setBalloonServer𑗂܂B
        balserver = SCFoundation.sharedFoundation().getBalloonServer(balloon_path,stat);
		hontai_b.setBalloonServer(balserver);
		unyuu_b.setBalloonServer(balserver);
        
        recalcBalloonsLoc();
		
		if (stat != null)
		{
			stat.texttype_print("%[color,white]restarted.%[color,default]");
			stat.closeWindow();
		}
    }
    
    public void resizeShell(double ratio)
    {
        currentShell.getSurfaceServer().resizeSurfaces(ratio);
        
        hontai.surfaceResized(currentShell.getSurfaceServer(),ratio);
        unyuu.surfaceResized(currentShell.getSurfaceServer(),ratio);
        
        recalcBalloonsLoc();
    }
    
    public boolean isScriptRunnerProtected()
    {
        // ݃XNvgi[NĂāA^CNeBJZbVA
        // ύXsƂtrueԂ܂B
        
        if (scrrunner != null)
        {
            return (scrrunner.isAlive() && !scrrunner.interruptAllowed());
        }
        
        return false;
    }
    
    public boolean checkMikire()
    {
		// {̑T[tBXʂ甼ȏ͂ݏoĂtrueԂ܂B
		if (hontai == null) return false;
		
		final int screenWidth = (int)NSScreen.mainScreen().frame().width();
		return (hontai.x() < hontai.width() / 2 || hontai.x() + hontai.width() - screenWidth > hontai.width() / 2);
    }
    
    public boolean checkKasanari()
    {
		// dȂ蕔̕{̖͂ɂイ̏80%zĂtrueԂ܂B
		if (hontai == null || unyuu == null) return false;
		
		float slimmer_width = (hontai.width() > unyuu.width() ? unyuu.width() : hontai.width());
		NSRect intersection = hontai.frame().rectByIntersectingRect(unyuu.frame());
		if (intersection == NSRect.ZeroRect) return false;
	
		return (intersection.width() > slimmer_width * (80.0 / 100.0));
    }
    
    public void forceMovingNextToAnother(int type)
    {
		// typeŎw肳ꂽT[tBẌׂ̗ʒu܂ŋړB
		// 4yс5̋@\BƂ̂̓͕ʂĂ̂낤B
		SCShellWindowController target = (type == SCFoundation.HONTAI ? hontai : unyuu);
		SCShellWindowController against = (type == SCFoundation.HONTAI ? unyuu : hontai);
	
		// Ƃ肠ɓĂ݂āA؂ȂEɈړB
		float x = against.x() - target.width();
		if (x < target.width() / 2)
		{
			x = against.x() + against.width();
		}
		target.setHorizLoc(x);
		
		// ړm
		shellWindowMoved(target);
    }
    
    public void shellWindowMoved(SCShellWindowController window)
    {
        // VFEChÊǂ炩hbOꂽɌĂ΂܂B
        //String entry_name = (window == hontai ? "shell_window hontai x" : "shell_window unyuu x");
		String entry_name = "shell_window."+currentShell.getDirName()+"."+(window == hontai ? "sakura" : "kero")+".x";
        
        SCGhostManager ghostManager = SCGhostManager.sharedGhostManager();
        NSMutableDictionary ghostDefaults = ghostManager.getGhostDefaults(getGhostPath());
        
        ghostDefaults.setObjectForKey(new Integer((int)window.x()),entry_name);
        
        ghostManager.setGhostDefaults(getGhostPath(),ghostDefaults);
    }
    
    public String getGhostMasterDirPath() {
        File ghost_root = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
        File f = new File(ghost_root,"ghost/master");
        return f.getPath();
    }
    
    public String getShellDirName() {
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	String shelldir = (String)ghostDefaults.objectForKey("shell_dirname");
	File ghost_root = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
	
	if (shelldir == null || shelldir.length() == 0) {
	    File master = new File(ghost_root,"shell/master");
	    if (master.exists()) {
		return "master";
	    }
	    else { // shell/master̂œKȕIԁB
		File shell = new File(ghost_root,"shell");
		File[] shells = shell.listFiles();
		int choice;
		while (true) {
		    choice = (int)((Math.random() * 10000) % shells.length);
		    if (shells[choice].isDirectory()) break;
		}
		return shells[choice].getName();
	    }
	}
	else {
	    File dir = new File(ghost_root,"shell/"+shelldir);
	    if (!dir.exists() || !dir.isDirectory()) {
		File master = new File(ghost_root,"shell/master");
		if (master.exists()) {
		    return "master";
		}
		else { // shell/master̂œKȕIԁB
		    File shell = new File(ghost_root,"shell");
		    File[] shells = shell.listFiles();
		    int choice;
		    while (true) {
			choice = (int)((Math.random() * 10000) % shells.length);
			if (shells[choice].isDirectory()) break;
		    }
		    return shells[choice].getName();
		}
	    }
	    else {
		return shelldir;
	    }
	}
    }
    
    public int getHorizontalLocationOfShell(String shellDirName,int type)
    {
		// shellDirName: ʒu擾VF̃fBNg
		// type: SCFoundation.SAKURA or SCFoundation.KERO
		// ̃\bhdefaultsushell_window.${shellDirName}.{sakura|kero}.xvǂ݂܂A
		// ꂪtȂ΁ushell_window {hontai|kero} xvA
		// Ό݂̃XN[̕ZolԂ܂B
		NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
		Object int_x = ghostDefaults.objectForKey("shell_window."+shellDirName+"."+(type == SCFoundation.SAKURA ? "sakura" : "kero")+".x");
		if (int_x != null)
		{
			return (int_x instanceof Integer ? ((Integer)int_x).intValue() : (int)((Long)int_x).longValue());
		}
		else if (type == SCFoundation.SAKURA)
		{
			return (int)(NSScreen.mainScreen().frame().width() - hontai.width());
		}
		else
		{
			return (int)(getHorizontalLocationOfShell(shellDirName,SCFoundation.SAKURA) - unyuu.width()); // ċA
		}
    }
    
    public void changeToOtherGhostAtRandom()
    {
		// _ɑ̃S[XgƑւB
		// Ɉ΂IB
		String nextPath = SCFoundation.sharedFoundation().getAnyGhostPathInAsleep();
		if (nextPath == null)
		{
			SCGhostManager.sharedGhostManager().forceHaltGhost(this);
		}
		else
		{
			String nextBalloonPath = SCGhostManager.sharedGhostManager().getBalloonPathOfGhost(nextPath);
			double nextScale = SCGhostManager.sharedGhostManager().getScaleOfGhost(nextPath);
			
			SCSessionChanger sc = new SCSessionChanger(this,nextPath,nextBalloonPath,nextScale);
			sc.start();
		}
    }
    
    public boolean isShellChangingSessionRunningNow()
    {
		return (lastShellChangingSession != null && lastShellChangingSession.isAlive());
    }
    
    public boolean isNetworkUpdaterRunningNow()
    {
		return (lastNetworkUpdater != null && lastNetworkUpdater.isAlive());
    }
    
    public boolean isSessionCloserRunningNow()
    {
		return (closer != null && closer.isAlive());
    }
    
    public SCScriptServer getTempScriptServer()
    {
		return tmpScriptServer;
    }
    
    public SCSafetyBalloonController getHontaiBalloon()
    {
        return hontai_b;
    }
	public SCSafetyBalloonController getSakuraBalloon()
    {
        return hontai_b;
    }
    
    public SCSafetyBalloonController getUnyuuBalloon()
    {
        return unyuu_b;
    }
	public SCSafetyBalloonController getKeroBalloon()
    {
        return unyuu_b;
    }
    
    public SCShellWindowController getSakura()
    {
		return hontai;
    }
    public SCShellWindowController getHontai()
    {
        return hontai;
    }
    
    public SCShellWindowController getKero()
    {
		return unyuu;
    }
    public SCShellWindowController getUnyuu()
    {
        return unyuu;
    }
    
    public SCScriptRunner getScriptRunner()
    {
        return scrrunner;
    }
    
    public SCBalloonSkinServer getBalloonServer()
    {
        return balserver;
    }
    
    public String getGhostPath()
    {
        return ghost_path;
    }
    
    public File getGhostDir()
    {
		return ghost_dir;
    }
    
    public SCSpirit getMasterSpirit()
    {
		return masterSpirit;
    }
    
    public SCShell getCurrentShell()
    {
		return currentShell;
    }
    
    public SCShellContextMenuMaker getShellContextMenuMaker()
    {
		return shellContextMenuMaker;
    }
    
    public SCMenuAppearanceServer getMenuAppearance()
    {
		return menuAppearance;
    }
    
    public String getSelfName() {
	// VFŃI[o[ChĂ炻AĂȂmaster ghost擾ĕԂB
	return (currentShell.getSelfName() == null ? masterSpirit.getSelfName() : currentShell.getSelfName());
    }
    
    public String getKeroName() {
	return (currentShell.getKeroName() == null ? masterSpirit.getKeroName() : currentShell.getKeroName());
    }

    public String getCurrentIdentification() {
	// ݎgp̃VFՎIDĂ΂A
	// ΃S[XgIDԂB
	String shell_id = currentShell.getIdentification();
	if (shell_id != null) {
	    return shell_id;
	}
	return masterSpirit.getIdentification();
    }
    
    public File getReadmeFile()
    {
		return readmeFile;
    }
}
