/*  $Id: SCShellView.java,v 1.7 2004/02/05 09:29:35 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCShellView extends NSView {
    SCShellWindowController swc;
    NSImage base;
    Vector layers;
    
    public SCShellView(NSRect r) {
	super(r);
	swc = null;
	base = null;
	layers = new Vector();
    }
    
    public void initialize(SCShellWindowController swc) {
	this.swc = swc;
    }
    
    public void cleanUp() {
	swc = null;
	base = null;
	layers.clear();
    }
    
    public boolean acceptsFirstMouse(NSEvent theEvent) {
	return true;
    }
    
    public void drawRect(NSRect r) {
	if (base == null) {
	    NSColor.clearColor().set();
	    NSGraphics.fillRectList(new NSRect[] {r});
	}
	else {
	    base.compositeToPoint(NSPoint.ZeroPoint,NSImage.CompositeCopy);
	    
	    int n_layers = layers.size();
	    for (int i = 0;i < n_layers;i++) {
		SCShellLayer layer = (SCShellLayer)layers.elementAt(i);
		layer.draw();
	    }
	}
    }
    
    public void changeSurface(NSImage img) {
	// imgnullłǂȀꍇ̓T[tBX܂B
        base = img;
    }
    
    public SCShellLayer addLayer(SCSurfaceServer sserver,int surfaceid,int seqid,NSPoint loc,boolean visible) {
	// C[V[PXIDɉʒuɑ}ÃC[Ԃ܂B
	
	// gp\IDT
	int id = 0;
	int n_layers = layers.size();
	for (int i = 0;i < n_layers;i++) {
	    for (int j = 0;j < n_layers;j++) {
		SCShellLayer layer =
		    (SCShellLayer)layers.elementAt(j);
		
		if (layer.id() == id) {
		    id++;
		}
	    }
	}
	SCShellLayer layer =
	    new SCShellLayer(swc,id,sserver,surfaceid,seqid,loc,visible);
	
	// }
	boolean inserted_flag = false;
	for (int i = 0;i < n_layers;i++) {
	    // ̃V[PXID傫ȒlC[ꂽA̐^ɑ}B
	    SCShellLayer l = (SCShellLayer)layers.elementAt(i);
	    
	    if (l.seqid() > seqid) {
		layers.insertElementAt(layer,i);
		inserted_flag = true;
		break;
	    }
	}
	if (!inserted_flag) { // }𖞂ĂȂ
	    // PɈԏɏB
	    layers.add(layer);
	}
	return layer;
    }
    
    public void removeLayer(SCShellLayer l) {
	// C[폜܂B
	int id = l.id();
	
	int n_layers = layers.size();
	for (int i = 0;i < n_layers;i++) {
	    SCShellLayer layer = (SCShellLayer)layers.elementAt(i);
	    
	    if (layer.id() == id) {
		layers.removeElementAt(i);
		break;
	    }
	}
    }
    
    public NSMenu menuForEvent(NSEvent e) { // OSĂ΂܂B
	if (swc.session().isInPassiveMode()) return null;
	SCShellContextMenuMaker scmm = swc.session().getShellContextMenuMaker();
	
	scmm.reconstructMenu(swc.getType());
	return scmm.getMenu(swc.getType());
    }
}
