/*  $Id: SCShellsList.java,v 1.6 2004/01/20 17:34:16 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

/*
    FIXME: ̂ƂSCShellsList̃CX^X͈pӂĎg񂵂Ă邪A
    {ȂSCInstalledGhostsListڐ̃CX^XĂׂB
    ReNXgj[JтɃfBNg\descript.txtǂݒHڂɂȂB
*/

public class SCShellsList implements NSTableView.DataSource {
    Vector list; // gSCShellsList.ListsElementB
    int selected_item = 0; // WI{^őIĂ鍀ځB
    
    SCGhostManager ghostManager;
    
    private static final NSSelector selector_changeShellTo;
    static {
	selector_changeShellTo = new NSSelector("changeShellTo",new Class[] {Object.class});
    }
    
    public SCShellsList(SCGhostManager ghostManager) {
	this.ghostManager = ghostManager;
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        NSTableView tableView = windowController.getTableShells();
	
	tableView.setDataSource(this);
	
	NSButtonCell bc = new NSButtonCell();
        bc.setButtonType(NSButtonCell.RadioButton);
        bc.setTitle("");
        
        NSTableColumn tc = tableView.tableColumnWithIdentifier("select");
        if (tc == null) System.out.println(
	    "SCShellsList error : The table doesn\'t have a NSTableColumn named \"select\".");
        
        tc.setDataCell(bc);
        
        list = new Vector();
    }
    
    public void setEnabled(boolean bool) {
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        
        NSTableView tableView = windowController.getTableShells();
        NSTableColumn tc;
        
        tc = tableView.tableColumnWithIdentifier("select");
        tc.dataCell().setEnabled(bool);
	//tableView.display();
	tableView.setNeedsDisplay(true);
    }
    
    public void setContent(String ghost_root) {
	// ghost_root : home/ghost/[ghostname]
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
	windowController.getTableShells().deselectAll(this);
        list.clear();
        
        // fBNg\ǂŃXg\܂B
	String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
	File shellDir = new File(bundleDir,ghost_root+"/shell");
	File[] shells = shellDir.listFiles();
	for (int i = 0;i < shells.length;i++) {
	    if (!shells[i].isDirectory()) continue;
	    
	    File descript_txt = new File(shells[i],"descript.txt");
	    if (!descript_txt.exists()) continue; // descript.txtB
	    
	    // ̒ɂdescript.txtǂށB
	    SCDescription desc = new SCDescription(descript_txt);
	    String shellname = desc.getStrValue("name");
	    String dirname = shells[i].getName();
	    
	    list.add(new ListsElement(shellname,dirname));
	}
	
	windowController.getTableShells().reloadData();
    }
    
    public void selectShell(String shelldir) {
        // fBNgŎw肳ꂽVFIт܂B
        // ȂI܂B
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int n_items = list.size();
        int found_id = -1;
        for (int i = 0;i < n_items;i++) {
            if (shelldir.equals( ((ListsElement)list.elementAt(i)).getDirName() )) {
		// 
		found_id = i;
		break;
	    }
        }
	if (found_id == -1) {
	    selected_item = -1;
	    windowController.getTableShells().reloadData();
	    return;
	}
        selected_item = found_id;
        
        NSTableView tableView = windowController.getTableShells();
        tableView.reloadData();
        tableView.scrollRowToVisible(found_id);
    }
    
    public NSMenu makeShellMenu(SCSession self) {
	NSMenu submenu = new NSMenu();
	submenu.setAutoenablesItems(false);
	
	// fBNg\ǂŃXg\܂B
	String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
	File shellDir = new File(bundleDir,self.getGhostPath()+"/shell");
	File[] shells = shellDir.listFiles();
	for (int i = 0;i < shells.length;i++) {
	    if (!shells[i].isDirectory()) continue;
	    
	    // ̒ɂdescript.txtǂށB
	    SCDescription desc = new SCDescription(new File(shells[i],"descript.txt"));
	    String shellname = desc.getStrValue("name");
	    String dirname = shells[i].getName();
	    
	    ShellMenuItem item = new ShellMenuItem(self,shellname == null ? dirname : shellname,dirname);
	    item.setAction(selector_changeShellTo);
	    item.setTarget(this);
	    item.setState(self.getCurrentShell().getDirName().equals(dirname) ? NSCell.OnState : NSCell.OffState);
	    item.setEnabled(item.state() != NSCell.OnState);
	    
	    submenu.addItem(item);
	}
	
	return submenu;
    }
    
    public void changeShellTo(Object sender) {
	// j[Ă΂ActionłB
	if (!(sender instanceof ShellMenuItem)) return;
	ShellMenuItem smi = (ShellMenuItem)sender;
	
	ghostManager.getInstalledList().changeShellOfGhost(smi.getSelf().getGhostPath(),smi.getDirName());
    }
    
    private class ListsElement {
	String name;
	String dirname;
	
	public ListsElement(String name,String dirname) {
	    this.name = name;
	    this.dirname = dirname;
	}
	
	public String getName() {
	    return name;
	}
	
	public String getDirName() {
	    return dirname;
	}
    }
    
    private class ShellMenuItem extends NSMenuItem {
	SCSession self;
	String dirname;
	
	public ShellMenuItem(SCSession self,String name,String dirname) {
	    super(name,null,"");
	    
	    this.self = self;
	    this.dirname = dirname;
	}
	
	public SCSession getSelf() {
	    return self;
	}
	
	public String getDirName() {
	    return dirname;
	}
    }
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
        if (list == null) return 0;
        return list.size();
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return false;
    }
    
    public void tableViewSortDescriptorsDidChange(
        NSTableView tableView,
        NSArray rows) {
        // optional
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex) {
	
        String column_id = (String)aTableColumn.identifier();
        if (column_id.equals("select")) {
            return new Integer( selected_item == rowIndex ? 1 : 0 );
        }
        
        // selectłȂnameB
        ListsElement elem = (ListsElement)list.elementAt(rowIndex);
	return (elem.getName() == null ? elem.getDirName() : elem.getName());
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
	
        String column_id = (String)aTableColumn.identifier();
        
        if (column_id.equals("select")) {
            selected_item = rowIndex;
            aTableView.reloadData();
            
	    String dirname = ((ListsElement)list.elementAt(rowIndex)).getDirName();
            ghostManager.getInstalledList().changeShellOfCurrentGhost(dirname);
        }
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
        // optional
        return false;
    }
}
