/*  $Id: SCSurface.java,v 1.9 2004/04/13 10:31:51 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import util.*;

public class SCSurface {
    /*
      ꖇ̃T[tBX\NXłB
      T[tBXpngf[^A`s.txtA`a.datt@C܂B
    */
    NSImage rawImage; // null͈̎kꂽNSImagecompressedImageɓĂB
    NSData compressedImage;
    NSSize originalSize;
    int id;
    Vector collisions; // gSCSurfaceCollisionB
    double ratio;
    
    public SCSurface(File f,int id,SCBlockedDescription comprehensiveDefinitions) {
	// f : png܂dgpt@Cւ̃pX
	// comprehensiveDefinitions : 蔻BnullȂs.txtǂށB
	this.id = id;
	if (!f.exists()) return;
		
	// png[hč̍WŐFBɃAt@`lB
	NSImage image_original;
	if (f.getName().toLowerCase().endsWith(".dgp")) {
	    image_original = DGPLoader.load(f);
	}
	else {
	    image_original = new NSImage(f.getPath(),true);
	}
	NSImage image = SCAlphaConverter.convertImage(image_original);
		
	// pna݂邩H
	File pnaFile = new File(NSPathUtilities.stringByDeletingPathExtension(f.getPath()) + ".pna");
	if (pnaFile.exists()) {
	    // pna[hăAt@`lɃRs[
	    NSImage pna = new NSImage(pnaFile.getPath(),true);
	    SCAlphaConverter.attachAlphaToImage(pna,image);
	}
		
	image.setScalesWhenResized(false);
	originalSize = image.size();
		
	/*int width = (int)image.size().width();
	  int height = (int)image.size().height();*/
		
	// k
	if (SCFoundation.COMPRESS_SURFACES_ON_MEMORY) {
	    compressedImage = compressImage(image);
	    image = null;
	    if (SCFoundation.DO_EXPLICIT_GC) {
		System.gc();
	    }
	}
	else {
	    rawImage = image;
	}
		
	// 蔻
	collisions = new Vector();
	if (comprehensiveDefinitions == null) {
	    File sfile = new File(NSPathUtilities.stringByDeletingPathExtension(f.getPath()) + "s.txt");
	    if (!sfile.exists()) return;
	    loadCollisionsFromIndividualFile(sfile);
	}
	else {
	    Object defs = comprehensiveDefinitions.get(NSPathUtilities.stringByDeletingPathExtension(f.getName()));
	    if (defs == null || !(defs instanceof Vector)) {
		defs = comprehensiveDefinitions.get("surface"+id);
	    }
	    if (defs != null && defs instanceof Vector) {
		loadCollisions((Vector)defs);
	    }
	}
    }
    
    public SCSurface(NSImage image,int id,Vector definitions) {
	// definitions : surfaces.txt̗vf
	this.id = id;
	
	image.setScalesWhenResized(false);
	originalSize = image.size();
	
	// k
	if (SCFoundation.COMPRESS_SURFACES_ON_MEMORY) {
	    compressedImage = compressImage(image);
	    image = null;
	    if (SCFoundation.DO_EXPLICIT_GC) {
		System.gc();
	    }
	}
	else {
	    rawImage = image;
	}
	
	// 蔻
	collisions = new Vector();
	loadCollisions(definitions);
    }
    
    protected void loadCollisionsFromIndividualFile(File sfile) {
	// s.txtt@C瓖蔻f[^ǂށB
	try {
	    BufferedReader br = null;
	    br = new BufferedReader(new InputStreamReader(new FileInputStream(sfile),"SJIS"));
	    
	    Vector valid_defs = new Vector();
	    while (true) {
		String line = br.readLine();
				
		if (line == null) break;
		if (line.indexOf(',') == -1) continue;
		if (line.startsWith("#")) continue;
				
		valid_defs.add(line);
	    }
	    loadCollisions(valid_defs);
	    
	    br.close();
	}
	catch(Exception e) {
	    System.err.println("SCSurface : exception occured in loading collision data from "+sfile.getName());
	    e.printStackTrace();
	}
    }
    
    protected void loadCollisions(Vector definitions) {
	// definitions : <String>蔻`s̏WB
	// 蔻`łȂڂ܂܂Ă琳B
	int width = (int)rawImage.size().width();
	int height = (int)rawImage.size().height();
		
	final int n_defs = definitions.size();
	for (int i = 0;i < n_defs;i++) {
	    String line = (String)definitions.elementAt(i);
	    
	    int comma_pos = line.indexOf(',');
	    if (comma_pos == -1) {
		continue;
	    }
	    String label = line.substring(0,comma_pos);
	    String data = line.substring(comma_pos+1);
	    
	    // collision̂ݔFB͎̂ĂBcollision͐V`^`ǂłǂށB
	    if (label.startsWith("collision")) {
		if (label.startsWith("collision.")) {
		    // ^Cv
		    try {
			String name = label.substring(label.indexOf('.')+1);
			if (name.equals("head")) {
			    name = "Head";
			}
			else if (name.equals("face")) {
			    name = "Face";
			}
			else if (name.equals("bust")) {
			    name = "Bust";
			}
			StringTokenizer st = new StringTokenizer(data,",");
			int left = Integer.parseInt(st.nextToken());
			int top = Integer.parseInt(st.nextToken());
			int right = Integer.parseInt(st.nextToken());
			int bottom = Integer.parseInt(st.nextToken());
			
			// Wn̍قl܂B
			collisions.add(new SCSurfaceCollision(new NSRect(left,height-bottom,right-left,bottom-top),name));
		    }
		    catch (Exception e) { continue; }
		}
		else {
		    // V^Cv
		    StringTokenizer st = new StringTokenizer(data,",");
		    try {
			int left = Integer.parseInt(st.nextToken());
			int top = Integer.parseInt(st.nextToken());
			int right = Integer.parseInt(st.nextToken());
			int bottom = Integer.parseInt(st.nextToken());
			String name = st.nextToken();
			
			// Wn̍قl܂B
			//System.out.println(left+","+(height-bottom)+","+(right-left)+","+(bottom-top)+" : "+name);
			collisions.add(new SCSurfaceCollision(new NSRect(left,height-bottom,right-left,bottom-top),name));
		    }
		    catch (Exception e) { continue; }
		}
	    }
	}
    }

    protected static NSData compressImage(NSImage src) {
	NSBitmapImageRep rep = (NSBitmapImageRep)src.representations().objectAtIndex(0);
	NSMutableData result = new NSMutableData();
	byte[] header = new byte[10]; // 4:height 4:width 2:spp
	int width = rep.pixelsWide();
	int height = rep.pixelsHigh();
	int spp = rep.samplesPerPixel();
	header[0] = (byte)((width >> 24) & 0x000000ff);
	header[1] = (byte)((width >> 16) & 0x000000ff);
	header[2] = (byte)((width >>  8) & 0x000000ff);
	header[3] = (byte)((width      ) & 0x000000ff);
	header[4] = (byte)((height >> 24) & 0x000000ff);
	header[5] = (byte)((height >> 16) & 0x000000ff);
	header[6] = (byte)((height >>  8) & 0x000000ff);
	header[7] = (byte)((height      ) & 0x000000ff);
	header[8] = (byte)((spp >>  8) & 0x000000ff);
	header[9] = (byte)((spp      ) & 0x000000ff);
	result.appendData(new NSData(header));
	result.appendData(new NSData(rep.bitmapData()));
	return result;
    }
    
    protected static NSImage decompressImage(NSData src) {
	byte[] header = src.bytes(0,10); // 4:height 4:width 2:spp
	int width = header[0] << 24 | header[1] << 16 | header[2] << 8 | header[3];
	int height = header[4] << 24 | header[5] << 16 | header[6] << 8 | header[7];
	int spp = header[8] << 8 | header[9];
	NSImage image = new NSImage();
	NSBitmapImageRep bitmap = new NSBitmapImageRep(
	    width,
	    height,
	    spp,
	    4,
	    true,
	    false,
	    NSGraphics.CalibratedRGBColorSpace,
	    0,
	    0);
	bitmap.setBitmapData(src.bytes(10,src.length()-10));
	image.addRepresentation(bitmap);
	return image;
    }
    
    public NSImage getImage() {
	if (rawImage == null) {
	    // compresed
	    NSImage decompressedImage = decompressImage(compressedImage);
	    
	    NSSize newsize = new NSSize( (float)(originalSize.width() * ratio) , (float)(originalSize.height() * ratio) );
	    if (ratio > 1.0) decompressedImage.setSize(newsize);
	    
	    NSImageRep rep = (NSImageRep)decompressedImage.representations().objectAtIndex(0);
	    rep.setSize(newsize);
	    
	    return decompressedImage;
	}
	else {
	    return rawImage;
	}
    }
    
    public int getID() {
        return id;
    }
    
    public NSSize getOriginalSize() {
	return originalSize;
    }
    
    public void resize(double ratio) {
	this.ratio = ratio;
        if (rawImage == null) return;
	
        NSSize newsize = new NSSize( (float)(originalSize.width() * ratio) , (float)(originalSize.height() * ratio) );
        if (ratio > 1.0) rawImage.setSize(newsize);
	
	NSImageRep rep = (NSImageRep)rawImage.representations().objectAtIndex(0);
	rep.setSize(newsize);
    }
    
    public String getCollisionNameAt(NSPoint pt) {
	// ȂnullԂB
	int n_cols = collisions.size();
	for (int i = 0;i < n_cols;i++) {
	    SCSurfaceCollision col = (SCSurfaceCollision)collisions.elementAt(i);
	    
	    if (col.rect().containsPoint(pt,false)) {
		return col.name();
	    }
	}
	return null;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("rawImage: {").append(
	    rawImage.toString().trim()).append('}');
	buf.append("; id: ").append(id);
	buf.append("; ratio: ").append(ratio);
	return buf.toString();
    }

    protected void finalize() {
	//Logger.log(this, Logger.DEBUG, "finalized");
    }
}
