/*  $Id: SCTimeEventTriggerDaemon.java,v 1.2 2003/12/24 06:02:13 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCTimeEventTriggerDaemon extends Thread {
    Calendar calendar;
    
    int lastComparedHour;
    int lastComparedMinute;
    int lastComparedSecond;
    
    volatile boolean signal_stop = false;
    
    public SCTimeEventTriggerDaemon() {
	calendar = Calendar.getInstance();
	
	lastComparedMinute = calendar.get(Calendar.MINUTE);
	lastComparedSecond = calendar.get(Calendar.SECOND);
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	
	while (!signal_stop) {
	    int inner_pool = NSAutoreleasePool.push();
	    
	    // Calendar𐳂ɃZbg
	    Date d = calendar.getTime();
	    d.setTime(System.currentTimeMillis());
	    calendar.setTime(d);
	    
	    if (lastComparedMinute != calendar.get(Calendar.MINUTE)) {
		// On(Minute|Second)Change : Ref0=AN(hour) , Ref1=؂tO(0|1) , Ref2=dȂtO(0|1) , Ref3=cantalktO(0|1)
		Vector sa = SCFoundation.sharedFoundation().getSessionsList();
		final int n_sa = sa.size();
		for (int i = 0;i < n_sa;i++) {
		    SCSession session = (SCSession)sa.elementAt(i);
		    session.doShioriEvent(
			"OnMinuteChange",
			new String[] {
				Integer.toString(session.hoursFromBootTime()),
				session.checkMikire() ? "1" : "0",
				session.checkKasanari() ? "1" : "0",
				session.isInPassiveMode() || NSApplication.sharedApplication().isHidden() ? "0" : "1"
				}
			);
		}
		lastComparedMinute = calendar.get(Calendar.MINUTE);
	    }
	    if (lastComparedSecond != calendar.get(Calendar.SECOND)) {
		Vector sa = SCFoundation.sharedFoundation().getSessionsList();
		final int n_sa = sa.size();
		for (int i = 0;i < n_sa;i++) {
		    SCSession session = (SCSession)sa.elementAt(i);
		    session.doShioriEvent(
			"OnSecondChange",
			new String[] {
				Integer.toString(session.hoursFromBootTime()),
				session.checkMikire() ? "1" : "0",
				session.checkKasanari() ? "1" : "0",
				session.isInPassiveMode() || NSApplication.sharedApplication().isHidden() ? "0" : "1"
			}
		    );
		}
		lastComparedSecond = calendar.get(Calendar.SECOND);
	    }
	    
	    try {
		sleep(300); // 0.3bԃX[v
	    }
	    catch (InterruptedException e) {}

	    NSAutoreleasePool.pop(inner_pool);
	}
	
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate() {
	if (!isAlive()) return;
	signal_stop = true;
	interrupt();
	while (isAlive()) {;}
    }
}
