/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawkput

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya;
import aya.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;

// #defineや#globaldefineの処理。
// 行の結合もここで行なう。

public class Preprocessor {
    protected static Hashtable global; // {検索文字列 => 置換文字列}
    static {
	global = new Hashtable();
    }
    
    BufferedReader br;
    Hashtable local; // {検索文字列 => 置換文字列}
    
    public Preprocessor(BufferedReader br) {
	this.br = br;
	this.local = new Hashtable();
    }
    
    public String doIt() throws Exception {
	StringBuffer result = new StringBuffer();
	
	Pattern define = Pattern.compile("^\\s*#define\\s+(.+?)\\s+(.+?)\\s*$");
	Pattern globaldefine = Pattern.compile("^\\s*#globaldefine\\s+(.+?)\\s+(.+?)\\s*$");
	
	// *** Java 1.4.2のjava.util.regexにはバグが！！ この\uffffを消すとマルチバイト文字が一切マッチしなくなる！！
	Pattern broken_string_a = Pattern.compile("^\\s*\"([^\uffff\"]*?)\\s*$");
	Pattern broken_string_b = Pattern.compile("^\\s*([^\uffff\"]*?)\"\\s*$");
	
	while (true) {
	    String line = br.readLine();
	    if (line == null) {
		break;
	    }
	    
	    // 行が'/'で終わっている場合は、それが//や*/でない限り行の連結と考える。
	    while (line.trim().endsWith("/") &&
		   !(line.trim().endsWith("//") || line.trim().endsWith("*/"))) {
		
		line = line.substring(0,line.length()-1);
		
		String next = br.readLine();
		if (next == null) {
		    break;
		}
		else {
		    // 行頭の空白文字は消す。
		    for (int pos = 0; pos < next.length(); pos++) {
			if (!Character.isWhitespace(next.charAt(pos))) {
			    line += next.substring(pos);
			    break;
			}
		    }
		}
	    }
	    
	    // 行が文字列定数だけで構成されている場合、その前後のダブルクォートが欠けていても補完する。
	    // グァーーーーーーーーーーーー！！！！！！！！！！！！
	    // もうゴールしてもいいよね…
	    Matcher matcher;
	    if ((matcher = broken_string_a.matcher(line)).find()) {
		line = '"'+matcher.group(1)+'"';
	    }
	    else if ((matcher = broken_string_b.matcher(line)).find()) {
		line = '"'+matcher.group(1)+'"';
	    }
	    
	    if ((matcher = define.matcher(line)).find()) {
		local.put(matcher.group(1),matcher.group(2));
	    }
	    else if ((matcher = globaldefine.matcher(line)).find()) {
		global.put(matcher.group(1),matcher.group(2));
	    }
	    else {
		StringBuffer buf = new StringBuffer(line);
		
		Hashtable[] tables = new Hashtable[] {local,global};
		for (int i = 0; i < tables.length; i++) {
		    for (Enumeration keys = tables[i].keys(); keys.hasMoreElements(); ) {
			String key = (String)keys.nextElement();
			String value = (String)tables[i].get(key);

			int pos = 0;
			while (pos < buf.length()) {
			    int idx = buf.indexOf(key, pos);
			    if (idx == -1) {
				break;
			    }
			    else {
				buf.replace(idx,idx + key.length(),value);
				pos = idx + value.length();
			    }
			}
		    }
		}
		
		result.append(buf.toString()).append('\n');
	    }
	}
	
	return result.toString();
    }
}
