/*  $Id: Evaluator.java,v 1.2 2004/01/29 20:59:02 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.util.*;

public class Evaluator {
    Misaka misaka;
    
    public Evaluator(Misaka misaka) {
	this.misaka = misaka;
    }
    
    public String evaluate(String src) {
	if (src == null) return "";
	if (src.length() == 0) return "";

	try {
	    return evaluate(src, false);
	}
	catch (Exception e) {
	    throw new RuntimeException(
		"Evaluation failed: `"+src+"'", e);
	}
    }
    private String evaluate(String src, boolean isPure) {
	//System.out.println(src);
	// isPure : src{Ŏn܂}ŏIĂ邩ǂB
	if (isPure) {
	    String content = src.substring(1,src.length()-1).trim();
	    /*
	      擪1ĂB
	      $Ŏn܂ĂȂ : ̂܂ܕԂ
	      Jʂ : ֐܂͍\	
	      ++,-- : CNg/fNg		
	      +=,-=,*=,/= : 揜
	      CR[ : 
	      ȊO : ϐQ
	    */
	    if (!content.startsWith("$")) {
		return evaluate(content,false); // {܂_{$ahya}}
	    }
	    
	    for (int i = 0; i < content.length() ;i++) {
		if (content.startsWith("{", i)) {
		    // q̃ubN
		    String inner = getOutmostNest(content,'{','}',i);
		    String evaluated;
		    try {
			evaluated = evaluate(inner,true);
		    }
		    catch (Exception e) {
			throw new RuntimeException(
			    "Evaluation failed: inner block `"+inner+"'", e);
		    }
		    // content蒼B
		    String before = content;
		    content =
			content.substring(0, i) +
			evaluated +
			content.substring(i + inner.length());
		    //System.out.println("Inner `"+before+"' => `"+content+"'");
		    i += evaluated.length() - 1;
		    continue;
		}
		else if (content.startsWith("(", i)) {
		    // ֐
		    String func_name = content.substring(0,i).trim();
		    if (func_name.equals("$if")) {
			// $if͓Bif\B
			return evaluateSyntaxIf(content);
		    }
		    else if (func_name.equals("$calc")) {
			// $calc̈B
			return evaluateFunctionCalc(content);
		    }
		    else if (func_name.equals("$imitationif")) {
			// $imitationifxɑSĂ̎]Ă܂Ȃ̂œB
			return evaluateFunctionCall(content,false);
		    }
		    else {
			return evaluateFunctionCall(content,true);
		    }
		}
		else if (content.startsWith("[",i)) {
		    // zϐ̗vf肵Q
		    String varname = content.substring(0,i).trim();
		    Variable v = misaka.getDictionary().findVariable(varname,true); // tȂ]
		    if (v == null) {
			return "";
		    }
		    else {
			try {
			    int blockstart = i;
			    int blockend = content.indexOf(']',i);
			    int index = Integer.parseInt(content.substring(blockstart+1,blockend));
			    return v.getContentAtIndex(index);
			}
			catch (Exception e) {
			    System.err.println("misaka.Evaluator#evaluate :");
			    System.err.println("  illegal reference of array : "+content);
			    return "";
			}
		    }
		}
		else if (content.startsWith("+=",i)) {
		    // Zđ
		    String left = content.substring(0,i).trim();
		    String right = content.substring(i+2).trim();
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(left);
		    String value_to_operate = evaluateExpression(right);
		    misaka.getDictionary().putUserVariable(
			left,
			Integer.toString(
			    interpretAsInteger(old_value) + interpretAsInteger(value_to_operate)));
		    return "";
		}
		else if (content.startsWith("-=",i)) {
		    // Zđ
		    String left = content.substring(0,i).trim();
		    String right = content.substring(i+2).trim();
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(left);
		    String value_to_operate = evaluateExpression(right);
		    misaka.getDictionary().putUserVariable(
			left,
			Integer.toString(
			    interpretAsInteger(old_value) - interpretAsInteger(value_to_operate)));
		    return "";
		}
		else if (content.startsWith("*=",i)) {
		    // Zđ
		    String left = content.substring(0,i).trim();
		    String right = content.substring(i+2).trim();
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(left);
		    String value_to_operate = evaluateExpression(right);
		    misaka.getDictionary().putUserVariable(
			left,
			Integer.toString(
			    interpretAsInteger(old_value) * interpretAsInteger(value_to_operate)));
		    return "";
		}
		else if (content.startsWith("/=",i)) {
		    // Zđ
		    String left = content.substring(0,i).trim();
		    String right = content.substring(i+2).trim();
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(left);
		    String value_to_operate = evaluateExpression(right);
		    misaka.getDictionary().putUserVariable(
			left,
			Integer.toString(
			    interpretAsInteger(old_value) / interpretAsInteger(value_to_operate)));
		    return "";
		}
		else if (content.startsWith("++",i)) {
		    // CNg
		    String variable_to_operate = content.substring(0,i);
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(variable_to_operate);
		    misaka.getDictionary().putUserVariable(
			variable_to_operate,
			Integer.toString(
			    interpretAsInteger(old_value) + 1));
		    return "";
		}
		else if (content.startsWith("--",i)) {
		    // fNg
		    String variable_to_operate = content.substring(0,i);
		    
		    String old_value = misaka.getDictionary().getContentOfVariable(variable_to_operate);
		    misaka.getDictionary().putUserVariable(
			variable_to_operate,
			Integer.toString(
			    interpretAsInteger(old_value) - 1));
		    return "";
		}
		else if (content.startsWith("=",i)) {
		    // 
		    String left = content.substring(0,i).trim();
		    String right = content.substring(i+1).trim();

		    String evaluated = evaluateExpression(right);
		    /*if (left.equals("$_talk")) {
			System.out.println("$_talk = `"+evaluated+"'");
			}*/
		    misaka.getDictionary().putUserVariable(left, evaluated);
		    return "";
		}
	    }
	    // ϐQ
	    String content_of_variable = misaka.getDictionary().getContentOfVariable(content);
	    /*if (content.equals("$_talk")) {
		System.out.println("$_talk : `"+content_of_variable+"'");
		}*/
	    return content_of_variable == null ? "" : content_of_variable;
	}
	else {
	    // lXg̍łOɗLubNoĕ]B
	    StringBuffer buf = new StringBuffer(src);
	    for (int pos = 0;pos < buf.length();) {
		char c = buf.charAt(pos);
		if (c == '{') {
		    String block = getOutmostNest(buf.toString(),'{','}',pos);
		    if (block == null) break; // ubN̂ŏIB
		    
		    int blockstart = pos;
		    int blockend = blockstart + block.length();
		    try {
			buf.replace(blockstart,blockend,evaluate(block,true));
		    }
		    catch (Exception e) {
			throw new RuntimeException(
			    "Evaluation failed: inner block `"+block+"'", e);
		    }
		}
		else if (c == '"') {
		    // _uNH[gTB
		    /* final int len_buf = buf.length();
		    for (int i = pos+1;i < len_buf;i++) {
			if (buf.charAt(i) == '"') {
			    buf.deleteCharAt(i);
			    buf.deleteCharAt(pos);
			    pos = i - 1; // ""̎̕XLĊJ
			    break;
			}
			} */
		    buf.deleteCharAt(pos); // PɏB
		}
		else {
		    pos++;
		}
	    }
	    return buf.toString();
	}
    }
    
    public static String getOutmostNest(String src,char startchar,char endchar,int startpos) {
	// łÕlXg؂oB
	// startcharŎn܂endcharŏIB
	// startpos猟JnB
	// startchar݂ȂΖقnullԂAstartchar̂ɑΉendchar΃G[\nullԂB
	int blockstart = src.indexOf(startchar,startpos);
	int blockend = src.indexOf(endchar,blockstart);
	
	if (blockstart == -1) {
	    return null;
	}
	
	int lastFoundNestStart = blockstart;
	while (true) {
	    // startcharTAblockstart`blockend͈̔͂Ōt玟endcharTB
	    int nestStart = src.indexOf(startchar,lastFoundNestStart+1);
	    if (nestStart != -1 && nestStart < blockend) { // lXgĂ
		lastFoundNestStart = nestStart;
		blockend = src.indexOf(endchar,blockend+1);
	    }
	    else {
		break; // blockendm
	    }
	}
	if (blockend == -1) {
	    throw new RuntimeException(
		"Syntax error: Missing `"+endchar+"' in script `"+src+"'.");
	}
	return src.substring(blockstart,blockend+1);
    }
        
    private String evaluateSyntaxIf(String statement) {
	// statement : $ifŎn܂if\
	
	// condition؂oB
	// lXg̍łOɗLubNoĕ]B
	String cond_block = getOutmostNest(statement,'(',')',0);
	if (cond_block == null) {
	    // condition݂Ȃ̂ŃG[
	    throw new RuntimeException(
		"Syntax error: Missing condition in `if' block `"+statement+"',");
	}
	int blockstart = statement.indexOf('(');
	int blockend = blockstart + cond_block.length() + 1;
	String cond_evaluated = evaluateCondition(cond_block);
	
	// then؂oB
	// lXg̍łOɗLubNoĕ]B
	String then_block = getOutmostNest(statement,'{','}',blockend);
	if (then_block == null) {
	    // then݂ȂB
	    return cond_evaluated;
	}
	blockstart = statement.indexOf('{',blockend);
	blockend = blockstart + then_block.length() + 1;
	
	// else؂oB
	// lXg̍łOɗLubNoĕ]B
	String else_block = getOutmostNest(statement,'{','}',blockend);
	if (else_block == null) {
	    // else݂ȂB
	    else_block = "";
	}
	
	if (cond_evaluated.equals("true")) {
	    return evaluate(then_block,false);
	}
	else {
	    return evaluate(else_block,false);
	}
    }
	
    protected String evaluateCondition(String cond) {
	try {
	    return evaluateCondition(cond,false);
	}
	catch (Exception e) {
	    throw new RuntimeException(
		"Evaluation of condition failed: `"+cond+"'", e);
	}
    }
    protected String evaluateCondition(String cond,boolean isPure) {
	// cond : Bʂ͎OĂĂ͂ȂȂBlXgĂ\LB
	// ႦΈȉ̎͑SėLB
	// ({$hour}==9)
	// (({$hour}==9) || ({$minute}==59))
	// (({$month}==12) && (({$day}==24) || ({$day}==25)))
	// ({$month}==12 && {$day}==24 && {$hour}==0)
	if (isPure) {
	    String content = cond.substring(1,cond.length()-1).trim();
	    /*
	      ֌WZq == <= >= < > !=
	      _Zq && ||
	    */
	    content = evaluateCondition(content,false); // ĕ]
	    
	    String[] parsed = new String[2];
	    
	    // &&||TAꂪ݂Ȃ_Zq̍E̎ċAŕ]B
	    if (parseLogicalExpression(content,"&&",parsed)) {
		return evaluateCondition("("+parsed[0]+")").equals("true") &&
		    evaluateCondition("("+parsed[1]+")").equals("true") ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,"||",parsed)) {
		return evaluateCondition("("+parsed[0]+")").equals("true") ||
		    evaluateCondition("("+parsed[1]+")").equals("true") ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,"==",parsed)) {
		return evaluate(parsed[0],false).equals(
		    evaluate(parsed[1],false)) ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,"<=",parsed)) {
		return interpretAsInteger(evaluate(parsed[0],false)) <=
		    interpretAsInteger(evaluate(parsed[1],false)) ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,">=",parsed)) {
		return interpretAsInteger(evaluate(parsed[0],false)) >=
		    interpretAsInteger(evaluate(parsed[1],false)) ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,"<",parsed)) {
		return interpretAsInteger(evaluate(parsed[0],false)) <
		    interpretAsInteger(evaluate(parsed[1],false)) ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,">",parsed)) {
		return interpretAsInteger(evaluate(parsed[0],false)) >
		    interpretAsInteger(evaluate(parsed[1],false)) ? "true" : "false";
	    }
	    
	    if (parseLogicalExpression(content,"!=",parsed)) {
		return evaluate(parsed[0],false).equals(
		    evaluate(parsed[1],false)) ? "false" : "true";
	    }
	    
	    // ɗƂ́A_ZqB
	    content = evaluate(content,false);
	    if (content.equals("true")) {
		return "true";
	    }
	    else if (content.equals("false")) {
		return "false";
	    }
	    else {
		System.err.println("misaka.Evaluator#evaluateCondition: Warning;");
		System.err.println("  result of evaluation for \""+cond+"\" was \"("+content+")\" got treated as true.");
		return "true";
	    }
	}
	else {
	    // lXg̍łOɗLoĕ]B
	    StringBuffer buf = new StringBuffer(cond);
	    int blockstart_limit = 0;
	    while (true) {
		String block = getOutmostNest(buf.toString(),'(',')',blockstart_limit);
		if (block == null) break; // ubN̂ŏIB
		
		int blockstart = buf.toString().indexOf('(',blockstart_limit);
		int blockend = blockstart + block.length();
		
		// ()ubN̂O{}ubN_ƂĂ̕]sȂȂB
		boolean left_first_block_was_brace = false;
		for (int i = blockstart-1;i >= 0;i--) {
		    char c = buf.charAt(i);
		    if (c == '(') { // Oɂ̂(B
			break;
		    }
		    else if (c == '{') { // Oɂ̂{B
			left_first_block_was_brace = true;
			break;
		    }
		}
		
		final int buf_len = buf.length();
		boolean right_first_block_was_brace = false;
		for (int i = blockend;i < buf_len;i++) {
		    char c = buf.charAt(i);
		    if (c == ')') { // ɂ̂)B
			break;
		    }
		    else if (c == '}') { // ɂ̂}B
			right_first_block_was_brace = true;
			break;
		    }
		}
		
		if (!(left_first_block_was_brace && right_first_block_was_brace)) {
		    try {
			buf.replace(
			    blockstart, blockend, evaluateCondition(block,true));
		    }
		    catch (Exception e) {
			throw new RuntimeException(
			    "Evaluation of inner condition failed: `"+block+"'", e);
		    }
		}
		else {
		    blockstart_limit = blockend; // Oł͂()TȂB
		}
	    }
	    return buf.toString().trim();
	}
    }
    protected static boolean parseLogicalExpression(String src,String oper,String[] dest) {
	// ̊֐͎̂悤Ƀp[XBdest2ȏ̗vfĂȂ΂ȂȂB
	// 10 < 5			->  10,5
	// 10 < 5 && 9 > 2	->  10 < 5,9 > 2
	// w肵Zq܂܂ĂȂfalseԂB
	for (int i = 0; i < src.length(); i++) {
	    if (src.charAt(i) == '"') {
		// ̏I܂ŃXLbv
		int quote = src.indexOf('"', i+1);
		if (quote != -1) {
		    i = quote;
		}
	    }
	    else if (src.charAt(i) == '{') {
		// ubN̏I܂ŃXLbv
		String block = getOutmostNest(src, '{', '}', i);
		i += block.length() - 1;
	    }
	    else if (src.charAt(i) == '(') {
		// ʂ̏I܂ŃXLbv
		String paren = getOutmostNest(src, '(', ')', i);
		i += paren.length() - 1;
	    }
	    else if (src.startsWith(oper, i)) {
		// ZqnP[
		dest[0] = src.substring(0, i).trim();
		dest[1] = src.substring(i + oper.length()).trim();
		//System.out.println("Logical: `"+src+"' / `"+oper+"' => `"+dest[0]+"', `"+dest[1]+"'");
		return true;
	    }
	}
	return false;
    }
    
    protected String evaluateFunctionCalc(String src) {
	// $calc((1+3)*2)
	// ]Bʂ̑Ή`FbN͍sȂ킸A肪Ε]ɃG[NB
	final int paren_open_pos = src.indexOf('(');
	String expression = src.substring(paren_open_pos).trim();
	
	return evaluateExpression(expression);
    }
    
    protected String evaluateFunctionCall(String src,boolean evaluate_args) {
	// $func("arg",1,{$var})
	// ֐ƈɕB
	// evaluate_argsfalseȂA]ɓnB
	final int paren_open_pos = src.indexOf('(');
	String func_name = src.substring(0,paren_open_pos).trim();
	
	Vector args = new Vector(); // <String>
	
	final int len = src.length();
	for (int i = paren_open_pos+1;i < len;) {
	    if (src.charAt(i) == ' ') {
		continue; // _uNI[gɋ܂ĂȂpXy[X͖B
	    }
	    else if (src.charAt(i) == '"') {
		// ̃_uNI[gA܂ł̈ƂAJ}͕ʂXLbvB
		int blockend_quote = src.indexOf('"',i+1);
		args.add(src.substring(i+1,blockend_quote));
		
		int comma_pos = src.indexOf(',',blockend_quote);
		int paren_close_pos = src.indexOf(')',blockend_quote);
		if (comma_pos != -1) {
		    // ,)̏Ԃɂ͂ȂĂ),̏ɕԂƂ͂ȂB
		    i = comma_pos+1;
		}
		else if (paren_close_pos != -1) {
		    i = paren_close_pos+1;
		}
		else {
		    throw new RuntimeException(
			"Illegal function call: `"+src+"'");
		}
	    }
	    else {
		// J}͕ʂTA܂ł̈ƂɃXLbvB
		int comma_pos = src.indexOf(',',i);
		int paren_close_pos = src.indexOf(')',i);
		if (comma_pos != -1) {
		    // ,)̏Ԃɂ͂ȂĂ),̏ɕԂƂ͂ȂB
		    if (evaluate_args) {
			String arg = src.substring(i,comma_pos).trim();
			if (!(arg.startsWith("{") && arg.endsWith("}"))) {
			    arg = '{' + arg + '}';
			}
			args.add(evaluate(arg,false)); // ĕ]
		    }
		    else {
			args.add(src.substring(i,comma_pos));
		    }
		    i = comma_pos+1;
		}
		else if (paren_close_pos != -1) {
		    if (evaluate_args) {
			String arg = src.substring(i,paren_close_pos).trim();
			if (!(arg.startsWith("{") && arg.endsWith("}"))) {
			    arg = '{' + arg + '}';
			}
			args.add(evaluate(arg, false)); // ĕ]
		    }
		    else {
			args.add(src.substring(i,paren_close_pos));
		    }
		    i = paren_close_pos+1;
		}
		else {
		    throw new RuntimeException(
			"Illegal function call: `"+src+"'");
		}
	    }
	}
	
	return misaka.getSystemFuncPackage().call(func_name,args);
    }
    
    public static int interpretAsInteger(String str) {
	// lƂĉߏoȂ0ԂB
	try {
	    return Integer.parseInt(str);
	}
	catch (Exception e) {
	    return 0;
	}
    }
    
    protected String evaluateExpression(String expr) {
	try {
	    Vector expr_array = generateInvPorlandExprArray(expr); // t|[hɕϊꂽ , <String>
	    Vector work_stack = new Vector(); // vZp , <String>
	    final int n_expr_elems = expr_array.size();
	    for (int i = 0;i < n_expr_elems;i++) {
		String current_token = evaluate((String)expr_array.elementAt(i),false);	
		
		if (isAllNumber(current_token)) {
		    work_stack.add(current_token);
		}
		else if (getPriorityOfOperator(current_token) == 0) {
		    // X^bNɒl݂΁AƌĂ܂B
		    // {$username={$username}} \Ȃ悤ɁB
		    if (work_stack.size() > 0) {
			work_stack.set(
			    work_stack.size() - 1,
			    work_stack.get(work_stack.size() - 1) + current_token);
		    }
		    else {
			work_stack.add(current_token);
		    }
		}
		else {
		    String oper = (String)current_token;
		    if (oper.equals("*INVERT*")) { // PZq͂ꂾ
			int top = interpretAsInteger((String)pop(work_stack));
			work_stack.add(
			    Integer.toString(top * -1));
		    }
		    else {
			if (oper.equals("+")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(left + right));
			}
			else if (oper.equals("-")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(left - right));
			}
			else if (oper.equals("*")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(left * right));
			}
			else if (oper.equals("/")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(left / right));
			}
			else if (oper.equals("^")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(
				    (int)Math.pow(left,right)));
			}
			else if (oper.equals("%")) {
			    int right = interpretAsInteger((String)pop(work_stack)); // E
			    int left = interpretAsInteger((String)pop(work_stack)); // 
			    work_stack.add(
				Integer.toString(left % right));
			}
		    }
		}
	    }
	    // ŏIIɃX^bNɂ͒lĉŁAԂB
	    return (String)work_stack.elementAt(0);
	}
	catch (Exception e) {
	    throw new RuntimeException(
		"Illegal expression: `"+expr+"'", e);
	}
    }
    protected Vector generateInvPorlandExprArray(String expr) {
	// t|[h֕ϊB
	// ԂVectorɂString(g[N)B
	
	// p̋󔒂폜
	StringBuffer buf = new StringBuffer(expr);
	//int pos;
	//while ((pos = buf.toString().indexOf(' ')) != -1) {
	//    buf.deleteCharAt(pos);
	//}
	
	Vector expr_stack = new Vector();
	Vector ope_stack = new Vector();
	ExpressionTokenizer ext = new ExpressionTokenizer(buf.toString());
	String tokenJustBefore = null; // Õg[N
	String currentToken = null;
	while (ext.hasMoreTokens()) {
	    tokenJustBefore = currentToken;
	    currentToken = ext.nextToken();
	    
	    if (isAllNumber(currentToken)) {
		// ̂܂܏o
		expr_stack.add(currentToken);
		continue;
	    }
	    
	    if (currentToken.equals("-")) {
		// 񂪏߂Ẵg[NA͒Õg[NJʈ͉Zqꍇ͒PZqB
		// łȂΓ񍀉ZqB
		// ʂ͓̒񍀉Zqł邱ƂɒӁB
		if (tokenJustBefore == null ||
		    tokenJustBefore.equals("(") ||
		    getPriorityOfOperator(tokenJustBefore) != 0) {
		    ope_stack.add("*INVERT*");
		    continue;
		}
	    }
	    
	    if (currentToken.equals("(")) {
		// Jʂpush
		ope_stack.add(currentToken);
	    }
	    else if (currentToken.equals(")")) {
		// ʂꂽ牉ZqX^bNɊJʂ܂popB
		while (true) {
		    String top = (String)pop(ope_stack);
		    
		    if (top.equals("(")) {
			break;
		    }
		    else {
			expr_stack.add(top);
		    }
		}
	    }
	    else if (getPriorityOfOperator(currentToken) == 0) {
		// 萔͂̂܂܏o
		expr_stack.add(currentToken);
	    }
	    else {
		// Zq́A̎_ł̃X^bÑgbvƔrėD揇ʂpoppushAłȂpusĥ
		// ZqX^bN󂾂gbvJʂȂ疳pusĥ݁B
		if (ope_stack.size() > 0) {
		    String top = (String)ope_stack.elementAt(ope_stack.size()-1);
		    if (!top.equals("(") &&
			getPriorityOfOperator(currentToken) <= getPriorityOfOperator(top)) {
			expr_stack.add(top);
			ope_stack.removeElementAt(ope_stack.size()-1);
		    }
		}
		ope_stack.add(currentToken);
	    }
	}
	// ZqX^bNSpop
	final int ope_stack_size = ope_stack.size();
	for (int i = ope_stack_size-1;i >= 0;i--) {
	    expr_stack.add(ope_stack.elementAt(i));
	}
	
	return expr_stack;
    }
    private static Object pop(Vector vec) {
	final int size = vec.size();
	Object top = vec.elementAt(size-1);
	vec.removeElementAt(size-1);
	return top;
    }
    public static boolean isAllNumber(String s) {
	// sSĔpŕ\ĂtrueB
	final int len = s.length();
	for (int i = 0;i < len;i++) {
	    if (!Character.isDigit(s.charAt(i))) return false;
	}
	return true;
    }
    private static Hashtable OPE_PRIORITY;
    static {
	OPE_PRIORITY = new Hashtable();
	OPE_PRIORITY.put("*INVERT*",new Integer(4));
	OPE_PRIORITY.put("^",new Integer(3));
	OPE_PRIORITY.put("*",new Integer(2));
	OPE_PRIORITY.put("/",new Integer(2));
	OPE_PRIORITY.put("%",new Integer(2));
	OPE_PRIORITY.put("+",new Integer(1));
	OPE_PRIORITY.put("-",new Integer(1));
    }
    public static int getPriorityOfOperator(String ope) {
	// 傫قǗD揇ʂB
	// ZqłȂ0ԂB
	Integer pri = (Integer)OPE_PRIORITY.get(ope);
	return (pri == null ? 0 : pri.intValue());
    }
}
