/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.io.*;
import java.util.*;

public class Misaka
{
    File ghost_dir;
    Vector last_references;
    Dictionary dictionary;
    Evaluator evaluator;
	SystemFuncPackage sys_func;
	SystemVariablePackage sys_vars;
    
    //----------- ȉ̏NOTIFYőĂ܂B------------//
    String ownerGhostName;
    Vector otherGhostNames; // g͌܂łȂStringB
    //---------------------------------------------------------//
	
	int randomtalk_count = 0; // 200ԂxɃZbgB
    
    public Misaka(File ghost_dir)
    {
		this.ghost_dir = ghost_dir;
		last_references = new Vector();
		dictionary = new Dictionary(this);
		evaluator = new Evaluator(this);
		sys_func = new SystemFuncPackage(this);
		sys_vars = new SystemVariablePackage(this);
		otherGhostNames = new Vector();
		
		loadMisakaIni();
		
		// [U[ϐ𕜋AB
		dictionary.restoreUserVariables();
		sys_vars.restoreData();
    }
    
    public void loadMisakaIni()
    {
		Ini ini = new Ini(new File(ghost_dir,"misaka.ini"));
		// dictionariesGgɋLڂꂽSẴt@C[hB
		// ΃pXDOS^UNIX^֕ϊB
		Vector dictionaries = (Vector)ini.get("dictionaries");
		if (dictionaries == null) return;
		
		final int n_dics = dictionaries.size();
		for (int i = 0;i < n_dics;i++)
		{
			dictionary.loadDicFile(new File(ghost_dir,convWinPathToUnixOne((String)dictionaries.elementAt(i))));
		}
    }
    
    public static String convWinPathToUnixOne(String src)
    {
		// obNXbVyсLXbVɕϊB
		StringBuffer buf = new StringBuffer(src);
		int pos;
		while ((pos = buf.toString().indexOf('\\')) != -1)
		{
			buf.setCharAt(pos,'/');
		}
		while ((pos = buf.toString().indexOf('\u00a5')) != -1)
		{
			buf.setCharAt(pos,'/');
		}
		return buf.toString();
    }
	
	public File getGhostDir()
	{
		return ghost_dir;
	}
    
    public Dictionary getDictionary()
    {
		return dictionary;
    }
    
    public Evaluator getEvaluator()
    {
		return evaluator;
    }
	
	public SystemFuncPackage getSystemFuncPackage()
	{
		return sys_func;
	}
	
	public SystemVariablePackage getSystemVariablePackage()
	{
		return sys_vars;
	}
	
	public Vector getLastReferences()
	{
		return last_references;
	}
    
    public static Object selectObjectAtRandom(Vector vec)
    {
		// vecnullȂnullԂ܂B
		if (vec == null) return null;
		
		int select = (int)((Math.random() * Integer.MAX_VALUE) % vec.size());
		return vec.elementAt(select);
    }
    public static String selectStringAtRandom(Vector vec)
    {
		// vecnullȂnullԂ܂B
		return (String)selectObjectAtRandom(vec);
    }
    
    // implementations of the interface SCShioriKernel
    public static boolean checkIfUsable(File ghost_dir)
    {
        return (new File(ghost_dir,"misaka.ini")).exists();
    }
    
    public void terminate()
    {
		sys_vars.storeData();
		dictionary.saveUserVariables();
    }
    
    public static String getModuleName()
    {
        return "\u7f8e\u5742"; // 
    }
	
    protected String doRandomTalkTrigger() {
	/*
	  $_talkinterval𐔒lƂĕ]ƂAꂪ0ɂȂ玩_g[NsȂȂB
	  łȂ΁A$_talkinterval0.5{1.5{randomtalk_countBƂAgKB
	  ̃\bh̓gKȂnullԂB
	*/
	int interval = Evaluator.interpretAsInteger(
	    dictionary.getContentOfVariable("$_talkinterval"));
	if (interval == 0) return null;
	
	randomtalk_count++;
	
	// 덷́}50%B
	int signal = (int)(Math.random() * Integer.MAX_VALUE) % 2 == 0 ? 1 : -1;
	double percentage = (Math.random() * Integer.MAX_VALUE) % 50;
	interval += (int)(signal * interval * (percentage / 100.0));
	
	if (randomtalk_count >= interval) {
	    // TRIGGER
	    randomtalk_count = 0; // ǂ̌ɂxZbg邪c
	    try {
		return evaluator.evaluate(
		    dictionary.getContentOfVariable("$_OnRandomTalk"));
	    }
	    catch (Exception e) {
		System.err.println("Exception in evaluating $_OnRandomTalk");
		e.printStackTrace();
	    }
	}
	
	return null;
    }
    
    public String request(String req) {
	BufferedReader br = new BufferedReader(new StringReader(req));
	
	// ܂̓wb_ǂ
	String header = null;
	try{ header = br.readLine(); }catch (Exception e){}
	
	// NOTIFY OtherGhostName͑ĂGgdĂB
	if (header.startsWith("NOTIFY OtherGhostName")) {
	    otherGhostNames.clear();
	    
	    String line = null;
	    while (true) {
		try{ line = br.readLine(); }catch (Exception e){}
		if (line == null) break;
		if (!line.startsWith("Ghost: ")) continue;
		
		otherGhostNames.add( line.substring(line.indexOf(':')+2) ); // R̎̃Xy[X͖
	    }
	    
	    try{ br.close(); }catch(IOException e){}
	    return "SHIORI/2.3 204 No Content\r\n\r\n";
	}
	
	// NGXgŜǂ
	Hashtable hash = new Hashtable();
	String line = null;
	while (true) {
	    try{ line = br.readLine(); }catch (Exception e){}
	    if (line == null) break;
	    if (line.indexOf(':') == -1) continue;
	    
	    String label = line.substring(0,line.indexOf(':'));
	    String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
	    hash.put(label,data);
	}
	
	// VXeϐ$senderXV
	dictionary.putUserVariable("$sender",(String)hash.get("Sender"));
	
	// ߊJnB
	if (header.startsWith("GET Sentence")) {
	    if (hash.get("Event") != null) { // Cxgt
		String eventName = (String)hash.get("Event");
		//System.out.println(eventName);
		
		// Referenceo^
		last_references.clear();
		final int numOfReferencesToSearch = 8;
		for (int i = 0;i < numOfReferencesToSearch;i++) {
		    String data = (String)hash.get("Reference"+i);
		    if (data == null) continue;
		    
		    last_references.add(data); // ԍłƕsƂȂ邪...
		}
		
		// OnUpdateBeginȂVXeϐǗ@\ɒʒmB
		if (eventName.equals("OnUpdateBegin")) {
		    sys_vars.onlineUpdated();
		}
		
		// OnSecondChangeȂ獡̂Ń_g[NgKꂽǂB
		if (eventName.equals("OnSecondChange")) {
		    String script_by_randomtalk_trigger = doRandomTalkTrigger();
		    if (script_by_randomtalk_trigger != null) {
			return generateResponce200(script_by_randomtalk_trigger,hash);
		    }
		}
		
		// $[name]BȂ204ԂB
		String evententry = dictionary.getContentOfVariable("$"+eventName);
		if (evententry == null) {
		    return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else {
		    try {
			return generateResponce200(
			    evaluator.evaluate(evententry), hash);
		    }
		    catch (Exception e) {
			System.err.println("Exception in evaluating $"+eventName);
			e.printStackTrace();
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		    }
		}
	    }
	    else if (hash.get("Sentence") != null) { // ZeXt
		// Referenceo^
		last_references.clear();
		final int numOfReferencesToSearch = 8;
		for (int i = 0;i < numOfReferencesToSearch;i++) {
		    String data = (String)hash.get("Reference"+i);
		    if (data == null) continue;
		    
		    last_references.add(data); // ԍłƕsƂȂ邪...
		}
		
		// VXeϐ$lastsentenceXV
		dictionary.putUserVariable("$lastsentence",(String)hash.get("Sentence"));
		
		// $_OnGhostCommunicateReceiveB204B
		String communicate_entry = dictionary.getContentOfVariable("$_OnGhostCommunicateReceive");
		if (communicate_entry == null) {
		    return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else {
		    return generateResponce200(evaluator.evaluate(communicate_entry),hash);
		}
	    }
	    else { // CxgZeX
		return generateResponce200(
		    evaluator.evaluate(
			dictionary.getContentOfVariable("$_OnRandomTalk")),hash);
	    }
	}
	else if (header.startsWith("GET Word")) {
	    return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
	}
	else if (header.startsWith("GET String")) {
	    String str = dictionary.getContentOfVariable("$"+(String)hash.get("ID"));
	    return "SHIORI/2.5 200 OK\r\nString: " + evaluator.evaluate(str) + "\r\n\r\n";
	}
	else if (header.startsWith("NOTIFY OwnerGhostName")) {
	    ownerGhostName = (String)hash.get("Ghost");
	    return "SHIORI/2.3 204 No Content\r\n\r\n";
	}
	else if (header.startsWith("TEACH")) {
	    return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
	}
	else {
	    return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
	}
    }
    
    private String generateResponce200(String sentence,Hashtable requestTable)
    {
		// requestTable̓S[XgԃR~jP[g邽߁B
		
		// sentenceȂ204B
		if (sentence.length() == 0)
		{
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		
		randomtalk_count = 0; // _g[ÑJE^Zbg
		return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
		
		/*
		String sysCom = dictionary.findEntryAndGetFirstElement("system.communicate");
		if (requestTable.get("Age") != null) // Age
		{
			if (sysCom != null && sysCom.equals("stop"))
			{
			// system.communicatestopbIB
			return "SHIORI/2.3 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
			if (sysCom == null || sysCom.equals( (String)requestTable.get("Sender") ))
			{
			// system.communicateA̓NGXgSenderƓstopłȂꍇɂ͉B
			try
			{
				int oldAge = Integer.parseInt( (String)requestTable.get("Age") );
				
				StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
				resp.append("Sender: "+ownerGhostName+"\r\n");
				resp.append("To: "+(String)requestTable.get("Sender")+"\r\n");
				resp.append("Age: "+Integer.toString(oldAge+1)+"\r\n");
				resp.append("Sentence: "+sentence+"\r\n");
				final int numOfReferencesToSearch = 8;
				for (int i = 0;i < numOfReferencesToSearch;i++)
				{
				String ref = dictionary.findEntryAndGetFirstElement("system.Response"+i);
				if (ref == null) continue;
				
				resp.append("Reference"+i+": "+ref+"\r\n");
				}
				resp.append("\r\n"); // X|XB
				return resp.toString();
			}
			catch (Exception e)
			{
				return "SHIORI/2.3 400 Bad Request\r\n\r\n";
			}
			}
			else
			{
			// system.communicatestopłłȂANGXgSenderƈقȂꍇ͕ʂ̑ɘbB
			StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
			resp.append("Sender: "+ownerGhostName+"\r\n");
			resp.append("To: "+sysCom+"\r\n");
			resp.append("Age: 0\r\n");
			resp.append("Sentence: "+sentence+"\r\n");
			final int numOfReferencesToSearch = 8;
			for (int i = 0;i < numOfReferencesToSearch;i++)
			{
				String ref = dictionary.findEntryAndGetFirstElement("system.Response"+i);
				if (ref == null) continue;
				
				resp.append("Reference"+i+": "+ref+"\r\n");
			}
			resp.append("\r\n"); // X|XB
			return resp.toString();
			}
		}
		else // Age
		{
			if (sysCom != null && !sysCom.equals("stop"))
			{
			// system.communicatełstopłȂVɃS[XgԃR~jP[VJnB
			StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
			resp.append("Sender: "+ownerGhostName+"\r\n");
			resp.append("To: "+sysCom+"\r\n");
			resp.append("Age: 0\r\n");
			resp.append("Sentence: "+sentence+"\r\n");
			final int numOfReferencesToSearch = 8;
			for (int i = 0;i < numOfReferencesToSearch;i++)
			{
				String ref = dictionary.findEntryAndGetFirstElement("system.Response"+i);
				if (ref == null) continue;
				
				resp.append("Reference"+i+": "+ref+"\r\n");
			}
			resp.append("\r\n"); // X|XB
			return resp.toString();
			}
			else
			{
			// system.communiate܂stop̂ŒʏSentencê݁B
			return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
		}*/
    }
}
