/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class SystemFuncPackage
{
	Misaka misaka;
	
	public SystemFuncPackage(Misaka misaka)
	{
		this.misaka = misaka;
	}
	
	public String call(String funcname,Vector args)
	{
		// funcname: $func
		// args: <String>
		try
		{
			Method func = this.getClass().getMethod("func_"+funcname.substring(1),new Class[] {Vector.class});
			return (String)func.invoke(this,new Object[] {args});
		}
		catch (NoSuchMethodException e)
		{
			System.err.println("misaka.SystemFuncPackage#call : undefined function call \""+funcname+"\"");
			return "";
		}
		catch (Exception e)
		{
			System.err.println("misaka.SystemFuncPackage#call : exception occurred in calling "+funcname);
			e.printStackTrace();
			return "";
		}
	}
	
	public String func_reference(Vector args) throws Exception
	{
		// {$reference(n)}
		// ݂ n Ԗڂ reference wb_̓eԂ
		int n = Integer.parseInt((String)args.elementAt(0));
		
		Vector last_references = misaka.getLastReferences();
		if (n >= last_references.size())
		{
			return "";
		}
		else
		{
			return (String)last_references.elementAt(n);
		}
	}
	
	public String func_random(Vector args) throws Exception
	{
		// {$random(n)}
		// 0`n-1 ͈̗̔͂ijԂB
		int n = Integer.parseInt((String)args.elementAt(0));
		
		return Integer.toString((int)(Math.random() * Integer.MAX_VALUE) % n);
	}
	
	public String func_extractfilename(Vector args) throws Exception
	{
		// {$extractfilename(s)}
		//  s t@CƌȂApXăt@Ĉ݂ԂB
		// C:\hoge\hoge.txt  hoge.txt
		// \/̗pX؂蕶ƂďBǂȊ֐ĝDnDCxgB
		String path = Misaka.convWinPathToUnixOne((String)args.elementAt(0));
		
		final int slash_pos = path.lastIndexOf('/');
		if (slash_pos == -1)
		{
			return path;
		}
		else
		{
			// ̏ꍇslash_pos == -1substring(0)ɂȂ̂ōDsA
			// 킴킴CႢ݂R[hKv͖B
			return path.substring(slash_pos+1);
		}
	}
	
	public String func_index(Vector args) throws Exception
	{
		/*
			{$index(n,s)}
			 s 當 n TA̐擪ʒuԂBPʃoCgBᎦ
		
			{$index("hum","human")}
			{$index("hux","human")}
			{$index("n","human")}
		*/
		String sub = (String)args.elementAt(0);
		String world = (String)args.elementAt(1);
		
		final int pos = world.indexOf(sub);
		if (pos == -1)
		{
			return "-1"; // tȂ-1ԂB̃}jAɂ͋Lqc
		}
		
		return Integer.toString(
					countSizeOfStringInSJIS(world.substring(0,pos)));
	}
	
	public String func_insentence(Vector args) throws Exception
	{
		/*
			{$insentence(s,n,n,n,n....)}
			 s 當 n TASĂ݂邩ǂ bool lŕԂB̍ő吔͖B
			
			̏ index ƋtɂȂĂ邱ƂɒӁB
			
			{$insentence("human","hum")}
			{$insentence("human","hux")}
			{$insentence("human","hum","uma","u")}
			{$insentence("human","hum","hua")}
		*/
		String world = (String)args.elementAt(0);
		
		final int argc = args.size();
		for (int i = 1;i < argc;i++)
		{
			String sub = (String)args.elementAt(i);
			
			if (world.indexOf(sub) == -1)
			{
				return "false";
			}
		}
		return "true";
	}
	
	public String func_inlastsentence(Vector args) throws Exception
	{
		/*
			{$inlastsentence(n,n,n,n....)}
			
			insentence ̃JvZO֐BlastsentenceiO COMMUNICATE Ŏ󂯎̃XNvgjɑ΂ insentence sB
		*/
		String world = misaka.getDictionary().getContentOfVariable("$lastsentence");
		
		Vector args_for_insentence = (Vector)args.clone();
		args_for_insentence.add(0,world);
		
		return func_insentence(args_for_insentence);
	}
	
    public String func_length(Vector args) throws Exception {
	/*
	  {$length(s)}
	   s ̒ioCgjԂB
	*/
	String str = (String)args.elementAt(0);

	//System.out.println(
	//    "$length(\""+str+"\") = "+countSizeOfStringInSJIS(str));
	
	return Integer.toString(
	    countSizeOfStringInSJIS(str));
    }
	
	public String func_substring(Vector args) throws Exception
	{
		/*
			{$substring(s,offset,count)}
			{$substringl(s,count)}
			{$substringr(s,count)}
			
			 s ̕ԂBsubstring ͕ s  offset oCgڂ count oCgAsubstringl   s ̍[ count oCgAsubstringr ͕ s ̉E[ count oCgB
		*/
		byte[] s = ((String)args.elementAt(0)).getBytes("SJIS");
		int offset = Integer.parseInt((String)args.elementAt(1));
		int count = Integer.parseInt((String)args.elementAt(2));
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream(count);
		baos.write(s,offset,count);
		byte[] result = baos.toByteArray();
		baos.close();
		
		return new String(result,"SJIS");
	}
	
	public String func_substringl(Vector args) throws Exception
	{
		byte[] s = ((String)args.elementAt(0)).getBytes("SJIS");
		int count = Integer.parseInt((String)args.elementAt(1));
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream(count);
		baos.write(s,0,count);
		byte[] result = baos.toByteArray();
		baos.close();
		
		return new String(result,"SJIS");
	}
	
	public String func_substringr(Vector args) throws Exception
	{
		byte[] s = ((String)args.elementAt(0)).getBytes("SJIS");
		int count = Integer.parseInt((String)args.elementAt(1));
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream(count);
		baos.write(s,s.length - count,count);
		byte[] result = baos.toByteArray();
		baos.close();
		
		return new String(result,"SJIS");
	}
	
	public String func_substringw(Vector args) throws Exception
	{
		/*
			{$substringw(s,m,n)}
			{$substringwl(s,n)}
			{$substringwr(s,n)}
			
			Ch substringBoCgł͂Ȃ̕ŃJEgBȊO substring ƓBᎦ
			
			{$temp="abcd"}{$substringl({$temp},3)}
			{$temp="abcd"}{$substringlw({$temp},3)}
		*/
		String s = (String)args.elementAt(0);
		int offset = Integer.parseInt((String)args.elementAt(1));
		int count = Integer.parseInt((String)args.elementAt(2));
		
		return s.substring(offset,offset + count);
	}
	
	public String func_substringwl(Vector args) throws Exception
	{
		String s = (String)args.elementAt(0);
		int count = Integer.parseInt((String)args.elementAt(1));
		
		return s.substring(0,count);
	}
	
	public String func_substringwr(Vector args) throws Exception
	{
		String s = (String)args.elementAt(0);
		int count = Integer.parseInt((String)args.elementAt(1));
		
		return s.substring(s.length() - count,s.length());
	}
	
	public String func_substringfirst(Vector args) throws Exception
	{
		/*
			{$substringfirst(s)}
			{$substringlast(s)}
			
			substringw ̃JvZO֐Bsubstringfirst  s ̐擪1Asubstringlast  s ̏I[1ԂB̊֐ MBCS lioCgł͂ȂPʂŔrjB
		*/
		return ((String)args.elementAt(0)).substring(0,1);
	}
	
	public String func_substringlast(Vector args) throws Exception
	{
		String s = (String)args.elementAt(0);
		return s.substring(s.length()-1,s.length());
	}
	
	public String func_isequallastandfirst(Vector args) throws Exception
	{
		/*
			{$isequallastandfirst(s0,s1)}

			s0 ̏I[1 s1 ̐擪1ꂩǂ𔻒肵 bool lԂB̊֐ MBCS lioCgł͂ȂPʂŔrjB
		*/
		String s0 = (String)args.elementAt(0);
		String s1 = (String)args.elementAt(1);
		
		return s0.charAt(s0.length()-1) == s1.charAt(0) ? "true" : "false";
	}
	
	public String func_getvalue(Vector args) throws Exception
	{
		/*
			{$getvalue(n,m)}
			n œnꂽJ}ŃZp[gAn Ԗڂ̗vfԂB
			
			{$_ref="a,b,c,d,e,f"}{$getvalue("{$_ref}",3)}
			̎̒l d
		*/
		String world = (String)args.elementAt(0);
		int index = Integer.parseInt((String)args.elementAt(1));
		
		StringTokenizer st = new StringTokenizer(world,",");
		for (int i = 0;i < index-1;i++)
		{
			st.nextToken(); // ̂Ă
		}
		return st.nextToken();
	}
	
	public String func_getvalueex(Vector args) throws Exception
	{
		/*
			{$getvalueex(n,m)}
			n œnꂽoCgl 1ŃZp[gAn Ԗڂ̗vfԂB
		*/
		String world = (String)args.elementAt(0);
		int index = Integer.parseInt((String)args.elementAt(1));
		
		StringTokenizer st = new StringTokenizer(world,"\u0001");
		for (int i = 0;i < index-1;i++)
		{
			st.nextToken(); // ̂Ă
		}
		return st.nextToken();
	}
	
	public String func_append(Vector args) throws Exception
	{
		/*
			{$append(a,s)}
			zϐ a ɗvf s ǉBa ɒPϐłꍇAPϐ̒l a[0]As  a[1] ƂȂAȍ~ a ͔zϐɕωB
		*/
		String name_of_array = (String)args.elementAt(0);
		String value = (String)args.elementAt(1);
		
		Variable v = misaka.getDictionary().findVariable(name_of_array,false);
		if (v == null)
		{
			// ϐ݂Ȃ̓͋LqĂȂB
			// ̃N[ł͒PϐǉB
			misaka.getDictionary().putUserVariable(name_of_array,value);
		}
		else
		{
			v.addContent(value);
		}
		return "";
	}
	
	public String func_copy(Vector args) throws Exception
	{
		/*
			{$copy(a0,a1)}
			
			zϐ a0  a1 ɃRs[Ba0 ɂ͈ȉ̏ŎϐgpłB

			A̗pAԍŏɌϐgp
		*/
		String name_of_src_array = (String)args.elementAt(0);
		String name_of_dest_array = (String)args.elementAt(1);
		
		Variable src = misaka.getDictionary().findVariable(name_of_src_array,false);
		if (src != null)
		{
			misaka.getDictionary().putUserVariable(name_of_dest_array,src.getContents());
		}
		return "";
	}
	
	public String func_count(Vector args) throws Exception
	{
		/*
			{$count(a)}

			z a ̗vfԂBY͂̊֐œl -1 ܂ŗLBa Pϐꍇ͏ 1 ԂBa zϐłPϐłȂꍇiNULL ꍇj -1 ԂB
		*/
		String name_of_array = (String)args.elementAt(0);
		
		Variable v = misaka.getDictionary().findVariable(name_of_array,false);
		if (v == null)
		{
			return "-1";
		}
		else
		{
			return Integer.toString(v.size());
		}
	}
	
	public String func_pop(Vector args) throws Exception
	{
		/*
			{$pop(a)}
			
			zϐ a 烉_1vfԂAɂ̗vfz񂩂폜Bz񂪋̏ꍇ͋󕶎ԂB
		*/
		String name_of_array = (String)args.elementAt(0);
		
		Variable v = misaka.getDictionary().findVariable(name_of_array,false);
		if (v == null) return "";
		if (v.size() == 0) return "";
		
		int idx = (int)(Math.random() * Integer.MAX_VALUE) % v.size();
		String result = v.getContentAtIndex(idx);
		v.deleteContentAtIndex(idx);
		
		return result;
	}
	
	public String func_popmatchl(Vector args) throws Exception
	{
		/*
			{$popmatchl(a,s)}

			zϐ a  s ƍvvf̒烉_1vfԂAɂ̗vfz񂩂폜BvvfȂꍇ͋󕶎ԂB
			
			âŝ̗Ȃ̂Ȃ̂ŁÃN[ł͗B
		*/
		Variable var1 = misaka.getDictionary().findVariable((String)args.elementAt(0),false);
		Variable var2 = misaka.getDictionary().findVariable((String)args.elementAt(1),false);
		if (var1 == null || var2 == null) return "";
		
		Vector vec1 = var1.getContents();
		Vector vec2 = var2.getContents();
		final int vec1_size = vec1.size();
		final int vec2_size = vec2.size();
		int n_matched_elements = 0; // vvf̐
		for (int i = 0;i < vec1_size && i < vec2_size;i++)
		{
			if (vec1.elementAt(i).equals(vec2.elementAt(i)))
			{
				/*
					lispnȂXbLƏ邪c
					
					(if	(equals
							(elementAt vec1 i)
							(elementAt vec2 i))
						
						(++ n_matched_elements))
				*/
				n_matched_elements++;
			}
			else
			{
				break;
			}
		}
		
		if (n_matched_elements == 0)
		{
			return "";
		}
		else
		{
			int idx = (int)(Math.random() * Integer.MAX_VALUE) % n_matched_elements;
			String result = var1.getContentAtIndex(idx);
			var1.deleteContentAtIndex(idx);
			var2.deleteContentAtIndex(idx);
			
			return result;
		}
	}
	
	public String func_stringexists(Vector args) throws Exception
	{
		/*
			{$stringexists(a,s)}

			zϐ a ɕ s ƊSvvf邩ۂ bool lŕԂB
		*/
		Variable v = misaka.getDictionary().findVariable((String)args.elementAt(0),false);
		String str = (String)args.elementAt(1);
		if (v == null) return "false";
		
		for (Enumeration e = v.getContents().elements();e.hasMoreElements();)
		{
			if (str.equals(e.nextElement()))
			{
				return "true";
			}
		}
		return "false";
	}
	
	public String func_choice(Vector args) throws Exception
	{
		/*
			$choice(n,n,n,n,n,n....)
			
			œnꂽl̂_ɈԂB̍ő吔ɐ͂ȂBᎦ
			
			{$choice("",{$b},256)}
		*/
		final int argc = args.size();
		if (argc == 0) return "";
		
		int idx = (int)(Math.random() * Integer.MAX_VALUE) % argc;
		return (String)args.elementAt(idx);
	}
	
	public String func_search(Vector args) throws Exception
	{
		/*
			$search(n,n,n,n....)

			V{ɈœnꂽSĂ܂܂ĂV{̒烉_Ɉ̃V{I]Ė߂lԂB̐ɐ͂ȂB
		*/
		Vector vars = misaka.getDictionary().collectVariablesWhoseNamesContainThese(args);
		
		final int n_vars = vars.size();
		int index = (int)(Math.random() * Integer.MAX_VALUE) % n_vars;
		return misaka.getEvaluator().evaluate(((Variable)vars.elementAt(index)).getContent());
	}
	
	public String func_imitationif(Vector args) throws Exception
	{
		/*
			$imitationif(n,n,n,n....)

			[ if ČB珇ɕ]AlԂƂł߂lɂĔB
		*/
		Evaluator evaluator = misaka.getEvaluator();
		
		final int argc = args.size();
		for (int i = 0;i < argc;i++)
		{
			String eval_result = evaluator.evaluate((String)args.elementAt(i));
			if (eval_result.length() > 0)
			{
				return eval_result;
			}
		}
		return "";
	}
	
	public String func_backup(Vector args) throws Exception
	{
		/*
			$backup()
			
			[U[ϐۑB
		*/
		misaka.getSystemVariablePackage().storeData();
		misaka.getDictionary().saveUserVariables();
		return "";
	}
	
	public static int countSizeOfStringInSJIS(String str)
	{
		try {
			return str.getBytes("SJIS").length;
		}
		catch (Exception e) { return 0; }
	}
	
	public String func_getmousemovecount(Vector args) throws Exception
	{
		// 
		return "0";
	}
	
	public String func_loadsaori(Vector args) throws Exception
	{
		return "";
	}
	public String func_saori(Vector args) throws Exception
	{
		return "";
	}
}
