/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.io.*;
import java.util.*;

/*
	̃NX̃CX^X́A쐬ꂽS[Xg̋Nƌ􂵂܂B
	[U[ϐƂĕKvȏۑ̂Ń[U[ϐ[hꂽrestoreData()Ă΂Ȃ΂Ȃ炸A
	܂[U[ϐt@CɕۑOɂ̃NX̃\bhstoreData()Ă΂Ȃ΂Ȃ܂B
	
	misaka.Misaka̓CxgOnUpdateBeginMxɃ\bhonlineUpdated()Ă΂Ȃ΂Ȃ܂B
*/

public class SystemVariablePackage
{
	Misaka misaka;
	long boot_time;
	
	long total_elapsed_time; // OI܂ł̃S[Xg̒ʎZNԁB[U[ϐ$___MISAKA-JAVA_TOTAL_ELAPSED_MILLISECONDS___ƂĕۑB
	
	long last_update_time; // ŌɃlbg[NXVsBG|bN~bB[U[ϐ$___MISAKA-JAVA_LAST_UPDATE_TIME___ƂĕۑB
	
	long first_boot_time; // N̎BG|bN~bB[U[ϐ$___MISAKA-JAVA_FIRST_BOOT_TIME___ƂĕۑB
	
	
	public SystemVariablePackage(Misaka misaka)
	{
		this.misaka = misaka;
		boot_time = System.currentTimeMillis();
	}
	
	public void restoreData()
	{
		Dictionary dic = misaka.getDictionary();
		
		try {
			total_elapsed_time = Long.parseLong(
							dic.getContentOfVariable("$___MISAKA-JAVA_TOTAL_ELAPSED_MILLISECONDS__"));
		}
		catch (Exception e) { // NumberFormatExceptionNullPointerException
			total_elapsed_time = 0; // ߂ċNĂ班ԂoĂȂɂB
		}
		
		try {
			last_update_time = Long.parseLong(
							dic.getContentOfVariable("$___MISAKA-JAVA_LAST_UPDATE_TIME___"));
		}
		catch (Exception e) {
			last_update_time = System.currentTimeMillis(); // XV΂ƂɂB
		}
		
		try {
			first_boot_time = Long.parseLong(
							dic.getContentOfVariable("$___MISAKA-JAVA_FIRST_BOOT_TIME___"));
		}
		catch (Exception e) {
			first_boot_time = System.currentTimeMillis(); // ݂̎N̎ƂB
		}
	}
	
	public void storeData()
	{
		// storeData͉xĂłǂAxłstoreDataĂ񂾌restoreDataĂł͂ȂȂB
		Dictionary dic = misaka.getDictionary();
		
		dic.putUserVariable(
				"$___MISAKA-JAVA_TOTAL_ELAPSED_MILLISECONDS__",
				Long.toString(
					total_elapsed_time + (System.currentTimeMillis() - boot_time)));
		
		dic.putUserVariable(
				"$___MISAKA-JAVA_LAST_UPDATE_TIME___",
				Long.toString(last_update_time));
		
		dic.putUserVariable(
				"$___MISAKA-JAVA_FIRST_BOOT_TIME___",
				Long.toString(first_boot_time));
	}
	
	public void onlineUpdated()
	{
		last_update_time = System.currentTimeMillis();
	}
	
	public String get(String name)
	{
		// VXeϐ݂ȂnullԂB
		Calendar cal = Calendar.getInstance();
		cal.setFirstDayOfWeek(Calendar.SUNDAY);
		
		if (name.equals("$year"))
			return Integer.toString(cal.get(Calendar.YEAR));
		else if (name.equals("$month"))
			return Integer.toString(cal.get(Calendar.MONTH)+1);
		else if (name.equals("$day"))
			return Integer.toString(cal.get(Calendar.DAY_OF_MONTH));
		else if (name.equals("$hour"))
			return Integer.toString(cal.get(Calendar.HOUR_OF_DAY));
		else if (name.equals("$minute"))
			return Integer.toString(cal.get(Calendar.MINUTE));
		else if (name.equals("$second"))
			return Integer.toString(cal.get(Calendar.SECOND));
		else if (name.equals("$dayofweek"))
			return Integer.toString(cal.get(Calendar.DAY_OF_WEEK)-1);
		else if (name.equals("$elapsedhour"))
		{
			return Integer.toString(
					(int)((System.currentTimeMillis() - boot_time) / 1000.0 / 60.0 / 60.0));
		}
		else if (name.equals("$elapsedminute"))
		{
			return Integer.toString(
					(int)((System.currentTimeMillis() - boot_time) / 1000.0 / 60.0) % 60);
		}
		else if (name.equals("$elapsedsecond"))
		{
			return Integer.toString(
					(int)((System.currentTimeMillis() - boot_time) / 1000.0) % 60);
		}
		else if (name.equals("$elapsedhouros") || name.equals("$elapsedminuteos") || name.equals("$elapsedsecondos"))
		{
			// 擾@mȂB
			return "0";
		}
		else if (name.equals("$elapsedhourtotal"))
		{
			long milliseconds_elapsed = total_elapsed_time + (System.currentTimeMillis() - boot_time);
			return Integer.toString((int)(milliseconds_elapsed / 1000.0 / 60.0 / 60.0));
					
		}
		else if (name.equals("$elapsedminutetotal"))
		{
			long milliseconds_elapsed = total_elapsed_time + (System.currentTimeMillis() - boot_time);
			return Integer.toString((int)(milliseconds_elapsed / 1000.0 / 60.0) % 60);
		}
		else if (name.equals("$elapsedsecondtotal"))
		{
			long milliseconds_elapsed = total_elapsed_time + (System.currentTimeMillis() - boot_time);
			return Integer.toString((int)(milliseconds_elapsed / 1000.0) % 60);
		}
		else if (name.equals("$os.version") || name.equals("$os.name") ||
				 name.equals("$os.phisicalmemorysize") || name.equals("$os.freememorysize") ||
				 name.equals("$os.totalmemorysize") || name.equals("$cpu.vendorname") ||
				 name.equals("$cpu.name") || name.equals("$cpu.clockcycle"))
		{
			// unamevm_stat̏o͂͂$cpu.clockcycleȊO͕邪A񂵁B
			return "";
		}
		else if (name.equals("$daysfromlastupdate"))
		{
			return Integer.toString(
				(int)((System.currentTimeMillis() - last_update_time) / 1000.0 / 60.0 / 60.0 / 24.0));
		}
		else if (name.equals("$daysfromfirstboot"))
		{
			return Integer.toString(
				(int)((System.currentTimeMillis() - first_boot_time) / 1000.0 / 60.0 / 60.0 / 24.0));
		}
		return null;
	}
}
