/*  $Id: SystemVariables.java,v 1.3 2004/02/11 12:22:14 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;
import java.util.*;

/*
    ݎԁA݌vԓ̃VXeϐێNXłB
    t@CɕۑʏϐlĂꍇ̂ŁA
    u͕KʏϐOɍsĉB
*/

public class SystemVariables extends Hashtable {
    Satori satori;
    long timeAtBoot,elapsedAtBoot;
    
    public SystemVariables(Satori satori) {
	super();
	this.satori = satori;
	
	// N̎
	timeAtBoot = System.currentTimeMillis();
	
	// ݌vԂǂݍ
	String ruikeiji = satori.getVariable().get(Satori.ZENKAKU_RUIKEIJI);
	put(Satori.ZENKAKU_RUIKEIJI,ruikeiji == null ? "0" : ruikeiji);
	
	String ruikeifun = satori.getVariable().get(Satori.ZENKAKU_RUIKEIFUN);
	put(Satori.ZENKAKU_RUIKEIFUN,ruikeifun == null ? "0" : ruikeifun);
	
	String ruikeibyou = satori.getVariable().get(Satori.ZENKAKU_RUIKEIBYOU);
	put(Satori.ZENKAKU_RUIKEIBYOU,ruikeibyou == null ? "0" : ruikeibyou);
	
	// Nɂ݌vN(millis)
	try {
	    elapsedAtBoot =
		(ruikeiji == null ? 0 : Integer.parseInt(ruikeiji) * 60 * 60 * 1000) +
		(ruikeifun == null ? 0 : Integer.parseInt(ruikeifun) * 60 * 1000) +
		(ruikeibyou == null ? 0 : Integer.parseInt(ruikeibyou) * 1000);
	}
	catch (Exception e) {
	    elapsedAtBoot = 0;
	}
	
	update();
    }
    
    public void close() {
	// ݌vԂ
	satori.getVariable().put(Satori.ZENKAKU_RUIKEIJI,(String)get(Satori.ZENKAKU_RUIKEIJI));
	satori.getVariable().put(Satori.ZENKAKU_RUIKEIFUN,(String)get(Satori.ZENKAKU_RUIKEIFUN));
	satori.getVariable().put(Satori.ZENKAKU_RUIKEIBYOU,(String)get(Satori.ZENKAKU_RUIKEIBYOU));
	satori.getVariable().put(Satori.ZENKAKU_RUIKEI_KIDOUJI,(String)get(Satori.ZENKAKU_RUIKEI_KIDOUJI));
    }
    
    public String getStrValue(String key) {
	return (String)get(key);
    }
    
    public void put(String key,int value) {
	put(key,""+value);
    }
    
    public void update() {
	// m1buɌĂ΂ȂĂ邱Ƃ͂܂񂪁AmȒl擾邽߂ɂ͖bĂяoĉB
	try {
	    // other ghost name
	    Vector otherGhostNames = satori.getOtherGhostNames();
	    if (otherGhostNames.size() > 0) {
		put(Satori.ZENKAKU_GHOST_STANDS_BY_THIS,((String[])otherGhostNames.elementAt(0))[0]);
	    }
	    else {
		remove(Satori.ZENKAKU_GHOST_STANDS_BY_THIS);
	    }
	    
	    // time
	    Calendar cal = Calendar.getInstance();
	    cal.setFirstDayOfWeek(Calendar.SUNDAY);
	    
	    put(Satori.ZENKAKU_GENZAINEN,cal.get(Calendar.YEAR));
	    put(Satori.ZENKAKU_GENZAITSUKI,cal.get(Calendar.MONTH)+1);
	    put(Satori.ZENKAKU_GENZAINICHI,cal.get(Calendar.DAY_OF_MONTH));
	    put(Satori.ZENKAKU_GENZAIYOUBI,""+Satori.ZENKAKU_DAYOFWEEK[cal.get(Calendar.DAY_OF_WEEK)-1]);
	    put(Satori.ZENKAKU_GENZAIJI,cal.get(Calendar.HOUR_OF_DAY));
	    put(Satori.ZENKAKU_GENZAIFUN,cal.get(Calendar.MINUTE));
	    put(Satori.ZENKAKU_GENZAIBYOU,cal.get(Calendar.SECOND));
	    
	    long elapsedTimeFromThisBoot = System.currentTimeMillis() - timeAtBoot;
	    long elapsedTimeFromFirstBoot = elapsedTimeFromThisBoot + elapsedAtBoot;

	    put(Satori.ZENKAKU_RUIKEI_KIDOUJI,(int)(elapsedTimeFromFirstBoot));
	    
	    put(Satori.ZENKAKU_KIDOUJI,(int)(elapsedTimeFromThisBoot / (1000.0 * 60.0 * 60.0)));
	    put(Satori.ZENKAKU_KIDOUFUN,(int)(elapsedTimeFromThisBoot / (1000.0 * 60.0)) % 60);
	    put(Satori.ZENKAKU_KIDOUBYOU,(int)(elapsedTimeFromThisBoot / 1000.0) % 60);
	    put(Satori.ZENKAKU_SIMPLE+Satori.ZENKAKU_KIDOUFUN,(int)(elapsedTimeFromThisBoot / (1000.0 * 60.0)));
	    put(Satori.ZENKAKU_SIMPLE+Satori.ZENKAKU_KIDOUBYOU,(int)(elapsedTimeFromThisBoot / 1000.0));
	    
	    put(Satori.ZENKAKU_RUIKEIJI,(int)(elapsedTimeFromFirstBoot / (1000.0 * 60.0 * 60.0)));
	    put(Satori.ZENKAKU_RUIKEIFUN,(int)(elapsedTimeFromFirstBoot / (1000.0 * 60.0)) % 60);
	    put(Satori.ZENKAKU_RUIKEIBYOU,(int)(elapsedTimeFromFirstBoot / 1000.0) % 60);
	    put(Satori.ZENKAKU_SIMPLE+Satori.ZENKAKU_RUIKEIFUN,(int)(elapsedTimeFromFirstBoot / (1000.0 * 60.0)));
	    put(Satori.ZENKAKU_SIMPLE+Satori.ZENKAKU_RUIKEIFUN,(int)(elapsedTimeFromFirstBoot / 1000.0));
	}
	catch (Exception e) {}
    }
}
