/*  $Id: SSU.java,v 1.2 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori.saori;
import satori.*;
import satori.saori.*;
import java.util.*;
import java.lang.reflect.*;

public class SSU extends SaoriModule {
    public SaoriResponce call(Vector args) {
	String function = (String)args.elementAt(0);
	
	try{
	    // ̃NXpublic SaoriResponce func_${funcname}(Vector args)ĂԁB
	    Method func = this.getClass().getMethod("func_"+function,new Class[] {Vector.class});
	    return (SaoriResponce)func.invoke(this,new Object[] {args});
	}
	catch (NoSuchMethodException e) {
	    System.err.println("satori.saori.SSU doesn't support "+function+" yet.");
	}
	catch (Exception e) {
	    System.err.println("Exception occured in calling SSU function "+function);
	    e.printStackTrace();
	}
	
	return SaoriResponce.EMPTY;
    }
    
    public SaoriResponce func_if(Vector args) {
	// if,^U,^[,U]
	String cond = (String)args.elementAt(1);
	String result_if_true = (String)args.elementAt(2);
	String result_if_false = (args.size() >= 4 ? (String)args.elementAt(3) : "");
	
	if (Evaluator.evalCondition(cond).equals("0")) {
	    return new SaoriResponce(result_if_false);
	}
	else {
	    return new SaoriResponce(result_if_true);
	}
    }
    
    public SaoriResponce func_unless(Vector args) {
	// unless,^U,U[,^]
	String cond = (String)args.elementAt(1);
	String result_if_false = (String)args.elementAt(2);
	String result_if_true = (args.size() >= 4 ? (String)args.elementAt(3) : "");
	
	if (Evaluator.evalCondition(cond).equals("0")) {
	    return new SaoriResponce(result_if_false);
	}
	else {
	    return new SaoriResponce(result_if_true);
	}
    }
    
    public SaoriResponce func_switch(Vector args) {
	// switch,,E1,1,E2,2,...
	// ӂevalCondition()B
	String cond = (String)args.elementAt(1);
	String key = Evaluator.evalCondition(cond);
	
	final int argc = args.size();
	for (int i = 2;i < argc;i += 2) {
	    String label = (String)args.elementAt(i);
	    String value = (String)args.elementAt(i+1);
	    
	    if (key.equals(label)) {
		return new SaoriResponce(value);
	    }
	}
	return SaoriResponce.EMPTY;
    }
    
    public SaoriResponce func_nswitch(Vector args) throws Exception {
	// nswitch,l,1,2,...
	// 0IWȂ̂1IWȂ̂Ȃ̂ŕ܂ł0IWŎB
	try {
	    int n = Integer.parseInt(
		ZenHanTranslator.convZenToHan(
		    (String)args.elementAt(1)));
	    return new SaoriResponce((String)args.elementAt(2 + n));
	}
	catch(Exception e) {
	    throw e;
	}
    }
    
    public SaoriResponce func_substr(Vector args) throws Exception {
	// substr,,ʒu,
	try {
	    String world = (String)args.elementAt(1);
	    int pos = Integer.parseInt((String)args.elementAt(2));
	    int len = Integer.parseInt((String)args.elementAt(3));
	    
	    return new SaoriResponce(((String)world).substring(pos,pos+len));
	}
	catch (Exception e) {
	    throw e;
	}
    }
    
    public SaoriResponce func_split(Vector args) throws Exception {
	// split,[,[,ő啪]] iԒl͌AԒlɕʂi[j
	try {
	    String world = (String)args.elementAt(1);
	    String delimitor = (args.size() >= 3 ? (String)args.elementAt(2) : " ");
	    int max_tokens = (args.size() >= 4 ? Integer.parseInt(
				  ZenHanTranslator.convZenToHan(
				      (String)args.elementAt(3))) : -1); // -1Ȃ疳
	    
	    Vector result = new Vector();
	    FunctionArgumentTokenizer fat = new FunctionArgumentTokenizer(world,delimitor);
	    while (fat.hasMoreTokens()) {
		if (max_tokens != -1 && result.size() >= max_tokens) break; // őł؂
		
		result.add(fat.nextToken());
	    }
	    
	    return new SaoriResponce(Integer.toString(result.size()),result);
	}
	catch (Exception e) {
	    throw e;
	}
    }
    
    public SaoriResponce func_replace(Vector args) {
	// replace,,O,
	// SĒuB
	StringBuffer result = new StringBuffer((String)args.elementAt(1));
	String from = (String)args.elementAt(2);
	String to = (String)args.elementAt(3);
	while (true) {
	    int pos = result.toString().indexOf(from);
	    if (pos == -1) break; // 
	    
	    result.replace(pos,pos+from.length(),to);
	}
	return new SaoriResponce(result.toString());
    }
    
    public SaoriResponce func_replace_first(Vector args) {
	// replace_first,,O,
	// ŏɌ̂ݒuB
	StringBuffer result = new StringBuffer((String)args.elementAt(1));
	String from = (String)args.elementAt(2);
	String to = (String)args.elementAt(3);
	
	int pos = result.toString().indexOf(from);
	if (pos != -1) {
	    result.replace(pos,pos+from.length(),to);
	}
	
	return new SaoriResponce(result.toString());
    }
    
    public SaoriResponce func_erase(Vector args) {
	// erase,,Ώ
	// Sč폜B
	StringBuffer result = new StringBuffer((String)args.elementAt(1));
	String word_to_erase = (String)args.elementAt(2);
	
	while (true) {
	    int pos = result.toString().indexOf(word_to_erase);
	    if (pos == -1) break; // 
	    
	    result.delete(pos,pos+word_to_erase.length());
	}
	
	return new SaoriResponce(result.toString());
    }
    
    public SaoriResponce func_erase_first(Vector args) {
	// erase_first,,Ώ
	// ŏɌ̂ݒuB
	StringBuffer result = new StringBuffer((String)args.elementAt(1));
	String word_to_erase = (String)args.elementAt(2);
	
	int pos = result.toString().indexOf(word_to_erase);
	if (pos != -1) {
	    result.delete(pos,pos+word_to_erase.length());
	}
	
	return new SaoriResponce(result.toString());
    }
    
    public SaoriResponce func_count(Vector args) {
	// count,,Ώ
	String world = (String)args.elementAt(1);
	String word_to_find = (String)args.elementAt(2);
	
	int result = 0;
	final int len = world.length();
	for (int pos = 0;pos < len;) {
	    if (world.startsWith(word_to_find,pos)) {
		result++;
		pos += word_to_find.length();
	    }
	    else {
		pos++;
	    }
	}
	
	return new SaoriResponce(Integer.toString(result));
    }
    
    public SaoriResponce func_compare(Vector args) {
	// compare,1,2
	// Q̕񂪓1,Ȃ0Ԃ
	String str_1 = (String)args.elementAt(1);
	String str_2 = (String)args.elementAt(2);
	
	return new SaoriResponce(str_1.equals(str_2) ? "1" : "0");
    }
    
    public SaoriResponce func_compare_head(Vector args) {
	// compare_head,, 
	// ̐擪ł1,Ȃ0Ԃ
	String world = (String)args.elementAt(1);
	String head = (String)args.elementAt(2);
	
	return new SaoriResponce(world.startsWith(head) ? "1" : "0");
    }
    
    public SaoriResponce func_compare_tail(Vector args) {
	// compare_tail,,
	// ̖ł1,Ȃ0Ԃ
	String world = (String)args.elementAt(1);
	String tail = (String)args.elementAt(2);
	
	return new SaoriResponce(world.endsWith(tail) ? "1" : "0");
    }
    
    public SaoriResponce func_length(Vector args) {
	// length,
	String str = (String)args.elementAt(1);
	return new SaoriResponce(Integer.toString(str.length()));
    }
    
    public SaoriResponce func_calc(Vector args) {
	// calc,vZ
	// vZvZČʂԂBifswitcḧ́AÖق̂ɂsĂ܂B
	String cond = (String)args.elementAt(1);
	return new SaoriResponce(Evaluator.evalCondition(cond));
    }
    
    public SaoriResponce func_iflist(Vector args) {
	// iflist,,Zq1+E1,1,Zq2+E2,2,...
	// u Zqn Env^ɂȂ_ŕnԂB
	String left = (String)args.elementAt(1);
	
	final int argc = args.size();
	for (int i = 2;i < argc;i += 2) {
	    String ope_and_right = (String)args.elementAt(i);
	    String str_to_return = (String)args.elementAt(i+1);
	    
	    if (!Evaluator.evalCondition(left + ope_and_right).equals("0")) { // ^ɂȂ
		return new SaoriResponce(str_to_return);
	    }
	}
	return SaoriResponce.EMPTY;
    }
}
