/*  $Id: SaoriManager.java,v 1.3 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori.saori;
import satori.*;
import satori.saori.*;
import java.util.*;

public class SaoriManager {
    Satori satori;
    Hashtable name_to_call_and_calling_info = null; // <String,CallingInfo> saoriďo[if],saoriR[
    Hashtable module_name_and_module = null; // <String,SaoriModule> W[[ssu.dll],W[
    
    public SaoriManager(Satori satori) {
	this.satori = satori;
    }
    
    public String call(String saori_name_to_call,Vector args) {
	// saori_name_to_call : saoriďo
	// args : B΋Vector
	// YSaorinullԂB
	if (name_to_call_and_calling_info == null) {
	    name_to_call_and_calling_info = new Hashtable();
	    
	    // SAORIǂŃp[XB
	    LinedDataBlock saori_definitions = satori.getDictionary().getWordList("SAORI");
	    if (saori_definitions == null) return "";
	    
	    for (Enumeration lines = saori_definitions.elements();lines.hasMoreElements();) {
		String line = (String)lines.nextElement();
		
		StringTokenizer tokens = new StringTokenizer(line,",");
		String name_to_call = tokens.nextToken();
		String module_name = tokens.nextToken();
		
		// W[̓XbVȍ~̂ݎgpB
		// windowspȂ̂ɃfBNgXbVŋ؂Ă񂾂낤c
		int last_slash = module_name.lastIndexOf('/');
		if (last_slash != -1) {
		    module_name = module_name.substring(last_slash+1);
		}
		
		// c͎ݒ肳B
		Vector prefix_parameters = new Vector();
		while (tokens.hasMoreTokens()) {
		    prefix_parameters.add(tokens.nextToken());
		}
		
		name_to_call_and_calling_info.put(name_to_call,new CallingInfo(module_name,prefix_parameters));
	    }
	}
	
	CallingInfo calling_info = (CallingInfo)name_to_call_and_calling_info.get(saori_name_to_call);
	if (calling_info == null) return null; // Saori͖B
	
	Vector clone_of_prefix = (Vector)calling_info.getPrefixParameters().clone();
	clone_of_prefix.addAll(args); // prefix擪ɁAargsɓB
	
	SaoriResponce saori_responce = calling_info.getModule().call(clone_of_prefix);
	// SAORI̕ԒĺirOjAirPjAirQjccɊi[B
	Vector sub_responces = saori_responce.getSubResults();
	final int n_sub_responces = sub_responces.size();
	for (int i = 0;i < n_sub_responces;i++) {
	    String sub_responce = (String)sub_responces.elementAt(i);
	    satori.getVariable().put("S"+i,sub_responce);
	}
	return saori_responce.getMainResult();
    }
    
    protected SaoriModule findModule(String module_name) {
	// KvȃW[TĕԂB
	// ܂ĂȂ΍B
	// tȂnullԂB
	if (module_name_and_module == null) {
	    module_name_and_module = new Hashtable();
	    module_name_and_module.put("ssu.dll", new SSU());
	}
	
	return (SaoriModule)module_name_and_module.get(module_name);
    }
    
    protected class CallingInfo {
	SaoriModule module;
	Vector prefix_parameters;
	
	public CallingInfo(String module_name,Vector prefix_parameters) {
	    // module_name : [fill_desktop.dll]
	    // prefix_parameters : [255,0,0]
	    module = findModule(module_name);
	    this.prefix_parameters = prefix_parameters;
	}
	
	public SaoriModule getModule() {
	    return module;
	}
	
	public Vector getPrefixParameters() {
	    return prefix_parameters;
	}
    }
}
